

------------------
Build instructions
------------------

Linux platform

```
cd $PROJECT_ROOT
autoconf
./configure --prefix=$HOME/usr --enable-assert --enable-go --with-goroot=$GOROOT
make clean
make
make install
```

-----
Help!
-----

If you have trouble using Vank, check online at dms3.io/is/vank for updated
documentation.

--------------
What is Vank?
--------------

Vank is an information retrieval system forked from the Lemur/Indri project; a
joint effort between the University of Massachusetts and Carnegie Mellon
University.  It combines the language modeling and inference network
approaches to information retrieval into one system.

For those who have used the Inquery system, Vank uses a query language
that is very similar, but adds additional features.  In particular,
Vank understands tagged documents, like HTML and XML documents, and can
therefore understand queries like #1(george bush).person (which means
find the phrase george bush appearing inside a person tag).  Vank can
also understand numeric quantities.  You can find out more about the
query language in the query language documentation.

Library:

Vank provides the QueryEnvironment and IndexEnvironment classes, which
can be used from C++, Java, C# or PHP (although indexing is not
supported from PHP).

IndexEnvironment understands many different file types.  However, you
can create your own file type, as long as it is XML-like, and tell
IndexEnvironment how to index it.  Then, using the addFile method,
IndexEnvironment can index your document(s).  If you want to do more
complex processing on your data, or if your data is arriving in real
time, you may parse your document into a ParsedDocument structure.  The
IndexEnvrionment object can index these structures directly.

QueryEnvironment allows you to run queries and retrieve a ranked list of
results.  You can use runAnnotatedQuery to retrieve match information
(annotations), which is useful for highlighting matched words in
documents.  By using the addIndex method with an instance of
IndexEnvironment, you can evaluate queries on an index that is currently
being built.  The addServer method allows you to connect to VankDaemon
processes for distributed retrieval.
