//========================================================================
//
// NameToUnicodeTable.h
//
// Copyright 2001-2004 Glyph & Cog, LLC
//
//========================================================================

static struct {
  Unicode u;
  char *name;
} nameToUnicodeTab[] = {
  {0x0021, (char*)"!"},
  {0x0023, (char*)"#"},
  {0x0024, (char*)"$"},
  {0x0025, (char*)"%"},
  {0x0026, (char*)"&"},
  {0x0027, (char*)"'"},
  {0x0028, (char*)"("},
  {0x0029, (char*)")"},
  {0x002a, (char*)"*"},
  {0x002b, (char*)"+"},
  {0x002c, (char*)","},
  {0x002d, (char*)"-"},
  {0x002e, (char*)"."},
  {0x002f, (char*)"/"},
  {0x0030, (char*)"0"},
  {0x0031, (char*)"1"},
  {0x0032, (char*)"2"},
  {0x0033, (char*)"3"},
  {0x0034, (char*)"4"},
  {0x0035, (char*)"5"},
  {0x0036, (char*)"6"},
  {0x0037, (char*)"7"},
  {0x0038, (char*)"8"},
  {0x0039, (char*)"9"},
  {0x003a, (char*)":"},
  {0x003b, (char*)";"},
  {0x003c, (char*)"<"},
  {0x003d, (char*)"="},
  {0x003e, (char*)">"},
  {0x003f, (char*)"?"},
  {0x0040, (char*)"@"},
  {0x0041, (char*)"A"},
  {0x00c6, (char*)"AE"},
  {0x01fc, (char*)"AEacute"},
  {0xf7e6, (char*)"AEsmall"},
  {0x00c1, (char*)"Aacute"},
  {0xf7e1, (char*)"Aacutesmall"},
  {0x0102, (char*)"Abreve"},
  {0x00c2, (char*)"Acircumflex"},
  {0xf7e2, (char*)"Acircumflexsmall"},
  {0xf6c9, (char*)"Acute"},
  {0xf7b4, (char*)"Acutesmall"},
  {0x00c4, (char*)"Adieresis"},
  {0xf7e4, (char*)"Adieresissmall"},
  {0x00c0, (char*)"Agrave"},
  {0xf7e0, (char*)"Agravesmall"},
  {0x0391, (char*)"Alpha"},
  {0x0386, (char*)"Alphatonos"},
  {0x0100, (char*)"Amacron"},
  {0x0104, (char*)"Aogonek"},
  {0x00c5, (char*)"Aring"},
  {0x01fa, (char*)"Aringacute"},
  {0xf7e5, (char*)"Aringsmall"},
  {0xf761, (char*)"Asmall"},
  {0x00c3, (char*)"Atilde"},
  {0xf7e3, (char*)"Atildesmall"},
  {0x0042, (char*)"B"},
  {0x0392, (char*)"Beta"},
  {0xf6f4, (char*)"Brevesmall"},
  {0xf762, (char*)"Bsmall"},
  {0x0043, (char*)"C"},
  {0x0106, (char*)"Cacute"},
  {0xf6ca, (char*)"Caron"},
  {0xf6f5, (char*)"Caronsmall"},
  {0x010c, (char*)"Ccaron"},
  {0x00c7, (char*)"Ccedilla"},
  {0xf7e7, (char*)"Ccedillasmall"},
  {0x0108, (char*)"Ccircumflex"},
  {0x010a, (char*)"Cdotaccent"},
  {0xf7b8, (char*)"Cedillasmall"},
  {0x03a7, (char*)"Chi"},
  {0xf6f6, (char*)"Circumflexsmall"},
  {0xf763, (char*)"Csmall"},
  {0x0044, (char*)"D"},
  {0x010e, (char*)"Dcaron"},
  {0x0110, (char*)"Dcroat"},
  {0x2206, (char*)"Delta"},
  {0xf6cb, (char*)"Dieresis"},
  {0xf6cc, (char*)"DieresisAcute"},
  {0xf6cd, (char*)"DieresisGrave"},
  {0xf7a8, (char*)"Dieresissmall"},
  {0xf6f7, (char*)"Dotaccentsmall"},
  {0xf764, (char*)"Dsmall"},
  {0x0045, (char*)"E"},
  {0x00c9, (char*)"Eacute"},
  {0xf7e9, (char*)"Eacutesmall"},
  {0x0114, (char*)"Ebreve"},
  {0x011a, (char*)"Ecaron"},
  {0x00ca, (char*)"Ecircumflex"},
  {0xf7ea, (char*)"Ecircumflexsmall"},
  {0x00cb, (char*)"Edieresis"},
  {0xf7eb, (char*)"Edieresissmall"},
  {0x0116, (char*)"Edotaccent"},
  {0x00c8, (char*)"Egrave"},
  {0xf7e8, (char*)"Egravesmall"},
  {0x0112, (char*)"Emacron"},
  {0x014a, (char*)"Eng"},
  {0x0118, (char*)"Eogonek"},
  {0x0395, (char*)"Epsilon"},
  {0x0388, (char*)"Epsilontonos"},
  {0xf765, (char*)"Esmall"},
  {0x0397, (char*)"Eta"},
  {0x0389, (char*)"Etatonos"},
  {0x00d0, (char*)"Eth"},
  {0xf7f0, (char*)"Ethsmall"},
  {0x20ac, (char*)"Euro"},
  {0x0046, (char*)"F"},
  {0xf766, (char*)"Fsmall"},
  {0x0047, (char*)"G"},
  {0x0393, (char*)"Gamma"},
  {0x011e, (char*)"Gbreve"},
  {0x01e6, (char*)"Gcaron"},
  {0x011c, (char*)"Gcircumflex"},
  {0x0122, (char*)"Gcommaaccent"},
  {0x0120, (char*)"Gdotaccent"},
  {0xf6ce, (char*)"Grave"},
  {0xf760, (char*)"Gravesmall"},
  {0xf767, (char*)"Gsmall"},
  {0x0048, (char*)"H"},
  {0x25cf, (char*)"H18533"},
  {0x25aa, (char*)"H18543"},
  {0x25ab, (char*)"H18551"},
  {0x25a1, (char*)"H22073"},
  {0x0126, (char*)"Hbar"},
  {0x0124, (char*)"Hcircumflex"},
  {0xf768, (char*)"Hsmall"},
  {0xf6cf, (char*)"Hungarumlaut"},
  {0xf6f8, (char*)"Hungarumlautsmall"},
  {0x0049, (char*)"I"},
  {0x0132, (char*)"IJ"},
  {0x00cd, (char*)"Iacute"},
  {0xf7ed, (char*)"Iacutesmall"},
  {0x012c, (char*)"Ibreve"},
  {0x00ce, (char*)"Icircumflex"},
  {0xf7ee, (char*)"Icircumflexsmall"},
  {0x00cf, (char*)"Idieresis"},
  {0xf7ef, (char*)"Idieresissmall"},
  {0x0130, (char*)"Idotaccent"},
  {0x2111, (char*)"Ifraktur"},
  {0x00cc, (char*)"Igrave"},
  {0xf7ec, (char*)"Igravesmall"},
  {0x012a, (char*)"Imacron"},
  {0x012e, (char*)"Iogonek"},
  {0x0399, (char*)"Iota"},
  {0x03aa, (char*)"Iotadieresis"},
  {0x038a, (char*)"Iotatonos"},
  {0xf769, (char*)"Ismall"},
  {0x0128, (char*)"Itilde"},
  {0x004a, (char*)"J"},
  {0x0134, (char*)"Jcircumflex"},
  {0xf76a, (char*)"Jsmall"},
  {0x004b, (char*)"K"},
  {0x039a, (char*)"Kappa"},
  {0x0136, (char*)"Kcommaaccent"},
  {0xf76b, (char*)"Ksmall"},
  {0x004c, (char*)"L"},
  {0xf6bf, (char*)"LL"},
  {0x0139, (char*)"Lacute"},
  {0x039b, (char*)"Lambda"},
  {0x013d, (char*)"Lcaron"},
  {0x013b, (char*)"Lcommaaccent"},
  {0x013f, (char*)"Ldot"},
  {0x0141, (char*)"Lslash"},
  {0xf6f9, (char*)"Lslashsmall"},
  {0xf76c, (char*)"Lsmall"},
  {0x004d, (char*)"M"},
  {0xf6d0, (char*)"Macron"},
  {0xf7af, (char*)"Macronsmall"},
  {0xf76d, (char*)"Msmall"},
  {0x039c, (char*)"Mu"},
  {0x004e, (char*)"N"},
  {0x0143, (char*)"Nacute"},
  {0x0147, (char*)"Ncaron"},
  {0x0145, (char*)"Ncommaaccent"},
  {0xf76e, (char*)"Nsmall"},
  {0x00d1, (char*)"Ntilde"},
  {0xf7f1, (char*)"Ntildesmall"},
  {0x039d, (char*)"Nu"},
  {0x004f, (char*)"O"},
  {0x0152, (char*)"OE"},
  {0xf6fa, (char*)"OEsmall"},
  {0x00d3, (char*)"Oacute"},
  {0xf7f3, (char*)"Oacutesmall"},
  {0x014e, (char*)"Obreve"},
  {0x00d4, (char*)"Ocircumflex"},
  {0xf7f4, (char*)"Ocircumflexsmall"},
  {0x00d6, (char*)"Odieresis"},
  {0xf7f6, (char*)"Odieresissmall"},
  {0xf6fb, (char*)"Ogoneksmall"},
  {0x00d2, (char*)"Ograve"},
  {0xf7f2, (char*)"Ogravesmall"},
  {0x01a0, (char*)"Ohorn"},
  {0x0150, (char*)"Ohungarumlaut"},
  {0x014c, (char*)"Omacron"},
  {0x2126, (char*)"Omega"},
  {0x038f, (char*)"Omegatonos"},
  {0x039f, (char*)"Omicron"},
  {0x038c, (char*)"Omicrontonos"},
  {0x00d8, (char*)"Oslash"},
  {0x01fe, (char*)"Oslashacute"},
  {0xf7f8, (char*)"Oslashsmall"},
  {0xf76f, (char*)"Osmall"},
  {0x00d5, (char*)"Otilde"},
  {0xf7f5, (char*)"Otildesmall"},
  {0x0050, (char*)"P"},
  {0x03a6, (char*)"Phi"},
  {0x03a0, (char*)"Pi"},
  {0x03a8, (char*)"Psi"},
  {0xf770, (char*)"Psmall"},
  {0x0051, (char*)"Q"},
  {0xf771, (char*)"Qsmall"},
  {0x0052, (char*)"R"},
  {0x0154, (char*)"Racute"},
  {0x0158, (char*)"Rcaron"},
  {0x0156, (char*)"Rcommaaccent"},
  {0x211c, (char*)"Rfraktur"},
  {0x03a1, (char*)"Rho"},
  {0xf6fc, (char*)"Ringsmall"},
  {0xf772, (char*)"Rsmall"},
  {0x0053, (char*)"S"},
  {0x250c, (char*)"SF010000"},
  {0x2514, (char*)"SF020000"},
  {0x2510, (char*)"SF030000"},
  {0x2518, (char*)"SF040000"},
  {0x253c, (char*)"SF050000"},
  {0x252c, (char*)"SF060000"},
  {0x2534, (char*)"SF070000"},
  {0x251c, (char*)"SF080000"},
  {0x2524, (char*)"SF090000"},
  {0x2500, (char*)"SF100000"},
  {0x2502, (char*)"SF110000"},
  {0x2561, (char*)"SF190000"},
  {0x2562, (char*)"SF200000"},
  {0x2556, (char*)"SF210000"},
  {0x2555, (char*)"SF220000"},
  {0x2563, (char*)"SF230000"},
  {0x2551, (char*)"SF240000"},
  {0x2557, (char*)"SF250000"},
  {0x255d, (char*)"SF260000"},
  {0x255c, (char*)"SF270000"},
  {0x255b, (char*)"SF280000"},
  {0x255e, (char*)"SF360000"},
  {0x255f, (char*)"SF370000"},
  {0x255a, (char*)"SF380000"},
  {0x2554, (char*)"SF390000"},
  {0x2569, (char*)"SF400000"},
  {0x2566, (char*)"SF410000"},
  {0x2560, (char*)"SF420000"},
  {0x2550, (char*)"SF430000"},
  {0x256c, (char*)"SF440000"},
  {0x2567, (char*)"SF450000"},
  {0x2568, (char*)"SF460000"},
  {0x2564, (char*)"SF470000"},
  {0x2565, (char*)"SF480000"},
  {0x2559, (char*)"SF490000"},
  {0x2558, (char*)"SF500000"},
  {0x2552, (char*)"SF510000"},
  {0x2553, (char*)"SF520000"},
  {0x256b, (char*)"SF530000"},
  {0x256a, (char*)"SF540000"},
  {0x015a, (char*)"Sacute"},
  {0x0160, (char*)"Scaron"},
  {0xf6fd, (char*)"Scaronsmall"},
  {0x015e, (char*)"Scedilla"},
  {0x015c, (char*)"Scircumflex"},
  {0x0218, (char*)"Scommaaccent"},
  {0x03a3, (char*)"Sigma"},
  {0xf773, (char*)"Ssmall"},
  {0x0054, (char*)"T"},
  {0x03a4, (char*)"Tau"},
  {0x0166, (char*)"Tbar"},
  {0x0164, (char*)"Tcaron"},
  {0x0162, (char*)"Tcommaaccent"},
  {0x0398, (char*)"Theta"},
  {0x00de, (char*)"Thorn"},
  {0xf7fe, (char*)"Thornsmall"},
  {0xf6fe, (char*)"Tildesmall"},
  {0xf774, (char*)"Tsmall"},
  {0x0055, (char*)"U"},
  {0x00da, (char*)"Uacute"},
  {0xf7fa, (char*)"Uacutesmall"},
  {0x016c, (char*)"Ubreve"},
  {0x00db, (char*)"Ucircumflex"},
  {0xf7fb, (char*)"Ucircumflexsmall"},
  {0x00dc, (char*)"Udieresis"},
  {0xf7fc, (char*)"Udieresissmall"},
  {0x00d9, (char*)"Ugrave"},
  {0xf7f9, (char*)"Ugravesmall"},
  {0x01af, (char*)"Uhorn"},
  {0x0170, (char*)"Uhungarumlaut"},
  {0x016a, (char*)"Umacron"},
  {0x0172, (char*)"Uogonek"},
  {0x03a5, (char*)"Upsilon"},
  {0x03d2, (char*)"Upsilon1"},
  {0x03ab, (char*)"Upsilondieresis"},
  {0x038e, (char*)"Upsilontonos"},
  {0x016e, (char*)"Uring"},
  {0xf775, (char*)"Usmall"},
  {0x0168, (char*)"Utilde"},
  {0x0056, (char*)"V"},
  {0xf776, (char*)"Vsmall"},
  {0x0057, (char*)"W"},
  {0x1e82, (char*)"Wacute"},
  {0x0174, (char*)"Wcircumflex"},
  {0x1e84, (char*)"Wdieresis"},
  {0x1e80, (char*)"Wgrave"},
  {0xf777, (char*)"Wsmall"},
  {0x0058, (char*)"X"},
  {0x039e, (char*)"Xi"},
  {0xf778, (char*)"Xsmall"},
  {0x0059, (char*)"Y"},
  {0x00dd, (char*)"Yacute"},
  {0xf7fd, (char*)"Yacutesmall"},
  {0x0176, (char*)"Ycircumflex"},
  {0x0178, (char*)"Ydieresis"},
  {0xf7ff, (char*)"Ydieresissmall"},
  {0x1ef2, (char*)"Ygrave"},
  {0xf779, (char*)"Ysmall"},
  {0x005a, (char*)"Z"},
  {0x0179, (char*)"Zacute"},
  {0x017d, (char*)"Zcaron"},
  {0xf6ff, (char*)"Zcaronsmall"},
  {0x017b, (char*)"Zdotaccent"},
  {0x0396, (char*)"Zeta"},
  {0xf77a, (char*)"Zsmall"},
  {0x0022, (char*)"\""},
  {0x005c, (char*)"\\"},
  {0x005d, (char*)"]"},
  {0x005e, (char*)"^"},
  {0x005f, (char*)"_"},
  {0x0060, (char*)"`"},
  {0x0061, (char*)"a"},
  {0x00e1, (char*)"aacute"},
  {0x0103, (char*)"abreve"},
  {0x00e2, (char*)"acircumflex"},
  {0x00b4, (char*)"acute"},
  {0x0301, (char*)"acutecomb"},
  {0x00e4, (char*)"adieresis"},
  {0x00e6, (char*)"ae"},
  {0x01fd, (char*)"aeacute"},
  {0x2015, (char*)"afii00208"},
  {0x0410, (char*)"afii10017"},
  {0x0411, (char*)"afii10018"},
  {0x0412, (char*)"afii10019"},
  {0x0413, (char*)"afii10020"},
  {0x0414, (char*)"afii10021"},
  {0x0415, (char*)"afii10022"},
  {0x0401, (char*)"afii10023"},
  {0x0416, (char*)"afii10024"},
  {0x0417, (char*)"afii10025"},
  {0x0418, (char*)"afii10026"},
  {0x0419, (char*)"afii10027"},
  {0x041a, (char*)"afii10028"},
  {0x041b, (char*)"afii10029"},
  {0x041c, (char*)"afii10030"},
  {0x041d, (char*)"afii10031"},
  {0x041e, (char*)"afii10032"},
  {0x041f, (char*)"afii10033"},
  {0x0420, (char*)"afii10034"},
  {0x0421, (char*)"afii10035"},
  {0x0422, (char*)"afii10036"},
  {0x0423, (char*)"afii10037"},
  {0x0424, (char*)"afii10038"},
  {0x0425, (char*)"afii10039"},
  {0x0426, (char*)"afii10040"},
  {0x0427, (char*)"afii10041"},
  {0x0428, (char*)"afii10042"},
  {0x0429, (char*)"afii10043"},
  {0x042a, (char*)"afii10044"},
  {0x042b, (char*)"afii10045"},
  {0x042c, (char*)"afii10046"},
  {0x042d, (char*)"afii10047"},
  {0x042e, (char*)"afii10048"},
  {0x042f, (char*)"afii10049"},
  {0x0490, (char*)"afii10050"},
  {0x0402, (char*)"afii10051"},
  {0x0403, (char*)"afii10052"},
  {0x0404, (char*)"afii10053"},
  {0x0405, (char*)"afii10054"},
  {0x0406, (char*)"afii10055"},
  {0x0407, (char*)"afii10056"},
  {0x0408, (char*)"afii10057"},
  {0x0409, (char*)"afii10058"},
  {0x040a, (char*)"afii10059"},
  {0x040b, (char*)"afii10060"},
  {0x040c, (char*)"afii10061"},
  {0x040e, (char*)"afii10062"},
  {0xf6c4, (char*)"afii10063"},
  {0xf6c5, (char*)"afii10064"},
  {0x0430, (char*)"afii10065"},
  {0x0431, (char*)"afii10066"},
  {0x0432, (char*)"afii10067"},
  {0x0433, (char*)"afii10068"},
  {0x0434, (char*)"afii10069"},
  {0x0435, (char*)"afii10070"},
  {0x0451, (char*)"afii10071"},
  {0x0436, (char*)"afii10072"},
  {0x0437, (char*)"afii10073"},
  {0x0438, (char*)"afii10074"},
  {0x0439, (char*)"afii10075"},
  {0x043a, (char*)"afii10076"},
  {0x043b, (char*)"afii10077"},
  {0x043c, (char*)"afii10078"},
  {0x043d, (char*)"afii10079"},
  {0x043e, (char*)"afii10080"},
  {0x043f, (char*)"afii10081"},
  {0x0440, (char*)"afii10082"},
  {0x0441, (char*)"afii10083"},
  {0x0442, (char*)"afii10084"},
  {0x0443, (char*)"afii10085"},
  {0x0444, (char*)"afii10086"},
  {0x0445, (char*)"afii10087"},
  {0x0446, (char*)"afii10088"},
  {0x0447, (char*)"afii10089"},
  {0x0448, (char*)"afii10090"},
  {0x0449, (char*)"afii10091"},
  {0x044a, (char*)"afii10092"},
  {0x044b, (char*)"afii10093"},
  {0x044c, (char*)"afii10094"},
  {0x044d, (char*)"afii10095"},
  {0x044e, (char*)"afii10096"},
  {0x044f, (char*)"afii10097"},
  {0x0491, (char*)"afii10098"},
  {0x0452, (char*)"afii10099"},
  {0x0453, (char*)"afii10100"},
  {0x0454, (char*)"afii10101"},
  {0x0455, (char*)"afii10102"},
  {0x0456, (char*)"afii10103"},
  {0x0457, (char*)"afii10104"},
  {0x0458, (char*)"afii10105"},
  {0x0459, (char*)"afii10106"},
  {0x045a, (char*)"afii10107"},
  {0x045b, (char*)"afii10108"},
  {0x045c, (char*)"afii10109"},
  {0x045e, (char*)"afii10110"},
  {0x040f, (char*)"afii10145"},
  {0x0462, (char*)"afii10146"},
  {0x0472, (char*)"afii10147"},
  {0x0474, (char*)"afii10148"},
  {0xf6c6, (char*)"afii10192"},
  {0x045f, (char*)"afii10193"},
  {0x0463, (char*)"afii10194"},
  {0x0473, (char*)"afii10195"},
  {0x0475, (char*)"afii10196"},
  {0xf6c7, (char*)"afii10831"},
  {0xf6c8, (char*)"afii10832"},
  {0x04d9, (char*)"afii10846"},
  {0x200e, (char*)"afii299"},
  {0x200f, (char*)"afii300"},
  {0x200d, (char*)"afii301"},
  {0x066a, (char*)"afii57381"},
  {0x060c, (char*)"afii57388"},
  {0x0660, (char*)"afii57392"},
  {0x0661, (char*)"afii57393"},
  {0x0662, (char*)"afii57394"},
  {0x0663, (char*)"afii57395"},
  {0x0664, (char*)"afii57396"},
  {0x0665, (char*)"afii57397"},
  {0x0666, (char*)"afii57398"},
  {0x0667, (char*)"afii57399"},
  {0x0668, (char*)"afii57400"},
  {0x0669, (char*)"afii57401"},
  {0x061b, (char*)"afii57403"},
  {0x061f, (char*)"afii57407"},
  {0x0621, (char*)"afii57409"},
  {0x0622, (char*)"afii57410"},
  {0x0623, (char*)"afii57411"},
  {0x0624, (char*)"afii57412"},
  {0x0625, (char*)"afii57413"},
  {0x0626, (char*)"afii57414"},
  {0x0627, (char*)"afii57415"},
  {0x0628, (char*)"afii57416"},
  {0x0629, (char*)"afii57417"},
  {0x062a, (char*)"afii57418"},
  {0x062b, (char*)"afii57419"},
  {0x062c, (char*)"afii57420"},
  {0x062d, (char*)"afii57421"},
  {0x062e, (char*)"afii57422"},
  {0x062f, (char*)"afii57423"},
  {0x0630, (char*)"afii57424"},
  {0x0631, (char*)"afii57425"},
  {0x0632, (char*)"afii57426"},
  {0x0633, (char*)"afii57427"},
  {0x0634, (char*)"afii57428"},
  {0x0635, (char*)"afii57429"},
  {0x0636, (char*)"afii57430"},
  {0x0637, (char*)"afii57431"},
  {0x0638, (char*)"afii57432"},
  {0x0639, (char*)"afii57433"},
  {0x063a, (char*)"afii57434"},
  {0x0640, (char*)"afii57440"},
  {0x0641, (char*)"afii57441"},
  {0x0642, (char*)"afii57442"},
  {0x0643, (char*)"afii57443"},
  {0x0644, (char*)"afii57444"},
  {0x0645, (char*)"afii57445"},
  {0x0646, (char*)"afii57446"},
  {0x0648, (char*)"afii57448"},
  {0x0649, (char*)"afii57449"},
  {0x064a, (char*)"afii57450"},
  {0x064b, (char*)"afii57451"},
  {0x064c, (char*)"afii57452"},
  {0x064d, (char*)"afii57453"},
  {0x064e, (char*)"afii57454"},
  {0x064f, (char*)"afii57455"},
  {0x0650, (char*)"afii57456"},
  {0x0651, (char*)"afii57457"},
  {0x0652, (char*)"afii57458"},
  {0x0647, (char*)"afii57470"},
  {0x06a4, (char*)"afii57505"},
  {0x067e, (char*)"afii57506"},
  {0x0686, (char*)"afii57507"},
  {0x0698, (char*)"afii57508"},
  {0x06af, (char*)"afii57509"},
  {0x0679, (char*)"afii57511"},
  {0x0688, (char*)"afii57512"},
  {0x0691, (char*)"afii57513"},
  {0x06ba, (char*)"afii57514"},
  {0x06d2, (char*)"afii57519"},
  {0x06d5, (char*)"afii57534"},
  {0x20aa, (char*)"afii57636"},
  {0x05be, (char*)"afii57645"},
  {0x05c3, (char*)"afii57658"},
  {0x05d0, (char*)"afii57664"},
  {0x05d1, (char*)"afii57665"},
  {0x05d2, (char*)"afii57666"},
  {0x05d3, (char*)"afii57667"},
  {0x05d4, (char*)"afii57668"},
  {0x05d5, (char*)"afii57669"},
  {0x05d6, (char*)"afii57670"},
  {0x05d7, (char*)"afii57671"},
  {0x05d8, (char*)"afii57672"},
  {0x05d9, (char*)"afii57673"},
  {0x05da, (char*)"afii57674"},
  {0x05db, (char*)"afii57675"},
  {0x05dc, (char*)"afii57676"},
  {0x05dd, (char*)"afii57677"},
  {0x05de, (char*)"afii57678"},
  {0x05df, (char*)"afii57679"},
  {0x05e0, (char*)"afii57680"},
  {0x05e1, (char*)"afii57681"},
  {0x05e2, (char*)"afii57682"},
  {0x05e3, (char*)"afii57683"},
  {0x05e4, (char*)"afii57684"},
  {0x05e5, (char*)"afii57685"},
  {0x05e6, (char*)"afii57686"},
  {0x05e7, (char*)"afii57687"},
  {0x05e8, (char*)"afii57688"},
  {0x05e9, (char*)"afii57689"},
  {0x05ea, (char*)"afii57690"},
  {0xfb2a, (char*)"afii57694"},
  {0xfb2b, (char*)"afii57695"},
  {0xfb4b, (char*)"afii57700"},
  {0xfb1f, (char*)"afii57705"},
  {0x05f0, (char*)"afii57716"},
  {0x05f1, (char*)"afii57717"},
  {0x05f2, (char*)"afii57718"},
  {0xfb35, (char*)"afii57723"},
  {0x05b4, (char*)"afii57793"},
  {0x05b5, (char*)"afii57794"},
  {0x05b6, (char*)"afii57795"},
  {0x05bb, (char*)"afii57796"},
  {0x05b8, (char*)"afii57797"},
  {0x05b7, (char*)"afii57798"},
  {0x05b0, (char*)"afii57799"},
  {0x05b2, (char*)"afii57800"},
  {0x05b1, (char*)"afii57801"},
  {0x05b3, (char*)"afii57802"},
  {0x05c2, (char*)"afii57803"},
  {0x05c1, (char*)"afii57804"},
  {0x05b9, (char*)"afii57806"},
  {0x05bc, (char*)"afii57807"},
  {0x05bd, (char*)"afii57839"},
  {0x05bf, (char*)"afii57841"},
  {0x05c0, (char*)"afii57842"},
  {0x02bc, (char*)"afii57929"},
  {0x2105, (char*)"afii61248"},
  {0x2113, (char*)"afii61289"},
  {0x2116, (char*)"afii61352"},
  {0x202c, (char*)"afii61573"},
  {0x202d, (char*)"afii61574"},
  {0x202e, (char*)"afii61575"},
  {0x200c, (char*)"afii61664"},
  {0x066d, (char*)"afii63167"},
  {0x02bd, (char*)"afii64937"},
  {0x00e0, (char*)"agrave"},
  {0x2135, (char*)"aleph"},
  {0x03b1, (char*)"alpha"},
  {0x03ac, (char*)"alphatonos"},
  {0x0101, (char*)"amacron"},
  {0x0026, (char*)"ampersand"},
  {0xf726, (char*)"ampersandsmall"},
  {0x2220, (char*)"angle"},
  {0x2329, (char*)"angleleft"},
  {0x232a, (char*)"angleright"},
  {0x0387, (char*)"anoteleia"},
  {0x0105, (char*)"aogonek"},
  {0x2248, (char*)"approxequal"},
  {0x00e5, (char*)"aring"},
  {0x01fb, (char*)"aringacute"},
  {0x2194, (char*)"arrowboth"},
  {0x21d4, (char*)"arrowdblboth"},
  {0x21d3, (char*)"arrowdbldown"},
  {0x21d0, (char*)"arrowdblleft"},
  {0x21d2, (char*)"arrowdblright"},
  {0x21d1, (char*)"arrowdblup"},
  {0x2193, (char*)"arrowdown"},
  {0xf8e7, (char*)"arrowhorizex"},
  {0x2190, (char*)"arrowleft"},
  {0x2192, (char*)"arrowright"},
  {0x2191, (char*)"arrowup"},
  {0x2195, (char*)"arrowupdn"},
  {0x21a8, (char*)"arrowupdnbse"},
  {0xf8e6, (char*)"arrowvertex"},
  {0x005e, (char*)"asciicircum"},
  {0x007e, (char*)"asciitilde"},
  {0x002a, (char*)"asterisk"},
  {0x2217, (char*)"asteriskmath"},
  {0xf6e9, (char*)"asuperior"},
  {0x0040, (char*)"at"},
  {0x00e3, (char*)"atilde"},
  {0x0062, (char*)"b"},
  {0x005c, (char*)"backslash"},
  {0x007c, (char*)"bar"},
  {0x03b2, (char*)"beta"},
  {0x2588, (char*)"block"},
  {0xf8f4, (char*)"braceex"},
  {0x007b, (char*)"braceleft"},
  {0xf8f3, (char*)"braceleftbt"},
  {0xf8f2, (char*)"braceleftmid"},
  {0xf8f1, (char*)"bracelefttp"},
  {0x007d, (char*)"braceright"},
  {0xf8fe, (char*)"bracerightbt"},
  {0xf8fd, (char*)"bracerightmid"},
  {0xf8fc, (char*)"bracerighttp"},
  {0x005b, (char*)"bracketleft"},
  {0xf8f0, (char*)"bracketleftbt"},
  {0xf8ef, (char*)"bracketleftex"},
  {0xf8ee, (char*)"bracketlefttp"},
  {0x005d, (char*)"bracketright"},
  {0xf8fb, (char*)"bracketrightbt"},
  {0xf8fa, (char*)"bracketrightex"},
  {0xf8f9, (char*)"bracketrighttp"},
  {0x02d8, (char*)"breve"},
  {0x00a6, (char*)"brokenbar"},
  {0xf6ea, (char*)"bsuperior"},
  {0x2022, (char*)"bullet"},
  {0x0063, (char*)"c"},
  {0x0107, (char*)"cacute"},
  {0x02c7, (char*)"caron"},
  {0x21b5, (char*)"carriagereturn"},
  {0x010d, (char*)"ccaron"},
  {0x00e7, (char*)"ccedilla"},
  {0x0109, (char*)"ccircumflex"},
  {0x010b, (char*)"cdotaccent"},
  {0x00b8, (char*)"cedilla"},
  {0x00a2, (char*)"cent"},
  {0xf6df, (char*)"centinferior"},
  {0xf7a2, (char*)"centoldstyle"},
  {0xf6e0, (char*)"centsuperior"},
  {0x03c7, (char*)"chi"},
  {0x25cb, (char*)"circle"},
  {0x2297, (char*)"circlemultiply"},
  {0x2295, (char*)"circleplus"},
  {0x02c6, (char*)"circumflex"},
  {0x2663, (char*)"club"},
  {0x003a, (char*)"colon"},
  {0x20a1, (char*)"colonmonetary"},
  {0x002c, (char*)"comma"},
  {0xf6c3, (char*)"commaaccent"},
  {0xf6e1, (char*)"commainferior"},
  {0xf6e2, (char*)"commasuperior"},
  {0x2245, (char*)"congruent"},
  {0x00a9, (char*)"copyright"},
  {0x00a9, (char*)"copyrightsans"},
  {0x00a9, (char*)"copyrightserif"},
  {0x00a4, (char*)"currency"},
  {0xf6d1, (char*)"cyrBreve"},
  {0xf6d2, (char*)"cyrFlex"},
  {0xf6d4, (char*)"cyrbreve"},
  {0xf6d5, (char*)"cyrflex"},
  {0x0064, (char*)"d"},
  {0x2020, (char*)"dagger"},
  {0x2021, (char*)"daggerdbl"},
  {0xf6d3, (char*)"dblGrave"},
  {0xf6d6, (char*)"dblgrave"},
  {0x010f, (char*)"dcaron"},
  {0x0111, (char*)"dcroat"},
  {0x00b0, (char*)"degree"},
  {0x03b4, (char*)"delta"},
  {0x2666, (char*)"diamond"},
  {0x00a8, (char*)"dieresis"},
  {0xf6d7, (char*)"dieresisacute"},
  {0xf6d8, (char*)"dieresisgrave"},
  {0x0385, (char*)"dieresistonos"},
  {0x00f7, (char*)"divide"},
  {0x2593, (char*)"dkshade"},
  {0x2584, (char*)"dnblock"},
  {0x0024, (char*)"dollar"},
  {0xf6e3, (char*)"dollarinferior"},
  {0xf724, (char*)"dollaroldstyle"},
  {0xf6e4, (char*)"dollarsuperior"},
  {0x20ab, (char*)"dong"},
  {0x02d9, (char*)"dotaccent"},
  {0x0323, (char*)"dotbelowcomb"},
  {0x0131, (char*)"dotlessi"},
  {0xf6be, (char*)"dotlessj"},
  {0x22c5, (char*)"dotmath"},
  {0xf6eb, (char*)"dsuperior"},
  {0x0065, (char*)"e"},
  {0x00e9, (char*)"eacute"},
  {0x0115, (char*)"ebreve"},
  {0x011b, (char*)"ecaron"},
  {0x00ea, (char*)"ecircumflex"},
  {0x00eb, (char*)"edieresis"},
  {0x0117, (char*)"edotaccent"},
  {0x00e8, (char*)"egrave"},
  {0x0038, (char*)"eight"},
  {0x2088, (char*)"eightinferior"},
  {0xf738, (char*)"eightoldstyle"},
  {0x2078, (char*)"eightsuperior"},
  {0x2208, (char*)"element"},
  {0x2026, (char*)"ellipsis"},
  {0x0113, (char*)"emacron"},
  {0x2014, (char*)"emdash"},
  {0x2205, (char*)"emptyset"},
  {0x2013, (char*)"endash"},
  {0x014b, (char*)"eng"},
  {0x0119, (char*)"eogonek"},
  {0x03b5, (char*)"epsilon"},
  {0x03ad, (char*)"epsilontonos"},
  {0x003d, (char*)"equal"},
  {0x2261, (char*)"equivalence"},
  {0x212e, (char*)"estimated"},
  {0xf6ec, (char*)"esuperior"},
  {0x03b7, (char*)"eta"},
  {0x03ae, (char*)"etatonos"},
  {0x00f0, (char*)"eth"},
  {0x0021, (char*)"exclam"},
  {0x203c, (char*)"exclamdbl"},
  {0x00a1, (char*)"exclamdown"},
  {0xf7a1, (char*)"exclamdownsmall"},
  {0x0021, (char*)"exclamleft"},
  {0xf721, (char*)"exclamsmall"},
  {0x2203, (char*)"existential"},
  {0x0066, (char*)"f"},
  {0x2640, (char*)"female"},
  {0xfb00, (char*)"ff"},
  {0xfb03, (char*)"ffi"},
  {0xfb04, (char*)"ffl"},
  {0xfb01, (char*)"fi"},
  {0x2012, (char*)"figuredash"},
  {0x25a0, (char*)"filledbox"},
  {0x25ac, (char*)"filledrect"},
  {0x0035, (char*)"five"},
  {0x215d, (char*)"fiveeighths"},
  {0x2085, (char*)"fiveinferior"},
  {0xf735, (char*)"fiveoldstyle"},
  {0x2075, (char*)"fivesuperior"},
  {0xfb02, (char*)"fl"},
  {0x0192, (char*)"florin"},
  {0x0034, (char*)"four"},
  {0x2084, (char*)"fourinferior"},
  {0xf734, (char*)"fouroldstyle"},
  {0x2074, (char*)"foursuperior"},
  {0x2044, (char*)"fraction"},
  {0x20a3, (char*)"franc"},
  {0x0067, (char*)"g"},
  {0x03b3, (char*)"gamma"},
  {0x011f, (char*)"gbreve"},
  {0x01e7, (char*)"gcaron"},
  {0x011d, (char*)"gcircumflex"},
  {0x0123, (char*)"gcommaaccent"},
  {0x0121, (char*)"gdotaccent"},
  {0x00df, (char*)"germandbls"},
  {0x2207, (char*)"gradient"},
  {0x0060, (char*)"grave"},
  {0x0300, (char*)"gravecomb"},
  {0x003e, (char*)"greater"},
  {0x2265, (char*)"greaterequal"},
  {0x00ab, (char*)"guillemotleft"},
  {0x00bb, (char*)"guillemotright"},
  {0x2039, (char*)"guilsinglleft"},
  {0x203a, (char*)"guilsinglright"},
  {0x0068, (char*)"h"},
  {0x0127, (char*)"hbar"},
  {0x0125, (char*)"hcircumflex"},
  {0x2665, (char*)"heart"},
  {0x0309, (char*)"hookabovecomb"},
  {0x2302, (char*)"house"},
  {0x02dd, (char*)"hungarumlaut"},
  {0x002d, (char*)"hyphen"},
  {0xf6e5, (char*)"hypheninferior"},
  {0xf6e6, (char*)"hyphensuperior"},
  {0x0069, (char*)"i"},
  {0x00ed, (char*)"iacute"},
  {0x012d, (char*)"ibreve"},
  {0x00ee, (char*)"icircumflex"},
  {0x00ef, (char*)"idieresis"},
  {0x00ec, (char*)"igrave"},
  {0x0133, (char*)"ij"},
  {0x012b, (char*)"imacron"},
  {0x221e, (char*)"infinity"},
  {0x222b, (char*)"integral"},
  {0x2321, (char*)"integralbt"},
  {0xf8f5, (char*)"integralex"},
  {0x2320, (char*)"integraltp"},
  {0x2229, (char*)"intersection"},
  {0x25d8, (char*)"invbullet"},
  {0x25d9, (char*)"invcircle"},
  {0x263b, (char*)"invsmileface"},
  {0x012f, (char*)"iogonek"},
  {0x03b9, (char*)"iota"},
  {0x03ca, (char*)"iotadieresis"},
  {0x0390, (char*)"iotadieresistonos"},
  {0x03af, (char*)"iotatonos"},
  {0xf6ed, (char*)"isuperior"},
  {0x0129, (char*)"itilde"},
  {0x006a, (char*)"j"},
  {0x0135, (char*)"jcircumflex"},
  {0x006b, (char*)"k"},
  {0x03ba, (char*)"kappa"},
  {0x0137, (char*)"kcommaaccent"},
  {0x0138, (char*)"kgreenlandic"},
  {0x006c, (char*)"l"},
  {0x013a, (char*)"lacute"},
  {0x03bb, (char*)"lambda"},
  {0x013e, (char*)"lcaron"},
  {0x013c, (char*)"lcommaaccent"},
  {0x0140, (char*)"ldot"},
  {0x003c, (char*)"less"},
  {0x2264, (char*)"lessequal"},
  {0x258c, (char*)"lfblock"},
  {0x20a4, (char*)"lira"},
  {0xf6c0, (char*)"ll"},
  {0x2227, (char*)"logicaland"},
  {0x00ac, (char*)"logicalnot"},
  {0x2228, (char*)"logicalor"},
  {0x017f, (char*)"longs"},
  {0x25ca, (char*)"lozenge"},
  {0x0142, (char*)"lslash"},
  {0xf6ee, (char*)"lsuperior"},
  {0x2591, (char*)"ltshade"},
  {0x006d, (char*)"m"},
  {0x00af, (char*)"macron"},
  {0x2642, (char*)"male"},
  {0x2212, (char*)"minus"},
  {0x2032, (char*)"minute"},
  {0xf6ef, (char*)"msuperior"},
  {0x00b5, (char*)"mu"},
  {0x00d7, (char*)"multiply"},
  {0x266a, (char*)"musicalnote"},
  {0x266b, (char*)"musicalnotedbl"},
  {0x006e, (char*)"n"},
  {0x0144, (char*)"nacute"},
  {0x0149, (char*)"napostrophe"},
  {0x00a0, (char*)"nbspace"},
  {0x0148, (char*)"ncaron"},
  {0x0146, (char*)"ncommaaccent"},
  {0x0039, (char*)"nine"},
  {0x2089, (char*)"nineinferior"},
  {0xf739, (char*)"nineoldstyle"},
  {0x2079, (char*)"ninesuperior"},
  {0x00a0, (char*)"nonbreakingspace"},
  {0x2209, (char*)"notelement"},
  {0x2260, (char*)"notequal"},
  {0x2284, (char*)"notsubset"},
  {0x207f, (char*)"nsuperior"},
  {0x00f1, (char*)"ntilde"},
  {0x03bd, (char*)"nu"},
  {0x0023, (char*)"numbersign"},
  {0x006f, (char*)"o"},
  {0x00f3, (char*)"oacute"},
  {0x014f, (char*)"obreve"},
  {0x00f4, (char*)"ocircumflex"},
  {0x00f6, (char*)"odieresis"},
  {0x0153, (char*)"oe"},
  {0x02db, (char*)"ogonek"},
  {0x00f2, (char*)"ograve"},
  {0x01a1, (char*)"ohorn"},
  {0x0151, (char*)"ohungarumlaut"},
  {0x014d, (char*)"omacron"},
  {0x03c9, (char*)"omega"},
  {0x03d6, (char*)"omega1"},
  {0x03ce, (char*)"omegatonos"},
  {0x03bf, (char*)"omicron"},
  {0x03cc, (char*)"omicrontonos"},
  {0x0031, (char*)"one"},
  {0x2024, (char*)"onedotenleader"},
  {0x215b, (char*)"oneeighth"},
  {0xf6dc, (char*)"onefitted"},
  {0x00bd, (char*)"onehalf"},
  {0x2081, (char*)"oneinferior"},
  {0xf731, (char*)"oneoldstyle"},
  {0x00bc, (char*)"onequarter"},
  {0x00b9, (char*)"onesuperior"},
  {0x2153, (char*)"onethird"},
  {0x25e6, (char*)"openbullet"},
  {0x00aa, (char*)"ordfeminine"},
  {0x00ba, (char*)"ordmasculine"},
  {0x221f, (char*)"orthogonal"},
  {0x00f8, (char*)"oslash"},
  {0x01ff, (char*)"oslashacute"},
  {0xf6f0, (char*)"osuperior"},
  {0x00f5, (char*)"otilde"},
  {0x0070, (char*)"p"},
  {0x00b6, (char*)"paragraph"},
  {0x0028, (char*)"parenleft"},
  {0xf8ed, (char*)"parenleftbt"},
  {0xf8ec, (char*)"parenleftex"},
  {0x208d, (char*)"parenleftinferior"},
  {0x207d, (char*)"parenleftsuperior"},
  {0xf8eb, (char*)"parenlefttp"},
  {0x0029, (char*)"parenright"},
  {0xf8f8, (char*)"parenrightbt"},
  {0xf8f7, (char*)"parenrightex"},
  {0x208e, (char*)"parenrightinferior"},
  {0x207e, (char*)"parenrightsuperior"},
  {0xf8f6, (char*)"parenrighttp"},
  {0x2202, (char*)"partialdiff"},
  {0x0025, (char*)"percent"},
  {0x002e, (char*)"period"},
  {0x00b7, (char*)"periodcentered"},
  {0xf6e7, (char*)"periodinferior"},
  {0xf6e8, (char*)"periodsuperior"},
  {0x22a5, (char*)"perpendicular"},
  {0x2030, (char*)"perthousand"},
  {0x20a7, (char*)"peseta"},
  {0x03c6, (char*)"phi"},
  {0x03d5, (char*)"phi1"},
  {0x03c0, (char*)"pi"},
  {0x002b, (char*)"plus"},
  {0x00b1, (char*)"plusminus"},
  {0x211e, (char*)"prescription"},
  {0x220f, (char*)"product"},
  {0x2282, (char*)"propersubset"},
  {0x2283, (char*)"propersuperset"},
  {0x221d, (char*)"proportional"},
  {0x03c8, (char*)"psi"},
  {0x0071, (char*)"q"},
  {0x003f, (char*)"question"},
  {0x00bf, (char*)"questiondown"},
  {0xf7bf, (char*)"questiondownsmall"},
  {0xf73f, (char*)"questionsmall"},
  {0x0022, (char*)"quotedbl"},
  {0x201e, (char*)"quotedblbase"},
  {0x201c, (char*)"quotedblleft"},
  {0x201d, (char*)"quotedblright"},
  {0x2018, (char*)"quoteleft"},
  {0x201b, (char*)"quotereversed"},
  {0x2019, (char*)"quoteright"},
  {0x201a, (char*)"quotesinglbase"},
  {0x0027, (char*)"quotesingle"},
  {0x0072, (char*)"r"},
  {0x0155, (char*)"racute"},
  {0x221a, (char*)"radical"},
  {0xf8e5, (char*)"radicalex"},
  {0x0159, (char*)"rcaron"},
  {0x0157, (char*)"rcommaaccent"},
  {0x2286, (char*)"reflexsubset"},
  {0x2287, (char*)"reflexsuperset"},
  {0x00ae, (char*)"registered"},
  {0x00ae, (char*)"registersans"},
  {0x00ae, (char*)"registerserif"},
  {0x2310, (char*)"revlogicalnot"},
  {0x03c1, (char*)"rho"},
  {0x02da, (char*)"ring"},
  {0xf6f1, (char*)"rsuperior"},
  {0x2590, (char*)"rtblock"},
  {0xf6dd, (char*)"rupiah"},
  {0x0073, (char*)"s"},
  {0x015b, (char*)"sacute"},
  {0x0161, (char*)"scaron"},
  {0x015f, (char*)"scedilla"},
  {0x015d, (char*)"scircumflex"},
  {0x0219, (char*)"scommaaccent"},
  {0x2033, (char*)"second"},
  {0x00a7, (char*)"section"},
  {0x003b, (char*)"semicolon"},
  {0x0037, (char*)"seven"},
  {0x215e, (char*)"seveneighths"},
  {0x2087, (char*)"seveninferior"},
  {0xf737, (char*)"sevenoldstyle"},
  {0x2077, (char*)"sevensuperior"},
  {0x2592, (char*)"shade"},
  {0x03c3, (char*)"sigma"},
  {0x03c2, (char*)"sigma1"},
  {0x223c, (char*)"similar"},
  {0x0036, (char*)"six"},
  {0x2086, (char*)"sixinferior"},
  {0xf736, (char*)"sixoldstyle"},
  {0x2076, (char*)"sixsuperior"},
  {0x002f, (char*)"slash"},
  {0x263a, (char*)"smileface"},
  {0x0020, (char*)"space"},
  {0x2660, (char*)"spade"},
  {0xf6f2, (char*)"ssuperior"},
  {0x00a3, (char*)"sterling"},
  {0x220b, (char*)"suchthat"},
  {0x2211, (char*)"summation"},
  {0x263c, (char*)"sun"},
  {0x0074, (char*)"t"},
  {0x03c4, (char*)"tau"},
  {0x0167, (char*)"tbar"},
  {0x0165, (char*)"tcaron"},
  {0x0163, (char*)"tcommaaccent"},
  {0x2234, (char*)"therefore"},
  {0x03b8, (char*)"theta"},
  {0x03d1, (char*)"theta1"},
  {0x00fe, (char*)"thorn"},
  {0x0033, (char*)"three"},
  {0x215c, (char*)"threeeighths"},
  {0x2083, (char*)"threeinferior"},
  {0xf733, (char*)"threeoldstyle"},
  {0x00be, (char*)"threequarters"},
  {0xf6de, (char*)"threequartersemdash"},
  {0x00b3, (char*)"threesuperior"},
  {0x02dc, (char*)"tilde"},
  {0x0303, (char*)"tildecomb"},
  {0x0384, (char*)"tonos"},
  {0x2122, (char*)"trademark"},
  {0x2122, (char*)"trademarksans"},
  {0x2122, (char*)"trademarkserif"},
  {0x25bc, (char*)"triagdn"},
  {0x25c4, (char*)"triaglf"},
  {0x25ba, (char*)"triagrt"},
  {0x25b2, (char*)"triagup"},
  {0xf6f3, (char*)"tsuperior"},
  {0x0032, (char*)"two"},
  {0x2025, (char*)"twodotenleader"},
  {0x2082, (char*)"twoinferior"},
  {0xf732, (char*)"twooldstyle"},
  {0x00b2, (char*)"twosuperior"},
  {0x2154, (char*)"twothirds"},
  {0x0075, (char*)"u"},
  {0x00fa, (char*)"uacute"},
  {0x016d, (char*)"ubreve"},
  {0x00fb, (char*)"ucircumflex"},
  {0x00fc, (char*)"udieresis"},
  {0x00f9, (char*)"ugrave"},
  {0x01b0, (char*)"uhorn"},
  {0x0171, (char*)"uhungarumlaut"},
  {0x016b, (char*)"umacron"},
  {0x005f, (char*)"underscore"},
  {0x2017, (char*)"underscoredbl"},
  {0x222a, (char*)"union"},
  {0x2200, (char*)"universal"},
  {0x0173, (char*)"uogonek"},
  {0x2580, (char*)"upblock"},
  {0x03c5, (char*)"upsilon"},
  {0x03cb, (char*)"upsilondieresis"},
  {0x03b0, (char*)"upsilondieresistonos"},
  {0x03cd, (char*)"upsilontonos"},
  {0x016f, (char*)"uring"},
  {0x0169, (char*)"utilde"},
  {0x0076, (char*)"v"},
  {0x0077, (char*)"w"},
  {0x1e83, (char*)"wacute"},
  {0x0175, (char*)"wcircumflex"},
  {0x1e85, (char*)"wdieresis"},
  {0x2118, (char*)"weierstrass"},
  {0x1e81, (char*)"wgrave"},
  {0x0078, (char*)"x"},
  {0x03be, (char*)"xi"},
  {0x0079, (char*)"y"},
  {0x00fd, (char*)"yacute"},
  {0x0177, (char*)"ycircumflex"},
  {0x00ff, (char*)"ydieresis"},
  {0x00a5, (char*)"yen"},
  {0x1ef3, (char*)"ygrave"},
  {0x007a, (char*)"z"},
  {0x017a, (char*)"zacute"},
  {0x017e, (char*)"zcaron"},
  {0x017c, (char*)"zdotaccent"},
  {0x0030, (char*)"zero"},
  {0x2080, (char*)"zeroinferior"},
  {0xf730, (char*)"zerooldstyle"},
  {0x2070, (char*)"zerosuperior"},
  {0x03b6, (char*)"zeta"},
  {0x007b, (char*)"{"},
  {0x007c, (char*)"|"},
  {0x007d, (char*)"}"},
  {0x007e, (char*)"~"},
  { 0, NULL }
};
