/*
 * errorHelper.h
 *
 * used to warnings with newer c++ standards, particularly:
 * 		ISO C++ forbids converting a string constant to ‘char*’
 */

#ifndef ERRORHELPER_H
#define ERRORHELPER_H

#include "GString.h"
#include <string>
#include <sstream>

char* composeError(std::string msg, GString* data = NULL) {
    std::stringstream ss;
	ss << msg;
	if (data) {
		for(int i = 0; i < data->getLength(); i++) {
			ss << data->getChar(i);
		}
	}
	return (char *)ss.str().c_str();
}

char* composeErrorChr(const char* msg, char* data = NULL) {
    std::stringstream ss;
    if (msg) {
        for(int i = 0; i < strlen(msg); i++) {
			ss << msg[i];
		}
    }
	if (data) {
		for(int i = 0; i < strlen(data); i++) {
			ss << data[i];
		}
	}
	return (char*)ss.str().c_str();
}

#endif
