//========================================================================
//
// FoFiEncodings.cc
//
// Copyright 1999-2003 Glyph & Cog, LLC
//
//========================================================================

#include <aconf.h>

#ifdef USE_GCC_PRAGMAS
#pragma implementation
#endif

#include <stdlib.h>
#include "FoFiEncodings.h"

//------------------------------------------------------------------------
// Type 1 and 1C font data
//------------------------------------------------------------------------

char *fofiType1StandardEncoding[256] = {
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"space",
  (char*)"exclam",
  (char*)"quotedbl",
  (char*)"numbersign",
  (char*)"dollar",
  (char*)"percent",
  (char*)"ampersand",
  (char*)"quoteright",
  (char*)"parenleft",
  (char*)"parenright",
  (char*)"asterisk",
  (char*)"plus",
  (char*)"comma",
  (char*)"hyphen",
  (char*)"period",
  (char*)"slash",
  (char*)"zero",
  (char*)"one",
  (char*)"two",
  (char*)"three",
  (char*)"four",
  (char*)"five",
  (char*)"six",
  (char*)"seven",
  (char*)"eight",
  (char*)"nine",
  (char*)"colon",
  (char*)"semicolon",
  (char*)"less",
  (char*)"equal",
  (char*)"greater",
  (char*)"question",
  (char*)"at",
  (char*)"A",
  (char*)"B",
  (char*)"C",
  (char*)"D",
  (char*)"E",
  (char*)"F",
  (char*)"G",
  (char*)"H",
  (char*)"I",
  (char*)"J",
  (char*)"K",
  (char*)"L",
  (char*)"M",
  (char*)"N",
  (char*)"O",
  (char*)"P",
  (char*)"Q",
  (char*)"R",
  (char*)"S",
  (char*)"T",
  (char*)"U",
  (char*)"V",
  (char*)"W",
  (char*)"X",
  (char*)"Y",
  (char*)"Z",
  (char*)"bracketleft",
  (char*)"backslash",
  (char*)"bracketright",
  (char*)"asciicircum",
  (char*)"underscore",
  (char*)"quoteleft",
  (char*)"a",
  (char*)"b",
  (char*)"c",
  (char*)"d",
  (char*)"e",
  (char*)"f",
  (char*)"g",
  (char*)"h",
  (char*)"i",
  (char*)"j",
  (char*)"k",
  (char*)"l",
  (char*)"m",
  (char*)"n",
  (char*)"o",
  (char*)"p",
  (char*)"q",
  (char*)"r",
  (char*)"s",
  (char*)"t",
  (char*)"u",
  (char*)"v",
  (char*)"w",
  (char*)"x",
  (char*)"y",
  (char*)"z",
  (char*)"braceleft",
  (char*)"bar",
  (char*)"braceright",
  (char*)"asciitilde",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"exclamdown",
  (char*)"cent",
  (char*)"sterling",
  (char*)"fraction",
  (char*)"yen",
  (char*)"florin",
  (char*)"section",
  (char*)"currency",
  (char*)"quotesingle",
  (char*)"quotedblleft",
  (char*)"guillemotleft",
  (char*)"guilsinglleft",
  (char*)"guilsinglright",
  (char*)"fi",
  (char*)"fl",
  NULL,
  (char*)"endash",
  (char*)"dagger",
  (char*)"daggerdbl",
  (char*)"periodcentered",
  NULL,
  (char*)"paragraph",
  (char*)"bullet",
  (char*)"quotesinglbase",
  (char*)"quotedblbase",
  (char*)"quotedblright",
  (char*)"guillemotright",
  (char*)"ellipsis",
  (char*)"perthousand",
  NULL,
  (char*)"questiondown",
  NULL,
  (char*)"grave",
  (char*)"acute",
  (char*)"circumflex",
  (char*)"tilde",
  (char*)"macron",
  (char*)"breve",
  (char*)"dotaccent",
  (char*)"dieresis",
  NULL,
  (char*)"ring",
  (char*)"cedilla",
  NULL,
  (char*)"hungarumlaut",
  (char*)"ogonek",
  (char*)"caron",
  (char*)"emdash",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"AE",
  NULL,
  (char*)"ordfeminine",
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"Lslash",
  (char*)"Oslash",
  (char*)"OE",
  (char*)"ordmasculine",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"ae",
  NULL,
  NULL,
  NULL,
  (char*)"dotlessi",
  NULL,
  NULL,
  (char*)"lslash",
  (char*)"oslash",
  (char*)"oe",
  (char*)"germandbls",
  NULL,
  NULL,
  NULL,
  NULL
};

char *fofiType1ExpertEncoding[256] = {
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"space",
  (char*)"exclamsmall",
  (char*)"Hungarumlautsmall",
  NULL,
  (char*)"dollaroldstyle",
  (char*)"dollarsuperior",
  (char*)"ampersandsmall",
  (char*)"Acutesmall",
  (char*)"parenleftsuperior",
  (char*)"parenrightsuperior",
  (char*)"twodotenleader",
  (char*)"onedotenleader",
  (char*)"comma",
  (char*)"hyphen",
  (char*)"period",
  (char*)"fraction",
  (char*)"zerooldstyle",
  (char*)"oneoldstyle",
  (char*)"twooldstyle",
  (char*)"threeoldstyle",
  (char*)"fouroldstyle",
  (char*)"fiveoldstyle",
  (char*)"sixoldstyle",
  (char*)"sevenoldstyle",
  (char*)"eightoldstyle",
  (char*)"nineoldstyle",
  (char*)"colon",
  (char*)"semicolon",
  (char*)"commasuperior",
  (char*)"threequartersemdash",
  (char*)"periodsuperior",
  (char*)"questionsmall",
  NULL,
  (char*)"asuperior",
  (char*)"bsuperior",
  (char*)"centsuperior",
  (char*)"dsuperior",
  (char*)"esuperior",
  NULL,
  NULL,
  NULL,
  (char*)"isuperior",
  NULL,
  NULL,
  (char*)"lsuperior",
  (char*)"msuperior",
  (char*)"nsuperior",
  (char*)"osuperior",
  NULL,
  NULL,
  (char*)"rsuperior",
  (char*)"ssuperior",
  (char*)"tsuperior",
  NULL,
  (char*)"ff",
  (char*)"fi",
  (char*)"fl",
  (char*)"ffi",
  (char*)"ffl",
  (char*)"parenleftinferior",
  NULL,
  (char*)"parenrightinferior",
  (char*)"Circumflexsmall",
  (char*)"hyphensuperior",
  (char*)"Gravesmall",
  (char*)"Asmall",
  (char*)"Bsmall",
  (char*)"Csmall",
  (char*)"Dsmall",
  (char*)"Esmall",
  (char*)"Fsmall",
  (char*)"Gsmall",
  (char*)"Hsmall",
  (char*)"Ismall",
  (char*)"Jsmall",
  (char*)"Ksmall",
  (char*)"Lsmall",
  (char*)"Msmall",
  (char*)"Nsmall",
  (char*)"Osmall",
  (char*)"Psmall",
  (char*)"Qsmall",
  (char*)"Rsmall",
  (char*)"Ssmall",
  (char*)"Tsmall",
  (char*)"Usmall",
  (char*)"Vsmall",
  (char*)"Wsmall",
  (char*)"Xsmall",
  (char*)"Ysmall",
  (char*)"Zsmall",
  (char*)"colonmonetary",
  (char*)"onefitted",
  (char*)"rupiah",
  (char*)"Tildesmall",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"exclamdownsmall",
  (char*)"centoldstyle",
  (char*)"Lslashsmall",
  NULL,
  NULL,
  (char*)"Scaronsmall",
  (char*)"Zcaronsmall",
  (char*)"Dieresissmall",
  (char*)"Brevesmall",
  (char*)"Caronsmall",
  NULL,
  (char*)"Dotaccentsmall",
  NULL,
  NULL,
  (char*)"Macronsmall",
  NULL,
  NULL,
  (char*)"figuredash",
  (char*)"hypheninferior",
  NULL,
  NULL,
  (char*)"Ogoneksmall",
  (char*)"Ringsmall",
  (char*)"Cedillasmall",
  NULL,
  NULL,
  NULL,
  (char*)"onequarter",
  (char*)"onehalf",
  (char*)"threequarters",
  (char*)"questiondownsmall",
  (char*)"oneeighth",
  (char*)"threeeighths",
  (char*)"fiveeighths",
  (char*)"seveneighths",
  (char*)"onethird",
  (char*)"twothirds",
  NULL,
  NULL,
  (char*)"zerosuperior",
  (char*)"onesuperior",
  (char*)"twosuperior",
  (char*)"threesuperior",
  (char*)"foursuperior",
  (char*)"fivesuperior",
  (char*)"sixsuperior",
  (char*)"sevensuperior",
  (char*)"eightsuperior",
  (char*)"ninesuperior",
  (char*)"zeroinferior",
  (char*)"oneinferior",
  (char*)"twoinferior",
  (char*)"threeinferior",
  (char*)"fourinferior",
  (char*)"fiveinferior",
  (char*)"sixinferior",
  (char*)"seveninferior",
  (char*)"eightinferior",
  (char*)"nineinferior",
  (char*)"centinferior",
  (char*)"dollarinferior",
  (char*)"periodinferior",
  (char*)"commainferior",
  (char*)"Agravesmall",
  (char*)"Aacutesmall",
  (char*)"Acircumflexsmall",
  (char*)"Atildesmall",
  (char*)"Adieresissmall",
  (char*)"Aringsmall",
  (char*)"AEsmall",
  (char*)"Ccedillasmall",
  (char*)"Egravesmall",
  (char*)"Eacutesmall",
  (char*)"Ecircumflexsmall",
  (char*)"Edieresissmall",
  (char*)"Igravesmall",
  (char*)"Iacutesmall",
  (char*)"Icircumflexsmall",
  (char*)"Idieresissmall",
  (char*)"Ethsmall",
  (char*)"Ntildesmall",
  (char*)"Ogravesmall",
  (char*)"Oacutesmall",
  (char*)"Ocircumflexsmall",
  (char*)"Otildesmall",
  (char*)"Odieresissmall",
  (char*)"OEsmall",
  (char*)"Oslashsmall",
  (char*)"Ugravesmall",
  (char*)"Uacutesmall",
  (char*)"Ucircumflexsmall",
  (char*)"Udieresissmall",
  (char*)"Yacutesmall",
  (char*)"Thornsmall",
  (char*)"Ydieresissmall"
};

//------------------------------------------------------------------------
// Type 1C font data
//------------------------------------------------------------------------

char *fofiType1CStdStrings[391] = {
  (char*)".notdef",
  (char*)"space",
  (char*)"exclam",
  (char*)"quotedbl",
  (char*)"numbersign",
  (char*)"dollar",
  (char*)"percent",
  (char*)"ampersand",
  (char*)"quoteright",
  (char*)"parenleft",
  (char*)"parenright",
  (char*)"asterisk",
  (char*)"plus",
  (char*)"comma",
  (char*)"hyphen",
  (char*)"period",
  (char*)"slash",
  (char*)"zero",
  (char*)"one",
  (char*)"two",
  (char*)"three",
  (char*)"four",
  (char*)"five",
  (char*)"six",
  (char*)"seven",
  (char*)"eight",
  (char*)"nine",
  (char*)"colon",
  (char*)"semicolon",
  (char*)"less",
  (char*)"equal",
  (char*)"greater",
  (char*)"question",
  (char*)"at",
  (char*)"A",
  (char*)"B",
  (char*)"C",
  (char*)"D",
  (char*)"E",
  (char*)"F",
  (char*)"G",
  (char*)"H",
  (char*)"I",
  (char*)"J",
  (char*)"K",
  (char*)"L",
  (char*)"M",
  (char*)"N",
  (char*)"O",
  (char*)"P",
  (char*)"Q",
  (char*)"R",
  (char*)"S",
  (char*)"T",
  (char*)"U",
  (char*)"V",
  (char*)"W",
  (char*)"X",
  (char*)"Y",
  (char*)"Z",
  (char*)"bracketleft",
  (char*)"backslash",
  (char*)"bracketright",
  (char*)"asciicircum",
  (char*)"underscore",
  (char*)"quoteleft",
  (char*)"a",
  (char*)"b",
  (char*)"c",
  (char*)"d",
  (char*)"e",
  (char*)"f",
  (char*)"g",
  (char*)"h",
  (char*)"i",
  (char*)"j",
  (char*)"k",
  (char*)"l",
  (char*)"m",
  (char*)"n",
  (char*)"o",
  (char*)"p",
  (char*)"q",
  (char*)"r",
  (char*)"s",
  (char*)"t",
  (char*)"u",
  (char*)"v",
  (char*)"w",
  (char*)"x",
  (char*)"y",
  (char*)"z",
  (char*)"braceleft",
  (char*)"bar",
  (char*)"braceright",
  (char*)"asciitilde",
  (char*)"exclamdown",
  (char*)"cent",
  (char*)"sterling",
  (char*)"fraction",
  (char*)"yen",
  (char*)"florin",
  (char*)"section",
  (char*)"currency",
  (char*)"quotesingle",
  (char*)"quotedblleft",
  (char*)"guillemotleft",
  (char*)"guilsinglleft",
  (char*)"guilsinglright",
  (char*)"fi",
  (char*)"fl",
  (char*)"endash",
  (char*)"dagger",
  (char*)"daggerdbl",
  (char*)"periodcentered",
  (char*)"paragraph",
  (char*)"bullet",
  (char*)"quotesinglbase",
  (char*)"quotedblbase",
  (char*)"quotedblright",
  (char*)"guillemotright",
  (char*)"ellipsis",
  (char*)"perthousand",
  (char*)"questiondown",
  (char*)"grave",
  (char*)"acute",
  (char*)"circumflex",
  (char*)"tilde",
  (char*)"macron",
  (char*)"breve",
  (char*)"dotaccent",
  (char*)"dieresis",
  (char*)"ring",
  (char*)"cedilla",
  (char*)"hungarumlaut",
  (char*)"ogonek",
  (char*)"caron",
  (char*)"emdash",
  (char*)"AE",
  (char*)"ordfeminine",
  (char*)"Lslash",
  (char*)"Oslash",
  (char*)"OE",
  (char*)"ordmasculine",
  (char*)"ae",
  (char*)"dotlessi",
  (char*)"lslash",
  (char*)"oslash",
  (char*)"oe",
  (char*)"germandbls",
  (char*)"onesuperior",
  (char*)"logicalnot",
  (char*)"mu",
  (char*)"trademark",
  (char*)"Eth",
  (char*)"onehalf",
  (char*)"plusminus",
  (char*)"Thorn",
  (char*)"onequarter",
  (char*)"divide",
  (char*)"brokenbar",
  (char*)"degree",
  (char*)"thorn",
  (char*)"threequarters",
  (char*)"twosuperior",
  (char*)"registered",
  (char*)"minus",
  (char*)"eth",
  (char*)"multiply",
  (char*)"threesuperior",
  (char*)"copyright",
  (char*)"Aacute",
  (char*)"Acircumflex",
  (char*)"Adieresis",
  (char*)"Agrave",
  (char*)"Aring",
  (char*)"Atilde",
  (char*)"Ccedilla",
  (char*)"Eacute",
  (char*)"Ecircumflex",
  (char*)"Edieresis",
  (char*)"Egrave",
  (char*)"Iacute",
  (char*)"Icircumflex",
  (char*)"Idieresis",
  (char*)"Igrave",
  (char*)"Ntilde",
  (char*)"Oacute",
  (char*)"Ocircumflex",
  (char*)"Odieresis",
  (char*)"Ograve",
  (char*)"Otilde",
  (char*)"Scaron",
  (char*)"Uacute",
  (char*)"Ucircumflex",
  (char*)"Udieresis",
  (char*)"Ugrave",
  (char*)"Yacute",
  (char*)"Ydieresis",
  (char*)"Zcaron",
  (char*)"aacute",
  (char*)"acircumflex",
  (char*)"adieresis",
  (char*)"agrave",
  (char*)"aring",
  (char*)"atilde",
  (char*)"ccedilla",
  (char*)"eacute",
  (char*)"ecircumflex",
  (char*)"edieresis",
  (char*)"egrave",
  (char*)"iacute",
  (char*)"icircumflex",
  (char*)"idieresis",
  (char*)"igrave",
  (char*)"ntilde",
  (char*)"oacute",
  (char*)"ocircumflex",
  (char*)"odieresis",
  (char*)"ograve",
  (char*)"otilde",
  (char*)"scaron",
  (char*)"uacute",
  (char*)"ucircumflex",
  (char*)"udieresis",
  (char*)"ugrave",
  (char*)"yacute",
  (char*)"ydieresis",
  (char*)"zcaron",
  (char*)"exclamsmall",
  (char*)"Hungarumlautsmall",
  (char*)"dollaroldstyle",
  (char*)"dollarsuperior",
  (char*)"ampersandsmall",
  (char*)"Acutesmall",
  (char*)"parenleftsuperior",
  (char*)"parenrightsuperior",
  (char*)"twodotenleader",
  (char*)"onedotenleader",
  (char*)"zerooldstyle",
  (char*)"oneoldstyle",
  (char*)"twooldstyle",
  (char*)"threeoldstyle",
  (char*)"fouroldstyle",
  (char*)"fiveoldstyle",
  (char*)"sixoldstyle",
  (char*)"sevenoldstyle",
  (char*)"eightoldstyle",
  (char*)"nineoldstyle",
  (char*)"commasuperior",
  (char*)"threequartersemdash",
  (char*)"periodsuperior",
  (char*)"questionsmall",
  (char*)"asuperior",
  (char*)"bsuperior",
  (char*)"centsuperior",
  (char*)"dsuperior",
  (char*)"esuperior",
  (char*)"isuperior",
  (char*)"lsuperior",
  (char*)"msuperior",
  (char*)"nsuperior",
  (char*)"osuperior",
  (char*)"rsuperior",
  (char*)"ssuperior",
  (char*)"tsuperior",
  (char*)"ff",
  (char*)"ffi",
  (char*)"ffl",
  (char*)"parenleftinferior",
  (char*)"parenrightinferior",
  (char*)"Circumflexsmall",
  (char*)"hyphensuperior",
  (char*)"Gravesmall",
  (char*)"Asmall",
  (char*)"Bsmall",
  (char*)"Csmall",
  (char*)"Dsmall",
  (char*)"Esmall",
  (char*)"Fsmall",
  (char*)"Gsmall",
  (char*)"Hsmall",
  (char*)"Ismall",
  (char*)"Jsmall",
  (char*)"Ksmall",
  (char*)"Lsmall",
  (char*)"Msmall",
  (char*)"Nsmall",
  (char*)"Osmall",
  (char*)"Psmall",
  (char*)"Qsmall",
  (char*)"Rsmall",
  (char*)"Ssmall",
  (char*)"Tsmall",
  (char*)"Usmall",
  (char*)"Vsmall",
  (char*)"Wsmall",
  (char*)"Xsmall",
  (char*)"Ysmall",
  (char*)"Zsmall",
  (char*)"colonmonetary",
  (char*)"onefitted",
  (char*)"rupiah",
  (char*)"Tildesmall",
  (char*)"exclamdownsmall",
  (char*)"centoldstyle",
  (char*)"Lslashsmall",
  (char*)"Scaronsmall",
  (char*)"Zcaronsmall",
  (char*)"Dieresissmall",
  (char*)"Brevesmall",
  (char*)"Caronsmall",
  (char*)"Dotaccentsmall",
  (char*)"Macronsmall",
  (char*)"figuredash",
  (char*)"hypheninferior",
  (char*)"Ogoneksmall",
  (char*)"Ringsmall",
  (char*)"Cedillasmall",
  (char*)"questiondownsmall",
  (char*)"oneeighth",
  (char*)"threeeighths",
  (char*)"fiveeighths",
  (char*)"seveneighths",
  (char*)"onethird",
  (char*)"twothirds",
  (char*)"zerosuperior",
  (char*)"foursuperior",
  (char*)"fivesuperior",
  (char*)"sixsuperior",
  (char*)"sevensuperior",
  (char*)"eightsuperior",
  (char*)"ninesuperior",
  (char*)"zeroinferior",
  (char*)"oneinferior",
  (char*)"twoinferior",
  (char*)"threeinferior",
  (char*)"fourinferior",
  (char*)"fiveinferior",
  (char*)"sixinferior",
  (char*)"seveninferior",
  (char*)"eightinferior",
  (char*)"nineinferior",
  (char*)"centinferior",
  (char*)"dollarinferior",
  (char*)"periodinferior",
  (char*)"commainferior",
  (char*)"Agravesmall",
  (char*)"Aacutesmall",
  (char*)"Acircumflexsmall",
  (char*)"Atildesmall",
  (char*)"Adieresissmall",
  (char*)"Aringsmall",
  (char*)"AEsmall",
  (char*)"Ccedillasmall",
  (char*)"Egravesmall",
  (char*)"Eacutesmall",
  (char*)"Ecircumflexsmall",
  (char*)"Edieresissmall",
  (char*)"Igravesmall",
  (char*)"Iacutesmall",
  (char*)"Icircumflexsmall",
  (char*)"Idieresissmall",
  (char*)"Ethsmall",
  (char*)"Ntildesmall",
  (char*)"Ogravesmall",
  (char*)"Oacutesmall",
  (char*)"Ocircumflexsmall",
  (char*)"Otildesmall",
  (char*)"Odieresissmall",
  (char*)"OEsmall",
  (char*)"Oslashsmall",
  (char*)"Ugravesmall",
  (char*)"Uacutesmall",
  (char*)"Ucircumflexsmall",
  (char*)"Udieresissmall",
  (char*)"Yacutesmall",
  (char*)"Thornsmall",
  (char*)"Ydieresissmall",
  (char*)"001.000",
  (char*)"001.001",
  (char*)"001.002",
  (char*)"001.003",
  (char*)"Black",
  (char*)"Bold",
  (char*)"Book",
  (char*)"Light",
  (char*)"Medium",
  (char*)"Regular",
  (char*)"Roman",
  (char*)"Semibold"
};

Gushort fofiType1CISOAdobeCharset[229] = {
    0,   1,   2,   3,   4,   5,   6,   7,   8,   9,
   10,  11,  12,  13,  14,  15,  16,  17,  18,  19,
   20,  21,  22,  23,  24,  25,  26,  27,  28,  29,
   30,  31,  32,  33,  34,  35,  36,  37,  38,  39,
   40,  41,  42,  43,  44,  45,  46,  47,  48,  49,
   50,  51,  52,  53,  54,  55,  56,  57,  58,  59,
   60,  61,  62,  63,  64,  65,  66,  67,  68,  69,
   70,  71,  72,  73,  74,  75,  76,  77,  78,  79,
   80,  81,  82,  83,  84,  85,  86,  87,  88,  89,
   90,  91,  92,  93,  94,  95,  96,  97,  98,  99,
  100, 101, 102, 103, 104, 105, 106, 107, 108, 109,
  110, 111, 112, 113, 114, 115, 116, 117, 118, 119,
  120, 121, 122, 123, 124, 125, 126, 127, 128, 129,
  130, 131, 132, 133, 134, 135, 136, 137, 138, 139,
  140, 141, 142, 143, 144, 145, 146, 147, 148, 149,
  150, 151, 152, 153, 154, 155, 156, 157, 158, 159,
  160, 161, 162, 163, 164, 165, 166, 167, 168, 169,
  170, 171, 172, 173, 174, 175, 176, 177, 178, 179,
  180, 181, 182, 183, 184, 185, 186, 187, 188, 189,
  190, 191, 192, 193, 194, 195, 196, 197, 198, 199,
  200, 201, 202, 203, 204, 205, 206, 207, 208, 209,
  210, 211, 212, 213, 214, 215, 216, 217, 218, 219,
  220, 221, 222, 223, 224, 225, 226, 227, 228
};

Gushort fofiType1CExpertCharset[166] = {
    0,   1, 229, 230, 231, 232, 233, 234, 235, 236,
  237, 238,  13,  14,  15,  99, 239, 240, 241, 242,
  243, 244, 245, 246, 247, 248,  27,  28, 249, 250,
  251, 252, 253, 254, 255, 256, 257, 258, 259, 260,
  261, 262, 263, 264, 265, 266, 109, 110, 267, 268,
  269, 270, 271, 272, 273, 274, 275, 276, 277, 278,
  279, 280, 281, 282, 283, 284, 285, 286, 287, 288,
  289, 290, 291, 292, 293, 294, 295, 296, 297, 298,
  299, 300, 301, 302, 303, 304, 305, 306, 307, 308,
  309, 310, 311, 312, 313, 314, 315, 316, 317, 318,
  158, 155, 163, 319, 320, 321, 322, 323, 324, 325,
  326, 150, 164, 169, 327, 328, 329, 330, 331, 332,
  333, 334, 335, 336, 337, 338, 339, 340, 341, 342,
  343, 344, 345, 346, 347, 348, 349, 350, 351, 352,
  353, 354, 355, 356, 357, 358, 359, 360, 361, 362,
  363, 364, 365, 366, 367, 368, 369, 370, 371, 372,
  373, 374, 375, 376, 377, 378
};

Gushort fofiType1CExpertSubsetCharset[87] = {
    0,   1, 231, 232, 235, 236, 237, 238,  13,  14,
   15,  99, 239, 240, 241, 242, 243, 244, 245, 246,
  247, 248,  27,  28, 249, 250, 251, 253, 254, 255,
  256, 257, 258, 259, 260, 261, 262, 263, 264, 265,
  266, 109, 110, 267, 268, 269, 270, 272, 300, 301,
  302, 305, 314, 315, 158, 155, 163, 320, 321, 322,
  323, 324, 325, 326, 150, 164, 169, 327, 328, 329,
  330, 331, 332, 333, 334, 335, 336, 337, 338, 339,
  340, 341, 342, 343, 344, 345, 346
};
