//========================================================================
//
// FontEncodingTables.cc
//
// Copyright 2001-2003 Glyph & Cog, LLC
//
//========================================================================

#include <aconf.h>
#include <stdlib.h>
#include "FontEncodingTables.h"

char *macRomanEncoding[256] = {
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"space",
  (char*)"exclam",
  (char*)"quotedbl",
  (char*)"numbersign",
  (char*)"dollar",
  (char*)"percent",
  (char*)"ampersand",
  (char*)"quotesingle",
  (char*)"parenleft",
  (char*)"parenright",
  (char*)"asterisk",
  (char*)"plus",
  (char*)"comma",
  (char*)"hyphen",
  (char*)"period",
  (char*)"slash",
  (char*)"zero",
  (char*)"one",
  (char*)"two",
  (char*)"three",
  (char*)"four",
  (char*)"five",
  (char*)"six",
  (char*)"seven",
  (char*)"eight",
  (char*)"nine",
  (char*)"colon",
  (char*)"semicolon",
  (char*)"less",
  (char*)"equal",
  (char*)"greater",
  (char*)"question",
  (char*)"at",
  (char*)"A",
  (char*)"B",
  (char*)"C",
  (char*)"D",
  (char*)"E",
  (char*)"F",
  (char*)"G",
  (char*)"H",
  (char*)"I",
  (char*)"J",
  (char*)"K",
  (char*)"L",
  (char*)"M",
  (char*)"N",
  (char*)"O",
  (char*)"P",
  (char*)"Q",
  (char*)"R",
  (char*)"S",
  (char*)"T",
  (char*)"U",
  (char*)"V",
  (char*)"W",
  (char*)"X",
  (char*)"Y",
  (char*)"Z",
  (char*)"bracketleft",
  (char*)"backslash",
  (char*)"bracketright",
  (char*)"asciicircum",
  (char*)"underscore",
  (char*)"grave",
  (char*)"a",
  (char*)"b",
  (char*)"c",
  (char*)"d",
  (char*)"e",
  (char*)"f",
  (char*)"g",
  (char*)"h",
  (char*)"i",
  (char*)"j",
  (char*)"k",
  (char*)"l",
  (char*)"m",
  (char*)"n",
  (char*)"o",
  (char*)"p",
  (char*)"q",
  (char*)"r",
  (char*)"s",
  (char*)"t",
  (char*)"u",
  (char*)"v",
  (char*)"w",
  (char*)"x",
  (char*)"y",
  (char*)"z",
  (char*)"braceleft",
  (char*)"bar",
  (char*)"braceright",
  (char*)"asciitilde",
  NULL,
  (char*)"Adieresis",
  (char*)"Aring",
  (char*)"Ccedilla",
  (char*)"Eacute",
  (char*)"Ntilde",
  (char*)"Odieresis",
  (char*)"Udieresis",
  (char*)"aacute",
  (char*)"agrave",
  (char*)"acircumflex",
  (char*)"adieresis",
  (char*)"atilde",
  (char*)"aring",
  (char*)"ccedilla",
  (char*)"eacute",
  (char*)"egrave",
  (char*)"ecircumflex",
  (char*)"edieresis",
  (char*)"iacute",
  (char*)"igrave",
  (char*)"icircumflex",
  (char*)"idieresis",
  (char*)"ntilde",
  (char*)"oacute",
  (char*)"ograve",
  (char*)"ocircumflex",
  (char*)"odieresis",
  (char*)"otilde",
  (char*)"uacute",
  (char*)"ugrave",
  (char*)"ucircumflex",
  (char*)"udieresis",
  (char*)"dagger",
  (char*)"degree",
  (char*)"cent",
  (char*)"sterling",
  (char*)"section",
  (char*)"bullet",
  (char*)"paragraph",
  (char*)"germandbls",
  (char*)"registered",
  (char*)"copyright",
  (char*)"trademark",
  (char*)"acute",
  (char*)"dieresis",
  (char*)"notequal",
  (char*)"AE",
  (char*)"Oslash",
  (char*)"infinity",
  (char*)"plusminus",
  (char*)"lessequal",
  (char*)"greaterequal",
  (char*)"yen",
  (char*)"mu",
  (char*)"partialdiff",
  (char*)"summation",
  (char*)"product",
  (char*)"pi",
  (char*)"integral",
  (char*)"ordfeminine",
  (char*)"ordmasculine",
  (char*)"Omega",
  (char*)"ae",
  (char*)"oslash",
  (char*)"questiondown",
  (char*)"exclamdown",
  (char*)"logicalnot",
  (char*)"radical",
  (char*)"florin",
  (char*)"approxequal",
  (char*)"Delta",
  (char*)"guillemotleft",
  (char*)"guillemotright",
  (char*)"ellipsis",
  (char*)"space",
  (char*)"Agrave",
  (char*)"Atilde",
  (char*)"Otilde",
  (char*)"OE",
  (char*)"oe",
  (char*)"endash",
  (char*)"emdash",
  (char*)"quotedblleft",
  (char*)"quotedblright",
  (char*)"quoteleft",
  (char*)"quoteright",
  (char*)"divide",
  (char*)"lozenge",
  (char*)"ydieresis",
  (char*)"Ydieresis",
  (char*)"fraction",
  (char*)"currency",
  (char*)"guilsinglleft",
  (char*)"guilsinglright",
  (char*)"fi",
  (char*)"fl",
  (char*)"daggerdbl",
  (char*)"periodcentered",
  (char*)"quotesinglbase",
  (char*)"quotedblbase",
  (char*)"perthousand",
  (char*)"Acircumflex",
  (char*)"Ecircumflex",
  (char*)"Aacute",
  (char*)"Edieresis",
  (char*)"Egrave",
  (char*)"Iacute",
  (char*)"Icircumflex",
  (char*)"Idieresis",
  (char*)"Igrave",
  (char*)"Oacute",
  (char*)"Ocircumflex",
  (char*)"apple",
  (char*)"Ograve",
  (char*)"Uacute",
  (char*)"Ucircumflex",
  (char*)"Ugrave",
  (char*)"dotlessi",
  (char*)"circumflex",
  (char*)"tilde",
  (char*)"macron",
  (char*)"breve",
  (char*)"dotaccent",
  (char*)"ring",
  (char*)"cedilla",
  (char*)"hungarumlaut",
  (char*)"ogonek",
  (char*)"caron"
};

char *macExpertEncoding[256] = {
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"space",
  (char*)"exclamsmall",
  (char*)"Hungarumlautsmall",
  (char*)"centoldstyle",
  (char*)"dollaroldstyle",
  (char*)"dollarsuperior",
  (char*)"ampersandsmall",
  (char*)"Acutesmall",
  (char*)"parenleftsuperior",
  (char*)"parenrightsuperior",
  (char*)"twodotenleader",
  (char*)"onedotenleader",
  (char*)"comma",
  (char*)"hyphen",
  (char*)"period",
  (char*)"fraction",
  (char*)"zerooldstyle",
  (char*)"oneoldstyle",
  (char*)"twooldstyle",
  (char*)"threeoldstyle",
  (char*)"fouroldstyle",
  (char*)"fiveoldstyle",
  (char*)"sixoldstyle",
  (char*)"sevenoldstyle",
  (char*)"eightoldstyle",
  (char*)"nineoldstyle",
  (char*)"colon",
  (char*)"semicolon",
  NULL,
  (char*)"threequartersemdash",
  NULL,
  (char*)"questionsmall",
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"Ethsmall",
  NULL,
  NULL,
  (char*)"onequarter",
  (char*)"onehalf",
  (char*)"threequarters",
  (char*)"oneeighth",
  (char*)"threeeighths",
  (char*)"fiveeighths",
  (char*)"seveneighths",
  (char*)"onethird",
  (char*)"twothirds",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"ff",
  (char*)"fi",
  (char*)"fl",
  (char*)"ffi",
  (char*)"ffl",
  (char*)"parenleftinferior",
  NULL,
  (char*)"parenrightinferior",
  (char*)"Circumflexsmall",
  (char*)"hypheninferior",
  (char*)"Gravesmall",
  (char*)"Asmall",
  (char*)"Bsmall",
  (char*)"Csmall",
  (char*)"Dsmall",
  (char*)"Esmall",
  (char*)"Fsmall",
  (char*)"Gsmall",
  (char*)"Hsmall",
  (char*)"Ismall",
  (char*)"Jsmall",
  (char*)"Ksmall",
  (char*)"Lsmall",
  (char*)"Msmall",
  (char*)"Nsmall",
  (char*)"Osmall",
  (char*)"Psmall",
  (char*)"Qsmall",
  (char*)"Rsmall",
  (char*)"Ssmall",
  (char*)"Tsmall",
  (char*)"Usmall",
  (char*)"Vsmall",
  (char*)"Wsmall",
  (char*)"Xsmall",
  (char*)"Ysmall",
  (char*)"Zsmall",
  (char*)"colonmonetary",
  (char*)"onefitted",
  (char*)"rupiah",
  (char*)"Tildesmall",
  NULL,
  NULL,
  (char*)"asuperior",
  (char*)"centsuperior",
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"Aacutesmall",
  (char*)"Agravesmall",
  (char*)"Acircumflexsmall",
  (char*)"Adieresissmall",
  (char*)"Atildesmall",
  (char*)"Aringsmall",
  (char*)"Ccedillasmall",
  (char*)"Eacutesmall",
  (char*)"Egravesmall",
  (char*)"Ecircumflexsmall",
  (char*)"Edieresissmall",
  (char*)"Iacutesmall",
  (char*)"Igravesmall",
  (char*)"Icircumflexsmall",
  (char*)"Idieresissmall",
  (char*)"Ntildesmall",
  (char*)"Oacutesmall",
  (char*)"Ogravesmall",
  (char*)"Ocircumflexsmall",
  (char*)"Odieresissmall",
  (char*)"Otildesmall",
  (char*)"Uacutesmall",
  (char*)"Ugravesmall",
  (char*)"Ucircumflexsmall",
  (char*)"Udieresissmall",
  NULL,
  (char*)"eightsuperior",
  (char*)"fourinferior",
  (char*)"threeinferior",
  (char*)"sixinferior",
  (char*)"eightinferior",
  (char*)"seveninferior",
  (char*)"Scaronsmall",
  NULL,
  (char*)"centinferior",
  (char*)"twoinferior",
  NULL,
  (char*)"Dieresissmall",
  NULL,
  (char*)"Caronsmall",
  (char*)"osuperior",
  (char*)"fiveinferior",
  NULL,
  (char*)"commainferior",
  (char*)"periodinferior",
  (char*)"Yacutesmall",
  NULL,
  (char*)"dollarinferior",
  NULL,
  NULL,
  (char*)"Thornsmall",
  NULL,
  (char*)"nineinferior",
  (char*)"zeroinferior",
  (char*)"Zcaronsmall",
  (char*)"AEsmall",
  (char*)"Oslashsmall",
  (char*)"questiondownsmall",
  (char*)"oneinferior",
  (char*)"Lslashsmall",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"Cedillasmall",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"OEsmall",
  (char*)"figuredash",
  (char*)"hyphensuperior",
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"exclamdownsmall",
  NULL,
  (char*)"Ydieresissmall",
  NULL,
  (char*)"onesuperior",
  (char*)"twosuperior",
  (char*)"threesuperior",
  (char*)"foursuperior",
  (char*)"fivesuperior",
  (char*)"sixsuperior",
  (char*)"sevensuperior",
  (char*)"ninesuperior",
  (char*)"zerosuperior",
  NULL,
  (char*)"esuperior",
  (char*)"rsuperior",
  (char*)"tsuperior",
  NULL,
  NULL,
  (char*)"isuperior",
  (char*)"ssuperior",
  (char*)"dsuperior",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"lsuperior",
  (char*)"Ogoneksmall",
  (char*)"Brevesmall",
  (char*)"Macronsmall",
  (char*)"bsuperior",
  (char*)"nsuperior",
  (char*)"msuperior",
  (char*)"commasuperior",
  (char*)"periodsuperior",
  (char*)"Dotaccentsmall",
  (char*)"Ringsmall",
  NULL,
  NULL,
  NULL,
  NULL
};

char *winAnsiEncoding[256] = {
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"space",
  (char*)"exclam",
  (char*)"quotedbl",
  (char*)"numbersign",
  (char*)"dollar",
  (char*)"percent",
  (char*)"ampersand",
  (char*)"quotesingle",
  (char*)"parenleft",
  (char*)"parenright",
  (char*)"asterisk",
  (char*)"plus",
  (char*)"comma",
  (char*)"hyphen",
  (char*)"period",
  (char*)"slash",
  (char*)"zero",
  (char*)"one",
  (char*)"two",
  (char*)"three",
  (char*)"four",
  (char*)"five",
  (char*)"six",
  (char*)"seven",
  (char*)"eight",
  (char*)"nine",
  (char*)"colon",
  (char*)"semicolon",
  (char*)"less",
  (char*)"equal",
  (char*)"greater",
  (char*)"question",
  (char*)"at",
  (char*)"A",
  (char*)"B",
  (char*)"C",
  (char*)"D",
  (char*)"E",
  (char*)"F",
  (char*)"G",
  (char*)"H",
  (char*)"I",
  (char*)"J",
  (char*)"K",
  (char*)"L",
  (char*)"M",
  (char*)"N",
  (char*)"O",
  (char*)"P",
  (char*)"Q",
  (char*)"R",
  (char*)"S",
  (char*)"T",
  (char*)"U",
  (char*)"V",
  (char*)"W",
  (char*)"X",
  (char*)"Y",
  (char*)"Z",
  (char*)"bracketleft",
  (char*)"backslash",
  (char*)"bracketright",
  (char*)"asciicircum",
  (char*)"underscore",
  (char*)"grave",
  (char*)"a",
  (char*)"b",
  (char*)"c",
  (char*)"d",
  (char*)"e",
  (char*)"f",
  (char*)"g",
  (char*)"h",
  (char*)"i",
  (char*)"j",
  (char*)"k",
  (char*)"l",
  (char*)"m",
  (char*)"n",
  (char*)"o",
  (char*)"p",
  (char*)"q",
  (char*)"r",
  (char*)"s",
  (char*)"t",
  (char*)"u",
  (char*)"v",
  (char*)"w",
  (char*)"x",
  (char*)"y",
  (char*)"z",
  (char*)"braceleft",
  (char*)"bar",
  (char*)"braceright",
  (char*)"asciitilde",
  (char*)"bullet",
  (char*)"Euro",
  (char*)"bullet",
  (char*)"quotesinglbase",
  (char*)"florin",
  (char*)"quotedblbase",
  (char*)"ellipsis",
  (char*)"dagger",
  (char*)"daggerdbl",
  (char*)"circumflex",
  (char*)"perthousand",
  (char*)"Scaron",
  (char*)"guilsinglleft",
  (char*)"OE",
  (char*)"bullet",
  (char*)"Zcaron",
  (char*)"bullet",
  (char*)"bullet",
  (char*)"quoteleft",
  (char*)"quoteright",
  (char*)"quotedblleft",
  (char*)"quotedblright",
  (char*)"bullet",
  (char*)"endash",
  (char*)"emdash",
  (char*)"tilde",
  (char*)"trademark",
  (char*)"scaron",
  (char*)"guilsinglright",
  (char*)"oe",
  (char*)"bullet",
  (char*)"zcaron",
  (char*)"Ydieresis",
  (char*)"space",
  (char*)"exclamdown",
  (char*)"cent",
  (char*)"sterling",
  (char*)"currency",
  (char*)"yen",
  (char*)"brokenbar",
  (char*)"section",
  (char*)"dieresis",
  (char*)"copyright",
  (char*)"ordfeminine",
  (char*)"guillemotleft",
  (char*)"logicalnot",
  (char*)"hyphen",
  (char*)"registered",
  (char*)"macron",
  (char*)"degree",
  (char*)"plusminus",
  (char*)"twosuperior",
  (char*)"threesuperior",
  (char*)"acute",
  (char*)"mu",
  (char*)"paragraph",
  (char*)"periodcentered",
  (char*)"cedilla",
  (char*)"onesuperior",
  (char*)"ordmasculine",
  (char*)"guillemotright",
  (char*)"onequarter",
  (char*)"onehalf",
  (char*)"threequarters",
  (char*)"questiondown",
  (char*)"Agrave",
  (char*)"Aacute",
  (char*)"Acircumflex",
  (char*)"Atilde",
  (char*)"Adieresis",
  (char*)"Aring",
  (char*)"AE",
  (char*)"Ccedilla",
  (char*)"Egrave",
  (char*)"Eacute",
  (char*)"Ecircumflex",
  (char*)"Edieresis",
  (char*)"Igrave",
  (char*)"Iacute",
  (char*)"Icircumflex",
  (char*)"Idieresis",
  (char*)"Eth",
  (char*)"Ntilde",
  (char*)"Ograve",
  (char*)"Oacute",
  (char*)"Ocircumflex",
  (char*)"Otilde",
  (char*)"Odieresis",
  (char*)"multiply",
  (char*)"Oslash",
  (char*)"Ugrave",
  (char*)"Uacute",
  (char*)"Ucircumflex",
  (char*)"Udieresis",
  (char*)"Yacute",
  (char*)"Thorn",
  (char*)"germandbls",
  (char*)"agrave",
  (char*)"aacute",
  (char*)"acircumflex",
  (char*)"atilde",
  (char*)"adieresis",
  (char*)"aring",
  (char*)"ae",
  (char*)"ccedilla",
  (char*)"egrave",
  (char*)"eacute",
  (char*)"ecircumflex",
  (char*)"edieresis",
  (char*)"igrave",
  (char*)"iacute",
  (char*)"icircumflex",
  (char*)"idieresis",
  (char*)"eth",
  (char*)"ntilde",
  (char*)"ograve",
  (char*)"oacute",
  (char*)"ocircumflex",
  (char*)"otilde",
  (char*)"odieresis",
  (char*)"divide",
  (char*)"oslash",
  (char*)"ugrave",
  (char*)"uacute",
  (char*)"ucircumflex",
  (char*)"udieresis",
  (char*)"yacute",
  (char*)"thorn",
  (char*)"ydieresis"
};

char *standardEncoding[256] = {
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"space",
  (char*)"exclam",
  (char*)"quotedbl",
  (char*)"numbersign",
  (char*)"dollar",
  (char*)"percent",
  (char*)"ampersand",
  (char*)"quoteright",
  (char*)"parenleft",
  (char*)"parenright",
  (char*)"asterisk",
  (char*)"plus",
  (char*)"comma",
  (char*)"hyphen",
  (char*)"period",
  (char*)"slash",
  (char*)"zero",
  (char*)"one",
  (char*)"two",
  (char*)"three",
  (char*)"four",
  (char*)"five",
  (char*)"six",
  (char*)"seven",
  (char*)"eight",
  (char*)"nine",
  (char*)"colon",
  (char*)"semicolon",
  (char*)"less",
  (char*)"equal",
  (char*)"greater",
  (char*)"question",
  (char*)"at",
  (char*)"A",
  (char*)"B",
  (char*)"C",
  (char*)"D",
  (char*)"E",
  (char*)"F",
  (char*)"G",
  (char*)"H",
  (char*)"I",
  (char*)"J",
  (char*)"K",
  (char*)"L",
  (char*)"M",
  (char*)"N",
  (char*)"O",
  (char*)"P",
  (char*)"Q",
  (char*)"R",
  (char*)"S",
  (char*)"T",
  (char*)"U",
  (char*)"V",
  (char*)"W",
  (char*)"X",
  (char*)"Y",
  (char*)"Z",
  (char*)"bracketleft",
  (char*)"backslash",
  (char*)"bracketright",
  (char*)"asciicircum",
  (char*)"underscore",
  (char*)"quoteleft",
  (char*)"a",
  (char*)"b",
  (char*)"c",
  (char*)"d",
  (char*)"e",
  (char*)"f",
  (char*)"g",
  (char*)"h",
  (char*)"i",
  (char*)"j",
  (char*)"k",
  (char*)"l",
  (char*)"m",
  (char*)"n",
  (char*)"o",
  (char*)"p",
  (char*)"q",
  (char*)"r",
  (char*)"s",
  (char*)"t",
  (char*)"u",
  (char*)"v",
  (char*)"w",
  (char*)"x",
  (char*)"y",
  (char*)"z",
  (char*)"braceleft",
  (char*)"bar",
  (char*)"braceright",
  (char*)"asciitilde",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"exclamdown",
  (char*)"cent",
  (char*)"sterling",
  (char*)"fraction",
  (char*)"yen",
  (char*)"florin",
  (char*)"section",
  (char*)"currency",
  (char*)"quotesingle",
  (char*)"quotedblleft",
  (char*)"guillemotleft",
  (char*)"guilsinglleft",
  (char*)"guilsinglright",
  (char*)"fi",
  (char*)"fl",
  NULL,
  (char*)"endash",
  (char*)"dagger",
  (char*)"daggerdbl",
  (char*)"periodcentered",
  NULL,
  (char*)"paragraph",
  (char*)"bullet",
  (char*)"quotesinglbase",
  (char*)"quotedblbase",
  (char*)"quotedblright",
  (char*)"guillemotright",
  (char*)"ellipsis",
  (char*)"perthousand",
  NULL,
  (char*)"questiondown",
  NULL,
  (char*)"grave",
  (char*)"acute",
  (char*)"circumflex",
  (char*)"tilde",
  (char*)"macron",
  (char*)"breve",
  (char*)"dotaccent",
  (char*)"dieresis",
  NULL,
  (char*)"ring",
  (char*)"cedilla",
  NULL,
  (char*)"hungarumlaut",
  (char*)"ogonek",
  (char*)"caron",
  (char*)"emdash",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"AE",
  NULL,
  (char*)"ordfeminine",
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"Lslash",
  (char*)"Oslash",
  (char*)"OE",
  (char*)"ordmasculine",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"ae",
  NULL,
  NULL,
  NULL,
  (char*)"dotlessi",
  NULL,
  NULL,
  (char*)"lslash",
  (char*)"oslash",
  (char*)"oe",
  (char*)"germandbls",
  NULL,
  NULL,
  NULL,
  NULL
};

char *expertEncoding[256] = {
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"space",
  (char*)"exclamsmall",
  (char*)"Hungarumlautsmall",
  NULL,
  (char*)"dollaroldstyle",
  (char*)"dollarsuperior",
  (char*)"ampersandsmall",
  (char*)"Acutesmall",
  (char*)"parenleftsuperior",
  (char*)"parenrightsuperior",
  (char*)"twodotenleader",
  (char*)"onedotenleader",
  (char*)"comma",
  (char*)"hyphen",
  (char*)"period",
  (char*)"fraction",
  (char*)"zerooldstyle",
  (char*)"oneoldstyle",
  (char*)"twooldstyle",
  (char*)"threeoldstyle",
  (char*)"fouroldstyle",
  (char*)"fiveoldstyle",
  (char*)"sixoldstyle",
  (char*)"sevenoldstyle",
  (char*)"eightoldstyle",
  (char*)"nineoldstyle",
  (char*)"colon",
  (char*)"semicolon",
  (char*)"commasuperior",
  (char*)"threequartersemdash",
  (char*)"periodsuperior",
  (char*)"questionsmall",
  NULL,
  (char*)"asuperior",
  (char*)"bsuperior",
  (char*)"centsuperior",
  (char*)"dsuperior",
  (char*)"esuperior",
  NULL,
  NULL,
  NULL,
  (char*)"isuperior",
  NULL,
  NULL,
  (char*)"lsuperior",
  (char*)"msuperior",
  (char*)"nsuperior",
  (char*)"osuperior",
  NULL,
  NULL,
  (char*)"rsuperior",
  (char*)"ssuperior",
  (char*)"tsuperior",
  NULL,
  (char*)"ff",
  (char*)"fi",
  (char*)"fl",
  (char*)"ffi",
  (char*)"ffl",
  (char*)"parenleftinferior",
  NULL,
  (char*)"parenrightinferior",
  (char*)"Circumflexsmall",
  (char*)"hyphensuperior",
  (char*)"Gravesmall",
  (char*)"Asmall",
  (char*)"Bsmall",
  (char*)"Csmall",
  (char*)"Dsmall",
  (char*)"Esmall",
  (char*)"Fsmall",
  (char*)"Gsmall",
  (char*)"Hsmall",
  (char*)"Ismall",
  (char*)"Jsmall",
  (char*)"Ksmall",
  (char*)"Lsmall",
  (char*)"Msmall",
  (char*)"Nsmall",
  (char*)"Osmall",
  (char*)"Psmall",
  (char*)"Qsmall",
  (char*)"Rsmall",
  (char*)"Ssmall",
  (char*)"Tsmall",
  (char*)"Usmall",
  (char*)"Vsmall",
  (char*)"Wsmall",
  (char*)"Xsmall",
  (char*)"Ysmall",
  (char*)"Zsmall",
  (char*)"colonmonetary",
  (char*)"onefitted",
  (char*)"rupiah",
  (char*)"Tildesmall",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"exclamdownsmall",
  (char*)"centoldstyle",
  (char*)"Lslashsmall",
  NULL,
  NULL,
  (char*)"Scaronsmall",
  (char*)"Zcaronsmall",
  (char*)"Dieresissmall",
  (char*)"Brevesmall",
  (char*)"Caronsmall",
  NULL,
  (char*)"Dotaccentsmall",
  NULL,
  NULL,
  (char*)"Macronsmall",
  NULL,
  NULL,
  (char*)"figuredash",
  (char*)"hypheninferior",
  NULL,
  NULL,
  (char*)"Ogoneksmall",
  (char*)"Ringsmall",
  (char*)"Cedillasmall",
  NULL,
  NULL,
  NULL,
  (char*)"onequarter",
  (char*)"onehalf",
  (char*)"threequarters",
  (char*)"questiondownsmall",
  (char*)"oneeighth",
  (char*)"threeeighths",
  (char*)"fiveeighths",
  (char*)"seveneighths",
  (char*)"onethird",
  (char*)"twothirds",
  NULL,
  NULL,
  (char*)"zerosuperior",
  (char*)"onesuperior",
  (char*)"twosuperior",
  (char*)"threesuperior",
  (char*)"foursuperior",
  (char*)"fivesuperior",
  (char*)"sixsuperior",
  (char*)"sevensuperior",
  (char*)"eightsuperior",
  (char*)"ninesuperior",
  (char*)"zeroinferior",
  (char*)"oneinferior",
  (char*)"twoinferior",
  (char*)"threeinferior",
  (char*)"fourinferior",
  (char*)"fiveinferior",
  (char*)"sixinferior",
  (char*)"seveninferior",
  (char*)"eightinferior",
  (char*)"nineinferior",
  (char*)"centinferior",
  (char*)"dollarinferior",
  (char*)"periodinferior",
  (char*)"commainferior",
  (char*)"Agravesmall",
  (char*)"Aacutesmall",
  (char*)"Acircumflexsmall",
  (char*)"Atildesmall",
  (char*)"Adieresissmall",
  (char*)"Aringsmall",
  (char*)"AEsmall",
  (char*)"Ccedillasmall",
  (char*)"Egravesmall",
  (char*)"Eacutesmall",
  (char*)"Ecircumflexsmall",
  (char*)"Edieresissmall",
  (char*)"Igravesmall",
  (char*)"Iacutesmall",
  (char*)"Icircumflexsmall",
  (char*)"Idieresissmall",
  (char*)"Ethsmall",
  (char*)"Ntildesmall",
  (char*)"Ogravesmall",
  (char*)"Oacutesmall",
  (char*)"Ocircumflexsmall",
  (char*)"Otildesmall",
  (char*)"Odieresissmall",
  (char*)"OEsmall",
  (char*)"Oslashsmall",
  (char*)"Ugravesmall",
  (char*)"Uacutesmall",
  (char*)"Ucircumflexsmall",
  (char*)"Udieresissmall",
  (char*)"Yacutesmall",
  (char*)"Thornsmall",
  (char*)"Ydieresissmall"
};

char *symbolEncoding[256] = {
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"space",
  (char*)"exclam",
  (char*)"universal",
  (char*)"numbersign",
  (char*)"existential",
  (char*)"percent",
  (char*)"ampersand",
  (char*)"suchthat",
  (char*)"parenleft",
  (char*)"parenright",
  (char*)"asteriskmath",
  (char*)"plus",
  (char*)"comma",
  (char*)"minus",
  (char*)"period",
  (char*)"slash",
  (char*)"zero",
  (char*)"one",
  (char*)"two",
  (char*)"three",
  (char*)"four",
  (char*)"five",
  (char*)"six",
  (char*)"seven",
  (char*)"eight",
  (char*)"nine",
  (char*)"colon",
  (char*)"semicolon",
  (char*)"less",
  (char*)"equal",
  (char*)"greater",
  (char*)"question",
  (char*)"congruent",
  (char*)"Alpha",
  (char*)"Beta",
  (char*)"Chi",
  (char*)"Delta",
  (char*)"Epsilon",
  (char*)"Phi",
  (char*)"Gamma",
  (char*)"Eta",
  (char*)"Iota",
  (char*)"theta1",
  (char*)"Kappa",
  (char*)"Lambda",
  (char*)"Mu",
  (char*)"Nu",
  (char*)"Omicron",
  (char*)"Pi",
  (char*)"Theta",
  (char*)"Rho",
  (char*)"Sigma",
  (char*)"Tau",
  (char*)"Upsilon",
  (char*)"sigma1",
  (char*)"Omega",
  (char*)"Xi",
  (char*)"Psi",
  (char*)"Zeta",
  (char*)"bracketleft",
  (char*)"therefore",
  (char*)"bracketright",
  (char*)"perpendicular",
  (char*)"underscore",
  (char*)"radicalex",
  (char*)"alpha",
  (char*)"beta",
  (char*)"chi",
  (char*)"delta",
  (char*)"epsilon",
  (char*)"phi",
  (char*)"gamma",
  (char*)"eta",
  (char*)"iota",
  (char*)"phi1",
  (char*)"kappa",
  (char*)"lambda",
  (char*)"mu",
  (char*)"nu",
  (char*)"omicron",
  (char*)"pi",
  (char*)"theta",
  (char*)"rho",
  (char*)"sigma",
  (char*)"tau",
  (char*)"upsilon",
  (char*)"omega1",
  (char*)"omega",
  (char*)"xi",
  (char*)"psi",
  (char*)"zeta",
  (char*)"braceleft",
  (char*)"bar",
  (char*)"braceright",
  (char*)"similar",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"Upsilon1",
  (char*)"minute",
  (char*)"lessequal",
  (char*)"fraction",
  (char*)"infinity",
  (char*)"florin",
  (char*)"club",
  (char*)"diamond",
  (char*)"heart",
  (char*)"spade",
  (char*)"arrowboth",
  (char*)"arrowleft",
  (char*)"arrowup",
  (char*)"arrowright",
  (char*)"arrowdown",
  (char*)"degree",
  (char*)"plusminus",
  (char*)"second",
  (char*)"greaterequal",
  (char*)"multiply",
  (char*)"proportional",
  (char*)"partialdiff",
  (char*)"bullet",
  (char*)"divide",
  (char*)"notequal",
  (char*)"equivalence",
  (char*)"approxequal",
  (char*)"ellipsis",
  (char*)"arrowvertex",
  (char*)"arrowhorizex",
  (char*)"carriagereturn",
  (char*)"aleph",
  (char*)"Ifraktur",
  (char*)"Rfraktur",
  (char*)"weierstrass",
  (char*)"circlemultiply",
  (char*)"circleplus",
  (char*)"emptyset",
  (char*)"intersection",
  (char*)"union",
  (char*)"propersuperset",
  (char*)"reflexsuperset",
  (char*)"notsubset",
  (char*)"propersubset",
  (char*)"reflexsubset",
  (char*)"element",
  (char*)"notelement",
  (char*)"angle",
  (char*)"gradient",
  (char*)"registerserif",
  (char*)"copyrightserif",
  (char*)"trademarkserif",
  (char*)"product",
  (char*)"radical",
  (char*)"dotmath",
  (char*)"logicalnot",
  (char*)"logicaland",
  (char*)"logicalor",
  (char*)"arrowdblboth",
  (char*)"arrowdblleft",
  (char*)"arrowdblup",
  (char*)"arrowdblright",
  (char*)"arrowdbldown",
  (char*)"lozenge",
  (char*)"angleleft",
  (char*)"registersans",
  (char*)"copyrightsans",
  (char*)"trademarksans",
  (char*)"summation",
  (char*)"parenlefttp",
  (char*)"parenleftex",
  (char*)"parenleftbt",
  (char*)"bracketlefttp",
  (char*)"bracketleftex",
  (char*)"bracketleftbt",
  (char*)"bracelefttp",
  (char*)"braceleftmid",
  (char*)"braceleftbt",
  (char*)"braceex",
  NULL,
  (char*)"angleright",
  (char*)"integral",
  (char*)"integraltp",
  (char*)"integralex",
  (char*)"integralbt",
  (char*)"parenrighttp",
  (char*)"parenrightex",
  (char*)"parenrightbt",
  (char*)"bracketrighttp",
  (char*)"bracketrightex",
  (char*)"bracketrightbt",
  (char*)"bracerighttp",
  (char*)"bracerightmid",
  (char*)"bracerightbt",
  NULL
};

char *zapfDingbatsEncoding[256] = {
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"space",
  (char*)"a1",
  (char*)"a2",
  (char*)"a202",
  (char*)"a3",
  (char*)"a4",
  (char*)"a5",
  (char*)"a119",
  (char*)"a118",
  (char*)"a117",
  (char*)"a11",
  (char*)"a12",
  (char*)"a13",
  (char*)"a14",
  (char*)"a15",
  (char*)"a16",
  (char*)"a105",
  (char*)"a17",
  (char*)"a18",
  (char*)"a19",
  (char*)"a20",
  (char*)"a21",
  (char*)"a22",
  (char*)"a23",
  (char*)"a24",
  (char*)"a25",
  (char*)"a26",
  (char*)"a27",
  (char*)"a28",
  (char*)"a6",
  (char*)"a7",
  (char*)"a8",
  (char*)"a9",
  (char*)"a10",
  (char*)"a29",
  (char*)"a30",
  (char*)"a31",
  (char*)"a32",
  (char*)"a33",
  (char*)"a34",
  (char*)"a35",
  (char*)"a36",
  (char*)"a37",
  (char*)"a38",
  (char*)"a39",
  (char*)"a40",
  (char*)"a41",
  (char*)"a42",
  (char*)"a43",
  (char*)"a44",
  (char*)"a45",
  (char*)"a46",
  (char*)"a47",
  (char*)"a48",
  (char*)"a49",
  (char*)"a50",
  (char*)"a51",
  (char*)"a52",
  (char*)"a53",
  (char*)"a54",
  (char*)"a55",
  (char*)"a56",
  (char*)"a57",
  (char*)"a58",
  (char*)"a59",
  (char*)"a60",
  (char*)"a61",
  (char*)"a62",
  (char*)"a63",
  (char*)"a64",
  (char*)"a65",
  (char*)"a66",
  (char*)"a67",
  (char*)"a68",
  (char*)"a69",
  (char*)"a70",
  (char*)"a71",
  (char*)"a72",
  (char*)"a73",
  (char*)"a74",
  (char*)"a203",
  (char*)"a75",
  (char*)"a204",
  (char*)"a76",
  (char*)"a77",
  (char*)"a78",
  (char*)"a79",
  (char*)"a81",
  (char*)"a82",
  (char*)"a83",
  (char*)"a84",
  (char*)"a97",
  (char*)"a98",
  (char*)"a99",
  (char*)"a100",
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  (char*)"a101",
  (char*)"a102",
  (char*)"a103",
  (char*)"a104",
  (char*)"a106",
  (char*)"a107",
  (char*)"a108",
  (char*)"a112",
  (char*)"a111",
  (char*)"a110",
  (char*)"a109",
  (char*)"a120",
  (char*)"a121",
  (char*)"a122",
  (char*)"a123",
  (char*)"a124",
  (char*)"a125",
  (char*)"a126",
  (char*)"a127",
  (char*)"a128",
  (char*)"a129",
  (char*)"a130",
  (char*)"a131",
  (char*)"a132",
  (char*)"a133",
  (char*)"a134",
  (char*)"a135",
  (char*)"a136",
  (char*)"a137",
  (char*)"a138",
  (char*)"a139",
  (char*)"a140",
  (char*)"a141",
  (char*)"a142",
  (char*)"a143",
  (char*)"a144",
  (char*)"a145",
  (char*)"a146",
  (char*)"a147",
  (char*)"a148",
  (char*)"a149",
  (char*)"a150",
  (char*)"a151",
  (char*)"a152",
  (char*)"a153",
  (char*)"a154",
  (char*)"a155",
  (char*)"a156",
  (char*)"a157",
  (char*)"a158",
  (char*)"a159",
  (char*)"a160",
  (char*)"a161",
  (char*)"a163",
  (char*)"a164",
  (char*)"a196",
  (char*)"a165",
  (char*)"a192",
  (char*)"a166",
  (char*)"a167",
  (char*)"a168",
  (char*)"a169",
  (char*)"a170",
  (char*)"a171",
  (char*)"a172",
  (char*)"a173",
  (char*)"a162",
  (char*)"a174",
  (char*)"a175",
  (char*)"a176",
  (char*)"a177",
  (char*)"a178",
  (char*)"a179",
  (char*)"a193",
  (char*)"a180",
  (char*)"a199",
  (char*)"a181",
  (char*)"a200",
  (char*)"a182",
  NULL,
  (char*)"a201",
  (char*)"a183",
  (char*)"a184",
  (char*)"a197",
  (char*)"a185",
  (char*)"a194",
  (char*)"a198",
  (char*)"a186",
  (char*)"a195",
  (char*)"a187",
  (char*)"a188",
  (char*)"a189",
  (char*)"a190",
  (char*)"a191",
  NULL
};
