/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */

//
// BooleanAndNode
//
// 16 November 2004 -- tds
//

#ifndef VANK_BOOLEANANDNODE_HPP
#define VANK_BOOLEANANDNODE_HPP

#include "vank/ListIteratorNode.hpp"
#include "vank/greedy_vector"
#include "lemur/lemur-platform.h"
#include <vector>
#include <string>
namespace vank
{
  namespace infnet
  {

    class BooleanAndNode : public ListIteratorNode {
      std::vector<ListIteratorNode*> _lists;
      std::string _name;
      vank::utility::greedy_vector<vank::index::Extent> _extents;

    public:
      BooleanAndNode( const std::string& name, std::vector<ListIteratorNode*>& children );

      void prepare( lemur::api::DOCID_T documentID );
      vank::utility::greedy_vector<vank::index::Extent>& extents();
      lemur::api::DOCID_T nextCandidateDocument();
      void indexChanged( vank::index::Index& index );
      const std::string& getName() const;
      void annotate( class Annotator& annotator, lemur::api::DOCID_T documentID, vank::index::Extent &extent);
    };
  }
}

#endif // VANK_BOOLEANANDNODE_HPP
