/*==========================================================================
 * Copyright (c) 2003-2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// Collection
//
// 11 May 2004 -- tds
//

#ifndef VANK_COLLECTION_HPP
#define VANK_COLLECTION_HPP

#include "vank/ObjectHandler.hpp"
#include "vank/ParsedDocument.hpp"
#include "lemur/IndexTypes.hpp"

namespace vank
{
  namespace collection
  {

    class Collection {
    public:
      virtual ~Collection() {};
      virtual void addDocument( lemur::api::DOCID_T documentID, vank::api::ParsedDocument* document ) = 0;
      virtual vank::api::ParsedDocument* retrieve( lemur::api::DOCID_T  documentID ) = 0;
    };
  }
}

#endif // VANK_COLLECTION_HPP
