/*==========================================================================
 * Copyright (c) 2005 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */

//
// DiskDocumentDataIterator
//
// 21 January 2005 -- tds
//

#ifndef VANK_DISKDOCUMENTDATAITERATOR_HPP
#define VANK_DISKDOCUMENTDATAITERATOR_HPP

#include "vank/File.hpp"
#include "vank/SequentialReadBuffer.hpp"
#include "vank/DocumentDataIterator.hpp"
#include "vank/DocumentData.hpp"

namespace vank {
  namespace index {
    class DiskDocumentDataIterator : public DocumentDataIterator {
    private:
      vank::file::SequentialReadBuffer* _readBuffer;
      UINT64 _fileSize;

      DocumentData _documentData;
      vank::file::File& _documentDataFile;
      bool _finished;

    public:
      DiskDocumentDataIterator( vank::file::File& documentDataFile );
      ~DiskDocumentDataIterator();

      void startIteration();
      bool nextEntry();
      const DocumentData* currentEntry();
      bool finished();
    };
  }
}

#endif // VANK_DISKDOCUMENTDATAITERATOR_HPP
