/*==========================================================================
 * Copyright (c) 2005 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */

//
// DiskTermListFileIterator
//
// 25 January 2005 -- tds
//

#ifndef VANK_DISKTERMLISTFILEITERATOR_HPP
#define VANK_DISKTERMLISTFILEITERATOR_HPP

#include "vank/TermListFileIterator.hpp"
#include "vank/SequentialReadBuffer.hpp"
#include "vank/TermList.hpp"
#include "lemur/IndexTypes.hpp"

namespace vank {
  namespace index {
    class DiskTermListFileIterator : public TermListFileIterator {
    private:
      TermList _termList;
      vank::file::File& _termListFile;
      vank::file::SequentialReadBuffer _buffer;
      UINT64 _fileSize;
      bool _finished;
      int _currentDocument;

    public:
      DiskTermListFileIterator( vank::file::File& termListFile );

      void startIteration();
      TermList* currentEntry();
      bool nextEntry();
      bool nextEntry( lemur::api::DOCID_T documentID );
      bool finished();
    };
  }
}

#endif // VANK_DISKTERMLISTFILEITERATOR_HPP
