/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// DocListIteratorNode
//
// 26 January 2004 -- tds
//

#ifndef VANK_DOCLISTITERATORNODE_HPP
#define VANK_DOCLISTITERATORNODE_HPP

#include "vank/DocListIterator.hpp"
#include "vank/ListIteratorNode.hpp"
#include "vank/Extent.hpp"
#include "vank/greedy_vector"
#include <string>
namespace vank
{
  namespace infnet
  {

    class DocListIteratorNode : public ListIteratorNode {
    private:
      vank::index::DocListIterator* _list;
      class InferenceNetwork& _network;
      int _listID;
      vank::utility::greedy_vector<vank::index::Extent> _extents;
      std::string _name;

    public:
      DocListIteratorNode( const std::string& name, class InferenceNetwork& network, int listID );

      lemur::api::DOCID_T nextCandidateDocument();
      void indexChanged( vank::index::Index& index );
      void indexChanged( vank::index::Index& index, class InferenceNetwork *network );

      void prepare( lemur::api::DOCID_T documentID );
      const vank::utility::greedy_vector<vank::index::Extent>& extents();
      const std::string& getName() const;  void annotate( Annotator& annotator, lemur::api::DOCID_T documentID, vank::index::Extent &extent );
    };
  }
}

#endif // VANK_DOCLISTITERATORNODE_HPP
