/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// ExtentAndNode
//
// 23 February 2004 -- tds
//

#ifndef VANK_EXTENTANDNODE_HPP
#define VANK_EXTENTANDNODE_HPP

#include "vank/ListIteratorNode.hpp"
#include <vector>
#include "vank/greedy_vector"
namespace vank
{
  namespace infnet
  {

    class ExtentAndNode : public ListIteratorNode {
    private:
      std::vector<ListIteratorNode*> _children;
      vank::utility::greedy_vector<vank::index::Extent> _extents;
      vank::utility::greedy_vector<vank::index::Extent> _partialExtents;
      std::string _name;

      void _and( vank::utility::greedy_vector<vank::index::Extent>& out, const vank::utility::greedy_vector<vank::index::Extent>& one, const vank::utility::greedy_vector<vank::index::Extent>& two );

    public:
      ExtentAndNode( const std::string& name, std::vector<ListIteratorNode*>& children );
      void prepare( lemur::api::DOCID_T documentID );
      const vank::utility::greedy_vector<vank::index::Extent>& extents();
      lemur::api::DOCID_T nextCandidateDocument();
      void indexChanged( vank::index::Index& index );
      const std::string& getName() const;
      void annotate( class Annotator& annotator, lemur::api::DOCID_T documentID, vank::index::Extent &extent );
    };
  }
}

#endif //VANK_EXTENTANDNODE_HPP
