/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// FieldIteratorNode
//
// 23 February 2004 -- tds
//

#ifndef VANK_FIELDITERATORNODE_HPP
#define VANK_FIELDITERATORNODE_HPP

#include "vank/ListIteratorNode.hpp"
#include "vank/DocExtentListIterator.hpp"
namespace vank
{
  namespace infnet
  {

    class FieldIteratorNode : public ListIteratorNode {
    private:
      class vank::index::DocExtentListIterator* _list;
      int _listID;
      vank::utility::greedy_vector<vank::index::Extent> _extents;
      vank::utility::greedy_vector<INT64> _numbers;
      class InferenceNetwork& _network;
      std::string _name;

    public:
      FieldIteratorNode( const std::string& name, class InferenceNetwork& network, int fieldID );
      void prepare( lemur::api::DOCID_T documentID );
      /// returns a list of intervals describing positions of children
      const vank::utility::greedy_vector<vank::index::Extent>& extents();
      const vank::utility::greedy_vector<INT64>& numbers();
      lemur::api::DOCID_T nextCandidateDocument();
      void indexChanged( vank::index::Index& index );
      const std::string& getName() const;
      void annotate( class Annotator& annotator, lemur::api::DOCID_T documentID, vank::index::Extent &extent );
    };
  }
}

#endif // VANK_FIELDITERATORNODE_HPP
