
//
// File
//
// 15 November 2004 -- tds
//

#ifndef VANK_FILE_HPP
#define VANK_FILE_HPP

#include "vank/vank-platform.h"
#include "vank/Mutex.hpp"
#include <string>
namespace vank
{
  namespace file
  {

    class File {
    private:
#ifdef WIN32
      vank::thread::Mutex _mutex;
      HANDLE _handle;
#else
      int _handle;
#endif

    public:
      File();
      ~File();

      bool create( const std::string& filename );
      bool open( const std::string& filename );
      bool openRead( const std::string& filename );
      bool openTemporary( std::string& filename );

      void close();

      size_t read( void* buffer, UINT64 position, size_t length );
      size_t write( const void* buffer, UINT64 position, size_t length );

      UINT64 size();
    };
  }
}

#endif // VANK_FILE_HPP
