/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// FilterRejectNode
//
// 13 April 2004 -- tds
//

#ifndef VANK_FILTERREJECTNODE_HPP
#define VANK_FILTERREJECTNODE_HPP

#include "vank/greedy_vector"
#include "vank/Extent.hpp"
#include "vank/BeliefNode.hpp"
#include "vank/ListIteratorNode.hpp"
namespace vank
{
  namespace infnet
  {

    class FilterRejectNode : public BeliefNode {
    private:
      vank::utility::greedy_vector<vank::api::ScoredExtentResult> _extents;
      vank::utility::greedy_vector<bool> _matches;
      ListIteratorNode* _filter;
      BeliefNode* _disallowed;
      std::string _name;

    public:
      FilterRejectNode( const std::string& name, ListIteratorNode* filter,
                        BeliefNode* disallowed );

      double maximumBackgroundScore();
      double maximumScore();
      bool hasMatch( lemur::api::DOCID_T documentID );
      const vank::utility::greedy_vector<bool>& hasMatch( lemur::api::DOCID_T documentID, const vank::utility::greedy_vector<vank::index::Extent>& extents );
      const vank::utility::greedy_vector<vank::api::ScoredExtentResult>& score( lemur::api::DOCID_T documentID, vank::index::Extent &extent, int documentLength );
      lemur::api::DOCID_T nextCandidateDocument();
      void indexChanged( vank::index::Index& index );

      const std::string& getName() const;
      void annotate( class Annotator& annotator, lemur::api::DOCID_T documentID, vank::index::Extent &extent );
    };
  }
}

#endif // VANK_FILTERREJECTNODE_HPP
