/*==========================================================================
 * Copyright (c) 2003-2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// KrovetzStemmerTransformation.hpp
//
// 13 May 2004 -- tds
//

#ifndef VANK_KROVETZSTEMMERTRANSFORMATION_HPP
#define VANK_KROVETZSTEMMERTRANSFORMATION_HPP

#include "vank/Transformation.hpp"
#include "vank/Parameters.hpp"
#include "vank/KrovetzStemmer.hpp"
namespace vank
{
  namespace parse
  {

    class KrovetzStemmerTransformation : public Transformation {
    private:
      KrovetzStemmer *stemmer;
      char* _stemBuffer;
      size_t _stemBufferSize;
      ObjectHandler<vank::api::ParsedDocument>* _handler;

      char* _getBuffer( size_t length );
      const char* _getBufferEnd() const;
      vank::api::ParsedDocument* _restart( vank::api::ParsedDocument* document, size_t lastIndex, char* endOfStemming );
      vank::api::ParsedDocument* _processTerms( vank::api::ParsedDocument* document, size_t start, char* stem, const char* end );
      char* _growBuffer( size_t length, char* oldEnd );

    public:
      KrovetzStemmerTransformation( vank::api::Parameters& parameters );
      ~KrovetzStemmerTransformation();

      vank::api::ParsedDocument* transform( vank::api::ParsedDocument* document );

      void setHandler( ObjectHandler<vank::api::ParsedDocument>& handler );
      void handle( vank::api::ParsedDocument* document );
      static bool _vank_kstem_loaded;
    };
  }
}

#endif // VANK_KROVETZSTEMMERTRANSFORMATION_HPP
