/*==========================================================================
 * Copyright (c) 2003-2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */

//
// MboxDocumentIterator
//
// 20 May 2005 -- tds
//

#ifndef VANK_MBOXDOCUMENTITERATOR_HPP
#define VANK_MBOXDOCUMENTITERATOR_HPP

#include "vank/DocumentIterator.hpp"
#include "vank/UnparsedDocument.hpp"
#include "vank/Buffer.hpp"
#include <fstream>
namespace vank
{
  namespace parse
  {
    class MboxDocumentIterator : public DocumentIterator {
    private:
      std::string _filename;
      UnparsedDocument _document;
      vank::utility::Buffer _buffer;
      vank::utility::Buffer _metaBuffer;
      std::ifstream _in;

      void _copyMetadata( const char* headerLine, int ignoreBytes, const char* tagName );

    public:
      void open( const std::string& filename );
      UnparsedDocument* nextDocument();
      void close();
    };
  }
}

#endif // VANK_MBOXDOCUMENTITERATOR_HPP
