#ifndef INC_NexiParser_hpp_
#define INC_NexiParser_hpp_

#line 18 "nexilang.g"

  #include "vank/QuerySpec.hpp"
  #include "vank/DateParse.hpp"
  #include "vank/delete_range.hpp"
  #include "vank/NexiLexer.hpp"
  #include <algorithm>
  #include <cctype>

#line 14 "NexiParser.hpp"
#include <antlr/config.hpp>
/* $ANTLR 2.7.3 (20060307-1): "nexilang.g" -> "NexiParser.hpp"$ */
#include <antlr/TokenStream.hpp>
#include <antlr/TokenBuffer.hpp>
#include "NexiLexerTokenTypes.hpp"
#include <antlr/LLkParser.hpp>

ANTLR_BEGIN_NAMESPACE(vank)
ANTLR_BEGIN_NAMESPACE(lang)
class CUSTOM_API NexiParser : public ANTLR_USE_NAMESPACE(antlr)LLkParser, public NexiLexerTokenTypes
{
#line 132 "nexilang.g"

private:
  // storage for allocated nodes
  std::vector<vank::lang::Node*> _nodes;
  // makes sure nodes go away when parser goes away
  vank::utility::VectorDeleter<vank::lang::Node*> _deleter;
    bool _shrinkage;

public:
  void init( NexiLexer* lexer ) {
    _deleter.setVector( _nodes );
    _shrinkage = true;
  }

  void setShrinkage( bool shrink ) {
    _shrinkage = shrink;
  }
#line 25 "NexiParser.hpp"
public:
	void initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory );
protected:
	NexiParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k);
public:
	NexiParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf);
protected:
	NexiParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k);
public:
	NexiParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer);
	NexiParser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state);
	int getNumTokens() const
	{
		return NexiParser::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return NexiParser::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return NexiParser::tokenNames;
	}
	public:  vank::lang::ScoredExtentNode*  query();
	public:  vank::lang::NestedExtentInside*  path();
	public:  vank::lang::RawExtentNode *  field();
	public:  vank::lang::ScoredExtentNode*  clause();
	public:  vank::lang::ScoredExtentNode*  termList();
	public:  vank::lang::ScoredExtentNode*  term();
	public:  vank::lang::ScoredExtentNode*  filter();
	public:  vank::lang::UnweightedCombinationNode*  logical();
	public:  vank::lang::ScoredExtentNode*  aboutClause();
	public:  vank::lang::RawExtentNode *  arithmeticClause();
	public:  vank::lang::ScoredExtentNode*  filterParens();
	public:  INT64  number();
	public:  vank::lang::ScoredExtentNode *  unrestrictedTerm();
	public:  vank::lang::RawExtentNode*  rawText();
	public:  vank::lang::ODNode*  odNode();
public:
	ANTLR_USE_NAMESPACE(antlr)RefAST getAST()
	{
		return returnAST;
	}

protected:
	ANTLR_USE_NAMESPACE(antlr)RefAST returnAST;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 44;
#else
	enum {
		NUM_TOKENS = 44
	};
#endif

	static const unsigned long _tokenSet_0_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_1;
};

ANTLR_END_NAMESPACE
ANTLR_END_NAMESPACE
#endif /*INC_NexiParser_hpp_*/
