/*==========================================================================
 * Copyright (c) 2003-2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// CaseNormalizationTransformation
//
// 13 August 2004 -- tds
//

#ifndef VANK_CASENORMALIZATIONTRANSFORMATION_HPP
#define VANK_CASENORMALIZATIONTRANSFORMATION_HPP

#include "vank/Transformation.hpp"
#include "vank/Parameters.hpp"
#include "lemur/string-set.h"
namespace vank
{
  namespace parse
  {

    class NormalizationTransformation : public Transformation {
    private:
      ObjectHandler<vank::api::ParsedDocument>* _handler;
      String_set* _acronyms;

    public:
      NormalizationTransformation( vank::api::Parameters* acronymList = 0 );
      ~NormalizationTransformation();

      vank::api::ParsedDocument* transform( vank::api::ParsedDocument* document );

      void handle( vank::api::ParsedDocument* document );
      void setHandler( ObjectHandler<vank::api::ParsedDocument>& handler );
    };
  }
}

#endif // VANK_CASENORMALIZATIONTRANSFORMATION_HPP
