/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// NullListNode.hpp
//
// 11 August 2004 -- tds
//

#ifndef VANK_NULLLISTNODE_HPP
#define VANK_NULLLISTNODE_HPP

#include "vank/ListIteratorNode.hpp"
namespace vank
{
  namespace infnet
  {

    class NullListNode : public ListIteratorNode {
    private:
      vank::utility::greedy_vector<vank::index::Extent> _extents;
      std::string _name;
      bool _stopword;

    public:
      NullListNode( const std::string& name, bool stopword );

      bool isStopword() const;
      const std::string& getName() const;

      lemur::api::DOCID_T nextCandidateDocument();
      void indexChanged( vank::index::Index& index );

      void prepare( lemur::api::DOCID_T documentID );
      const vank::utility::greedy_vector<vank::index::Extent>& extents();
      void annotate( class Annotator& annotator, lemur::api::DOCID_T documentID, vank::index::Extent &extent );
    };
  }
}

#endif // VANK_NULLLISTNODE_HPP
