/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// NullScorerNode
//
// 10 March 2004 -- tds
//

#ifndef VANK_NULLSCORERNODE_HPP
#define VANK_NULLSCORERNODE_HPP

#include "vank/greedy_vector"
#include "vank/ScoredExtentResult.hpp"
#include "vank/TermScoreFunction.hpp"
#include "vank/BeliefNode.hpp"
namespace vank
{
  namespace infnet
  {

    class NullScorerNode : public BeliefNode {
    private:
      vank::query::TermScoreFunction& _scoreFunction;
      vank::utility::greedy_vector<vank::api::ScoredExtentResult> _scores;
      vank::utility::greedy_vector<bool> _matches;
      std::string _name;
      double _maximumBackgroundScore;
      double _maximumScore;

    public:
      NullScorerNode( const std::string& name, vank::query::TermScoreFunction& scoreFunction );

      void indexChanged( vank::index::Index& index );
      lemur::api::DOCID_T nextCandidateDocument();
      double maximumScore();
      double maximumBackgroundScore();
      bool hasMatch( lemur::api::DOCID_T documentID );
      const vank::utility::greedy_vector<bool>& hasMatch( lemur::api::DOCID_T documentID, const vank::utility::greedy_vector<vank::index::Extent>& extents );
      const vank::utility::greedy_vector<vank::api::ScoredExtentResult>& score( lemur::api::DOCID_T documentID, vank::index::Extent &extent, int documentLength );
      void annotate( class Annotator& annotator, lemur::api::DOCID_T documentID, vank::index::Extent &extent );
      const std::string& getName() const;
    };
  }
}

#endif // VANK_NULLSCORERNODE_HPP
