/*==========================================================================
 * Copyright (c) 2003-2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// PDFDocumentExtractor
//
// 25 June 2004 -- tds
//

#ifndef VANK_PDFDOCUMENTEXTRACTOR_HPP
#define VANK_PDFDOCUMENTEXTRACTOR_HPP

#include "lemur/lemur-compat.hpp"
#include "vank/Buffer.hpp"
#include "vank/UnparsedDocument.hpp"
#include "vank/DocumentIterator.hpp"
#include "vank/XMLReader.hpp"
#include "vank/XMLNode.hpp"
#include "vank/XMLWriter.hpp"
#include <string>
namespace vank
{
  namespace parse
  {

    class PDFDocumentExtractor : public DocumentIterator {
      vank::utility::Buffer _documentTextBuffer;
      UnparsedDocument _unparsedDocument;
      std::string _documentPath;

    public:
      PDFDocumentExtractor();
      ~PDFDocumentExtractor();

      void open( const std::string& filename );
      UnparsedDocument* nextDocument();
	  void appendPdfMetaData(vank::xml::XMLNode* node);
	  void seekValue(vank::xml::XMLNode* node, std::string &metaTag);
      void close();
	private:
	  std::string _title;
	  std::string _author;

    };
  }
}

#endif // VANK_PDFDOCUMENTEXTRACTOR_HPP
