/*==========================================================================
 * Copyright (c) 2003-2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// ParsedDocument
//
// 12 May 2004 -- tds
//

#ifndef VANK_PARSEDDOCUMENT_HPP
#define VANK_PARSEDDOCUMENT_HPP

#include "vank/greedy_vector"
#include "vank/TagExtent.hpp"
#include "vank/TermExtent.hpp"
#include "vank/MetadataPair.hpp"
#include <string>
namespace vank
{
  namespace api
  {

    struct ParsedDocument {
      const char* text;
      size_t textLength;

      const char* content;
      size_t contentLength;

      std::string getContent() {
        return std::string (content, contentLength);
      }

      vank::utility::greedy_vector<char*> terms;
      vank::utility::greedy_vector<vank::parse::TagExtent *> tags;
      vank::utility::greedy_vector<vank::parse::TermExtent> positions;
      vank::utility::greedy_vector<vank::parse::MetadataPair> metadata;
    };
  }
}

#endif // VANK_PARSEDDOCUMENT_HPP
