/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */

//
// PonteExpander
//
// 18 Aug 2004 -- dam
//

#ifndef VANK_PONTEEXPANDER_HPP
#define VANK_PONTEEXPANDER_HPP

#include <string>
#include <vector>
#include <map>

#include "vank/QueryExpander.hpp"
#include "vank/QueryEnvironment.hpp"
#include "vank/Parameters.hpp"
namespace vank
{
  namespace query
  {

    class PonteExpander : public QueryExpander  {
    public:
      PonteExpander( vank::api::QueryEnvironment * env , vank::api::Parameters& param );

      virtual std::string expand( std::string originalQuery, std::vector<vank::api::ScoredExtentResult>& results );
    };
  }
}

#endif // VANK_PONTEEXPANDER_HPP
