/*==========================================================================
 * Copyright (c) 2003-2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// PorterStemmerTransformation
//
// 13 May 2004 -- tds
//

#ifndef VANK_PORTERSTEMMERTRANSFORMATION_HPP
#define VANK_PORTERSTEMMERTRANSFORMATION_HPP

#include "vank/Transformation.hpp"
#include "vank/Porter_Stemmer.hpp"
namespace vank
{
  namespace parse
  {

    class PorterStemmerTransformation : public Transformation {
    private:
      ObjectHandler<vank::api::ParsedDocument>* _handler;
      Porter_Stemmer *stemmer;
    public:
      PorterStemmerTransformation();
      ~PorterStemmerTransformation();
      vank::api::ParsedDocument* transform( vank::api::ParsedDocument* document );

      void setHandler( ObjectHandler<vank::api::ParsedDocument>& handler );
      void handle( vank::api::ParsedDocument* document );
    };
  }
}

#endif // VANK_PORTERSTEMMERTRANSFORMATION_HPP
