/*==========================================================================
 * Copyright (c) 2005 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
*/

//
// PriorListIterator.hpp
//
// 22 July 2005 -- tds
//

#ifndef VANK_PRIORLISTITERATOR_HPP
#define VANK_PRIORLISTITERATOR_HPP

#include "vank/SequentialReadBuffer.hpp"
#include "vank/greedy_vector"
#include "lemur/IndexTypes.hpp"

namespace vank {
  namespace collection {
    class PriorListIterator {
    public:
      struct Entry {
        lemur::api::DOCID_T document;
        double score;
      };

    private:
      vank::file::SequentialReadBuffer* _file;
      Entry _entry;
      vank::utility::greedy_vector<double> _lookup;

      bool _finished;
      UINT32 _entryCount;
      UINT32 _entryLength;
      UINT32 _tableLength;

    public:
      PriorListIterator( vank::file::SequentialReadBuffer* file );
      ~PriorListIterator();

      void startIteration();
      void nextEntry();
      void nextEntry( lemur::api::DOCID_T document );
      Entry* currentEntry();
      bool finished();
    };
  }
}

#endif // VANK_PRIORLISTITERATOR_HPP
