/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// QueryAnnotation
//
// 21 July 2004 -- tds
//

#ifndef VANK_QUERYANNOTATION_HPP
#define VANK_QUERYANNOTATION_HPP

#include "vank/EvaluatorNode.hpp"
#include <string>
#include <vector>
#include <map>
#include "vank/QuerySpec.hpp"

namespace vank
{
  namespace api
  {

    struct QueryAnnotationNode {
      std::string name;
      std::string type;
      std::string queryText;
      std::vector<QueryAnnotationNode*> children;
    };

    class QueryAnnotation {
    private:
      QueryAnnotationNode* _queryTree;
      vank::infnet::EvaluatorNode::MResults _annotations;
      std::vector<vank::api::ScoredExtentResult> _results;

    public:
      QueryAnnotation();
      QueryAnnotation( vank::lang::Node* queryRoot, vank::infnet::EvaluatorNode::MResults& annotations, std::vector<vank::api::ScoredExtentResult>& results );
      ~QueryAnnotation();

      const QueryAnnotationNode* getQueryTree() const;
      const std::map< std::string, std::vector<vank::api::ScoredExtentResult> >& getAnnotations() const;
      const std::vector<vank::api::ScoredExtentResult>& getResults() const;
    };
  }
}

#endif // VANK_DOCUMENTANNOTATION_HPP
