#ifndef INC_QueryParser_hpp_
#define INC_QueryParser_hpp_

#line 18 "vanklang.g"

  #include "vank/QuerySpec.hpp"
  #include "vank/DateParse.hpp"
  #include "vank/delete_range.hpp"
  #include "vank/QueryLexer.hpp"

#line 12 "QueryParser.hpp"
#include <antlr/config.hpp>
/* $ANTLR 2.7.7 (2006-11-01): "vanklang.g" -> "QueryParser.hpp"$ */
#include <antlr/TokenStream.hpp>
#include <antlr/TokenBuffer.hpp>
#include "vank/QueryLexerTokenTypes.hpp"
#include <antlr/LLkParser.hpp>

ANTLR_BEGIN_NAMESPACE(vank)
ANTLR_BEGIN_NAMESPACE(lang)
class CUSTOM_API QueryParser : public ANTLR_USE_NAMESPACE(antlr)LLkParser, public QueryLexerTokenTypes
{
#line 158 "vanklang.g"

private:
  // storage for allocated nodes
  std::vector<vank::lang::Node*> _nodes;
  // makes sure nodes go away when parser goes away
  vank::utility::VectorDeleter<vank::lang::Node*> _deleter;

  vank::lang::RawExtentNode * innerMost( vank::lang::ScoredExtentNode* sr ) {
    vank::lang::RawExtentNode * ou = 0;
    // set the new outer node we need to pass down (the innermost of field or field list of
    // of this restriction)
    vank::lang::ExtentRestriction * er = dynamic_cast<vank::lang::ExtentRestriction *>(sr);
    if (er != 0) {
      vank::lang::RawExtentNode * f = er->getField();
      vank::lang::ExtentInside * ei = dynamic_cast<vank::lang::ExtentInside *>(f);
      while (ei != 0) {
        f = ei->getInner();
        ei = dynamic_cast<vank::lang::ExtentInside *>(f);
      }
      ou = f;
    }
    return ou;
  }

public:
  void init( QueryLexer* lexer ) {
    _deleter.setVector( _nodes );
  }
#line 23 "QueryParser.hpp"
public:
	void initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory );
protected:
	QueryParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k);
public:
	QueryParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf);
protected:
	QueryParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k);
public:
	QueryParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer);
	QueryParser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state);
	int getNumTokens() const
	{
		return QueryParser::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return QueryParser::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return QueryParser::tokenNames;
	}
	public:  vank::lang::ScoredExtentNode*  query();
	public:  vank::lang::ScoredExtentNode*  scoredExtentNode(
		 vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  weightNode(
		vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  combineNode(
		vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  orNode(
		vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  notNode(
		vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  wandNode(
		vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  wsumNode(
		vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  maxNode(
		vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::PriorNode*  priorNode();
	public:  vank::lang::FilRejNode*  filrejNode(
		 vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::FilReqNode*  filreqNode(
		 vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::FilReqNode*  scoreifNode(
		 vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::FilRejNode*  scoreifnotNode(
		 vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  scoredRaw(
		 vank::lang::RawExtentNode * ou
	);
	public:  RawExtentNode*  qualifiedTerm();
	public:  ExtentOr*  context_list(
		 vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::RawExtentNode*  unqualifiedTerm();
	public:  vank::lang::ScoredExtentNode*  weightedList(
		 vank::lang::WeightedCombinationNode* wn, vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  extentRestriction(
		 vank::lang::ScoredExtentNode* sn, vank::lang::RawExtentNode * ou
	);
	public:  double  floating();
	public:  vank::lang::ScoredExtentNode*  sumList(
		 vank::lang::WSumNode* wn, vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  unweightedList(
		 vank::lang::UnweightedCombinationNode* cn, vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::ScoredExtentNode*  sumNode(
		vank::lang::RawExtentNode * ou
	);
	public:  vank::lang::WeightedExtentOr*  wsynNode();
	public:  RawExtentNode*  unscoredTerm();
	public:  vank::lang::ODNode*  odNode();
	public:  vank::lang::UWNode*  uwNode();
	public:  vank::lang::BAndNode*  bandNode();
	public:  vank::lang::Field*  anyField();
	public: std::string  fieldNameString();
	public:  vank::lang::ExtentAnd*  field_list();
	public:  vank::lang::FieldLessNode*  dateBefore();
	public:  vank::lang::FieldGreaterNode*  dateAfter();
	public:  vank::lang::FieldBetweenNode*  dateBetween();
	public:  vank::lang::FieldEqualsNode*  dateEquals();
	public:  vank::lang::ExtentOr*  synonym_list();
	public:  vank::lang::ExtentOr*  synonym_list_brace();
	public:  vank::lang::ExtentOr*  synonym_list_alt();
	public:  vank::lang::FieldLessNode*  lessNode();
	public:  vank::lang::FieldGreaterNode*  greaterNode();
	public:  vank::lang::FieldBetweenNode*  betweenNode();
	public:  vank::lang::FieldEqualsNode*  equalsNode();
	public:  vank::lang::IndexTerm*  rawText();
	public:  vank::lang::ODNode*  hyphenTerm();
	public:  vank::lang::WildcardTerm*  wildcardOpNode();
	public: vank::lang::IndexTerm *  hyphenate();
	public:  std::string  fstring();
	public:  vank::lang::ExtentInside*  path();
	public:  vank::lang::ExtentInside*  pathOperator();
	public:  vank::lang::Field*  field_restriction();
	public:  UINT64  date();
	public:  UINT64  slashDate();
	public:  UINT64  spaceDate();
	public:  UINT64  dashDate();
	public:  INT64  number();
public:
	ANTLR_USE_NAMESPACE(antlr)RefAST getAST()
	{
		return returnAST;
	}

protected:
	ANTLR_USE_NAMESPACE(antlr)RefAST returnAST;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 69;
#else
	enum {
		NUM_TOKENS = 69
	};
#endif

	static const unsigned long _tokenSet_0_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_1;
	static const unsigned long _tokenSet_2_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_2;
	static const unsigned long _tokenSet_3_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_3;
	static const unsigned long _tokenSet_4_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_4;
	static const unsigned long _tokenSet_5_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_5;
	static const unsigned long _tokenSet_6_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_6;
	static const unsigned long _tokenSet_7_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_7;
	static const unsigned long _tokenSet_8_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_8;
	static const unsigned long _tokenSet_9_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_9;
};

ANTLR_END_NAMESPACE
ANTLR_END_NAMESPACE
#endif /*INC_QueryParser_hpp_*/
