/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */

//
// SimpleCopier
//
// 24 September 2004 -- tds
//
// SimpleCopier just makes a copy of a query tree and stores it.
// This is useful for keeping a copy of a query tree around.
//

#ifndef VANK_SIMPLECOPIER_HPP
#define VANK_SIMPLECOPIER_HPP

#include "Copier.hpp"
namespace vank
{
  namespace lang
  {

    class SimpleCopier : public vank::lang::Copier {
    private:
      std::vector<vank::lang::Node*> _nodes;

    public:
      ~SimpleCopier() {
        vank::utility::delete_vector_contents( _nodes );
      }

      vank::lang::Node* defaultAfter( vank::lang::Node* oldNode, vank::lang::Node* newNode ) {
        _nodes.push_back(newNode);
        return newNode;
      }

      vank::lang::Node* root() {
        if( _nodes.size() )
          return _nodes.back();
        return 0;
      }
    };
  }
}

#endif // VANK_SIMPLECOPIER_HPP
