/*==========================================================================
 * Copyright (c) 2003-2005 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// TokenizedDocument
//
// 15 September 2005 -- mwb
//

#ifndef VANK_TOKENIZEDDOCUMENT_HPP
#define VANK_TOKENIZEDDOCUMENT_HPP

#include "vank/greedy_vector"
#include "vank/TagEvent.hpp"
#include "vank/TermExtent.hpp"
#include "vank/MetadataPair.hpp"

namespace vank {
  namespace parse {

    struct TokenizedDocument {

      const char* text;
      size_t textLength;

      const char* content;
      size_t contentLength;

      vank::utility::greedy_vector<char*> terms;
      vank::utility::greedy_vector<TagEvent> tags;
      vank::utility::greedy_vector<TermExtent> positions;
      vank::utility::greedy_vector<MetadataPair> metadata;
    };
  }
}

#endif // VANK_TOKENIZEDDOCUMENT_HPP
