/*==========================================================================
 * Copyright (c) 2003-2005 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */

//
// UTF8CaseNormalizationTransformation
//
// 16 September 2005 -- mwb
//

#ifndef VANK_UTF8CASENORMALIZATIONTRANSFORMATION_HPP
#define VANK_UTF8CASENORMALIZATIONTRANSFORMATION_HPP

#include "vank/vank-platform.h"
#include "vank/Transformation.hpp"
#include "vank/UTF8Transcoder.hpp"
#include "vank/ParsedDocument.hpp"
#include "vank/HashTable.hpp"
#include <vector>
#include <map>

namespace vank {
  namespace parse {

    class UTF8CaseNormalizationTransformation : public Transformation {

    private:
      ObjectHandler<vank::api::ParsedDocument>* _handler;
      UTF8Transcoder _transcoder;
      std::vector<char*> _buffers_allocated;

      vank::utility::HashTable<UINT64,UINT64> _downcase;
      void _initHT();

    public:
      UTF8CaseNormalizationTransformation();
      ~UTF8CaseNormalizationTransformation();

      void handle( vank::api::ParsedDocument* document );
      void setHandler( ObjectHandler<vank::api::ParsedDocument>& handler );

      vank::api::ParsedDocument* transform( vank::api::ParsedDocument* document );

    };
  }
}

#endif // VANK_UTF8CASENORMALIZATIONTRANSFORMATION_HPP
