/*==========================================================================
 * Copyright (c) 2003-2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// Parser
//
// 11 May 2004 -- tds
//

#ifndef VANK_PARSER_HPP
#define VANK_PARSER_HPP

#include "vank/ObjectHandler.hpp"
#include "vank/TokenizedDocument.hpp"
#include "vank/ParsedDocument.hpp"
#include "vank/ConflationPattern.hpp"
#include <map>
#include <vector>

namespace vank {
  namespace parse
  {

    class Parser : public ObjectHandler<TokenizedDocument> {
    public:
      virtual ~Parser() {};

      virtual vank::api::ParsedDocument* parse( TokenizedDocument* document ) = 0;
      virtual void setTags( const std::vector<std::string>& include,
                            const std::vector<std::string>& exclude,
                            const std::vector<std::string>& index,
                            const std::vector<std::string>& metadata,
                            const std::map<ConflationPattern *, std::string>& conflations ) = 0;

      virtual void handle( TokenizedDocument* document ) = 0;
      virtual void setHandler( ObjectHandler<vank::api::ParsedDocument>& handler ) = 0;
    };
  }
}

#endif // VANK_PARSER_HPP
