/*==========================================================================
 * Copyright (c) 2003-2005 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// Tokenizer
//
// 15 September 2005 -- mwb
//

#ifndef VANK_TOKENIZER_HPP
#define VANK_TOKENIZER_HPP

#include "vank/ObjectHandler.hpp"
#include "vank/UnparsedDocument.hpp"
#include "vank/TokenizedDocument.hpp"
// #include <map>
// #include <vector>

namespace vank {
  namespace parse {

    class Tokenizer : public ObjectHandler<UnparsedDocument> {
    public:
      Tokenizer() {}
      virtual ~Tokenizer() {}

      virtual TokenizedDocument* tokenize( UnparsedDocument* document ) = 0;
      virtual void handle( UnparsedDocument* document ) = 0;
      virtual void setHandler( ObjectHandler<TokenizedDocument>& handler ) = 0;
    };
  }
}

#endif // VANK_TOKENIZER_HPP
