/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */

/**
 * vank-platform.h
 *
 * The point of this header is to contain the kinds of things
 * that are stored in platform.h on Unix:
 *    * endian constants
 *    * type size constants
 *    * typedefs
 *
 * As this is an Vank header, it is also appropriate to put general
 * Vank-specific typedefs here.
 */

#ifndef VANK_PLATFORM_H
#define VANK_PLATFORM_H

#include "lemur/lemur-platform.h"

#define VANKD_PORT ( 16743 )
#define VANK_DISTRIBUTION "Vank release 5.11"

#endif /* VANK_PLATFORM_H */
