/*==========================================================================
 * Copyright (c) 2005 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */

//
// MemoryDocumentDataIterator
//
// 21 January 2005 -- tds
//

#include "vank/MemoryDocumentDataIterator.hpp"

//
// MemoryDocumentDataIterator constructor
//

vank::index::MemoryDocumentDataIterator::MemoryDocumentDataIterator( const std::vector<DocumentData>& documentData ) :
  _dataVector(documentData)
{
}

//
// MemoryDocumentDataIterator destructor
//

vank::index::MemoryDocumentDataIterator::~MemoryDocumentDataIterator()
{
}

//
// startIteration
//

void vank::index::MemoryDocumentDataIterator::startIteration() {
  _iterator = _dataVector.begin();
}

//
// nextEntry
//

bool vank::index::MemoryDocumentDataIterator::nextEntry() {
  if( !finished() )
    _iterator++;

  return !finished();
}

//
// finished
//

bool vank::index::MemoryDocumentDataIterator::finished() {
  return _iterator == _dataVector.end();
}

//
// currentEntry
//

const vank::index::DocumentData* vank::index::MemoryDocumentDataIterator::currentEntry() {
  if( finished() )
    return 0;

  return &(*_iterator);
}
