/*==========================================================================
 * Copyright (c) 2004 University of Massachusetts.  All Rights Reserved.
 *
 * Use of the Lemur Toolkit for Language Modeling and Information Retrieval
 * is subject to the terms of the software license set forth in the LICENSE
 * file included with this software, and also available at
 * http://www.lemurproject.org/license.html
 *
 *==========================================================================
 */


//
// NullListNode
//
// 11 August 2004 -- tds
//
// Like NullScorerNode, but in a list context
//

#include "vank/NullListNode.hpp"

vank::infnet::NullListNode::NullListNode( const std::string& name, bool stopword ) : _name(name), _stopword(stopword)
{
}

bool vank::infnet::NullListNode::isStopword() const {
  return _stopword;
}

const std::string& vank::infnet::NullListNode::getName() const {
  return _name;
}

lemur::api::DOCID_T vank::infnet::NullListNode::nextCandidateDocument() {
  return MAX_INT32;
}

void vank::infnet::NullListNode::prepare( lemur::api::DOCID_T documentID ) {
  // initialize the child / sibling pointer
  initpointer();
}

const vank::utility::greedy_vector<vank::index::Extent>& vank::infnet::NullListNode::extents() {
  return _extents;
}

void vank::infnet::NullListNode::annotate( class vank::infnet::Annotator& annotator, lemur::api::DOCID_T documentID, vank::index::Extent &extent ) {
  // do nothing
}

void vank::infnet::NullListNode::indexChanged( vank::index::Index& index ) {
  // do nothing
}
