
#ifdef SWIGGO

%insert(go_wrapper) %{

//
//  extend IndexEnvironment.i
//
type IndexEnvironment interface {
    Wrapped_IndexEnvironment

	SetDocumentRoot(arg2 string) (err error)
	SetAnchorTextPath(arg2 string) (err error)
	SetOffsetMetadataPath(arg2 string) (err error)
	SetOffsetAnnotationsPath(arg2 string) (err error)
	GetFileClassSpec(arg2 string) (_swig_ret Vank_parse_FileClassEnvironmentFactory_Specification, err error)
	AddFileClass(a ...interface{}) (err error)
	DeleteDocument(arg2 int) (err error)
	SetIndexedFields(arg2 StringVector) (err error)
	SetNumericField(a ...interface{}) (err error)
	SetOrdinalField(arg2 string, arg3 bool) (err error)
	SetParentalField(arg2 string, arg3 bool) (err error)
	SetMetadataIndexedFields(arg2 StringVector, arg3 StringVector) (err error)
	SetStopwords(arg2 StringVector) (err error)
	SetStemmer(arg2 string) (err error)
	SetMemory(arg2 int64) (err error)
    SetMaxDocs(arg2 int64) (err error)
	SetNormalization(arg2 bool) (err error)
	SetStoreDocs(arg2 bool) (err error)
	Create(a ...interface{}) (err error)
	Open(a ...interface{}) (err error)
	Close() (err error)
    AddFile(a ...interface{}) (err error)
	AddString(arg2 string, arg3 string, arg4 MetadataPairVector) (_swig_ret int, err error)
	AddParsedDocument(arg2 ParsedDocument) (_swig_ret int, err error)
	DocumentsIndexed() (_swig_ret int, err error)
	DocumentsSeen() (_swig_ret int, err error)
}

func NewIndexEnvironment() (swig_r IndexEnvironment, err error) {
	defer catch(&err)
    swig_r = (IndexEnvironment)(SwigcptrWrapped_IndexEnvironment(C._wrap_new_Wrapped_IndexEnvironment_vank_go_073f147d1da00b5b()))
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetDocumentRoot(arg2 string) (err error) {
    defer catch(&err)
    e.Wrapped_setDocumentRoot(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetAnchorTextPath(arg2 string) (err error) {
    defer catch(&err)
    e.Wrapped_setAnchorTextPath(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetOffsetMetadataPath(arg2 string) (err error) {
    defer catch(&err)
    e.Wrapped_setOffsetMetadataPath(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetOffsetAnnotationsPath(arg2 string) (err error) {
    defer catch(&err)
    e.Wrapped_setOffsetAnnotationsPath(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) GetFileClassSpec(arg2 string) (_swig_ret Vank_parse_FileClassEnvironmentFactory_Specification, err error) {
    defer catch(&err)
    _swig_ret = e.Wrapped_getFileClassSpec(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) AddFileClass(a ...interface{}) (err error) {
    defer catch(&err)
    argc := len(a)
	if argc == 1 {
		e.Wrapped_addFileClass(a[0].(Vank_parse_FileClassEnvironmentFactory_Specification))
		return
	}
	if argc == 12 {
		e.Wrapped_addFileClass(a[0].(string), a[1].(string), a[2].(string), a[3].(string), a[4].(string), a[5].(string), a[6].(string), a[7].(StringVector), a[8].(StringVector), a[9].(StringVector), a[10].(StringVector), a[11].(Std_map_Sl_vank_parse_ConflationPattern_Sm__Sc_std_string_Sg_))
		return
	}
	panic("No match for overloaded function call")
    return
}

func (e SwigcptrWrapped_IndexEnvironment) DeleteDocument(arg2 int) (err error) {
    defer catch(&err)
    e.Wrapped_deleteDocument(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetIndexedFields(arg2 StringVector) (err error) {
    defer catch(&err)
    e.Wrapped_setIndexedFields(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetNumericField(a ...interface{}) (err error) {
    defer catch(&err)
    argc := len(a)
	if argc == 2 {
		e.Wrapped_setNumericField(a[0].(string), a[1].(bool))
		return
	}
	if argc == 3 {
		e.Wrapped_setNumericField(a[0].(string), a[1].(bool), a[2].(string))
		return
	}
	panic("No match for overloaded function call")
    // can't nest variadit function
    //e.Wrapped_setNumericField(a)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetOrdinalField(arg2 string, arg3 bool) (err error) {
    defer catch(&err)
    e.Wrapped_setOrdinalField(arg2, arg3)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetParentalField(arg2 string, arg3 bool) (err error) {
    defer catch(&err)
    e.Wrapped_setParentalField(arg2, arg3)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetMetadataIndexedFields(arg2 StringVector, arg3 StringVector) (err error) {
    defer catch(&err)
    e.Wrapped_setMetadataIndexedFields(arg2, arg3)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetStopwords(arg2 StringVector) (err error) {
    defer catch(&err)
    e.Wrapped_setStopwords(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetStemmer(arg2 string) (err error) {
    defer catch(&err)
    e.Wrapped_setStemmer(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetMemory(arg2 int64) (err error) {
    defer catch(&err)
    e.Wrapped_setMemory(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetMaxDocs(arg2 int64) (err error) {
    defer catch(&err)
    e.Wrapped_setMaxDocs(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetNormalization(arg2 bool) (err error) {
    defer catch(&err)
    e.Wrapped_setNormalization(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) SetStoreDocs(arg2 bool) (err error) {
    defer catch(&err)
    e.Wrapped_setStoreDocs(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) Create(a ...interface{}) (err error) {
    defer catch(&err)
    argc := len(a)
	if argc == 1 {
		e.Wrapped_create(a[0].(string))
		return
	}
	if argc == 2 {
		e.Wrapped_create(a[0].(string), a[1].(IndexStatus))
		return
	}
	panic("No match for overloaded function call")
    return
}

func (e SwigcptrWrapped_IndexEnvironment) Open(a ...interface{}) (err error) {
    defer catch(&err)
    argc := len(a)
	if argc == 1 {
		e.Wrapped_open(a[0].(string))
		return
	}
	if argc == 2 {
		e.Wrapped_open(a[0].(string), a[1].(IndexStatus))
		return
	}
	panic("No match for overloaded function call")
    return
}

func (e SwigcptrWrapped_IndexEnvironment) Close() (err error) {
    defer catch(&err)
    e.Wrapped_close()
    return
}

func (e SwigcptrWrapped_IndexEnvironment) AddFile(a ...interface{}) (err error) {
    defer catch(&err)
    argc := len(a)
    if argc == 2 {
        e.Wrapped_addFile__SWIG_0(a[0].(string), a[1].(IndexDocumentMetaCallback))
        return
    }
    if argc == 3 {
        e.Wrapped_addFile__SWIG_1(a[0].(string), a[1].(string), a[2].(IndexDocumentMetaCallback))
        return
    }
    panic("No match for overloaded function call")
    return
}

func (e SwigcptrWrapped_IndexEnvironment) AddString(arg2 string, arg3 string, arg4 MetadataPairVector) (_swig_ret int, err error) {
    defer catch(&err)
    _swig_ret = e.Wrapped_addString(arg2, arg3, arg4)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) AddParsedDocument(arg2 ParsedDocument) (_swig_ret int, err error) {
    defer catch(&err)
    _swig_ret = e.Wrapped_addParsedDocument(arg2)
    return
}

func (e SwigcptrWrapped_IndexEnvironment) DocumentsIndexed() (_swig_ret int, err error) {
    defer catch(&err)
    _swig_ret = e.Wrapped_documentsIndexed()
    return
}

func (e SwigcptrWrapped_IndexEnvironment) DocumentsSeen() (_swig_ret int, err error) {
    defer catch(&err)
    _swig_ret = e.Wrapped_documentsSeen()
    return
}


//
// the GO type MyStatusMonitor is subclassed from C++ type vank::api::IndexStatus
// this requires that director feature be enabled, look for
// '%module(directors="1") modulename' under ifdef SWIGGO in vank.i and look
// for '%feature("director") modulename' in IndexEnvironment.i
//
// MyStatusMonitor is a superset of IndexStatus and hence can be used as a
// drop in replacement for IndexStatus but the reverse causes a compile time
// error. refer to swig docs for details (SWIG 3.0: 23.4.7 Go Director Classes)
//
type MyStatusMonitor interface {
  IndexStatus
  DeleteIndexStatus()
  IsIndexStatus()
}

// Via embedding myStatusMonitor "inherits" all methods of IndexStatus.
// isgs => Index Status GO Structure
type myStatusMonitor struct {
  IndexStatus
}

func (isgs *myStatusMonitor) DeleteIndexStatus() {
  DeleteDirectorIndexStatus(isgs.IndexStatus)
}

func (isgs *myStatusMonitor) IsIndexStatus() {}

type overwrittenMethodsOnIndexStatus struct {
  is IndexStatus
}

func (om *overwrittenMethodsOnIndexStatus) Status( code int, documentFile string, error string, documentsIndexed int, documentsSeen int ) {

    // C++ code defines class local enums, method signature uses int for code
    // swiggo generates constants we cannot use because of signature mismatch
    // note: must match C++ definition
    const (
        FileOpen = iota
        FileSkip
        FileError
        FileClose
        DocumentCount
    )

    switch(code) {
    case FileOpen:
        Buildindex_print_event( fmt.Sprintf("Opened %v", documentFile) )

    case FileClose:
        Buildindex_print_event( fmt.Sprintf("Closed %v", documentFile) )

    case FileSkip:
        Buildindex_print_event( fmt.Sprintf("Skipped %v", documentFile) )

    case FileError:
        Buildindex_print_event( fmt.Sprintf("Error in %v : %v", documentFile, error) )

    default:
        fallthrough
    case DocumentCount:
        if( documentsSeen < 10 || (documentsSeen % 500) == 0 ) {
            // note: C++ signature wants second count as INT64, but it is int here in GO
            //Buildindex_print_status( "Documents parsed: ", documentsSeen, " Documents indexed: ", documentsIndexed )
            // so use this instead.
            Buildindex_print_event( fmt.Sprintf("Documents parsed: %v Documents indexed: %v", documentsSeen, documentsIndexed) )
            Buildindex_flush_status()
        }
    }
}

func NewMyStatusMonitor() MyStatusMonitor {
  om := &overwrittenMethodsOnIndexStatus{}
  ins := NewDirectorIndexStatus(om)
  om.is = ins

  isgs := &myStatusMonitor{IndexStatus: ins}
  return isgs
}

func DeleteMyStatusMonitor(isgs MyStatusMonitor) {
    isgs.DeleteIndexStatus()
}

//
// the GO type MyDocumentMetaEditor is subclassed from C++ type vank::api::IndexDocumentMetaCallback
// this requires that director feature be enabled, look for
// '%module(directors="1") modulename' under ifdef SWIGGO in vank.i and look
// for '%feature("director") modulename' in IndexEnvironment.i
//
// MyDocumentMetaEditor is a superset of IndexDocumentMetaCallback and hence can be used as a
// drop in replacement for IndexDocumentMetaCallback but the reverse causes a compile time
// error. refer to swig docs for details (SWIG 3.0: 23.4.7 Go Director Classes)
//
type MyDocumentMetaEditor interface {
  IndexDocumentMetaCallback
  DeleteIndexDocumentMetaCallback()
  IsIndexDocumentMetaCallback()
}

// Via embedding myDocumentMetaEditor "inherits" all methods of IndexDocumentMetaCallback.
// idmcgs => Index Document Meta Callback GO Structure
type myDocumentMetaEditor struct {
  IndexDocumentMetaCallback
}

func (idmcgs *myDocumentMetaEditor) DeleteIndexDocumentMetaCallback() {
  DeleteDirectorIndexDocumentMetaCallback(idmcgs.IndexDocumentMetaCallback)
}

func (idmcgs *myDocumentMetaEditor) IsIndexDocumentMetaCallback() {}

type overwrittenMethodsOnIndexDocumentMetaCallback struct {
  idmc IndexDocumentMetaCallback
}

func (om *overwrittenMethodsOnIndexDocumentMetaCallback) DocMetaCallback( docType int, docClass string, metadata MetadataPairVector ) {

    // C++ code defines class local enums, method signature uses int for code
    // swiggo generates constants we cannot use because of signature mismatch
    // note: must match C++ definition
    const (
        FileSource = iota
        StringSource
    )

    vs := int(metadata.Size())

    switch(docType) {
      case FileSource:
        Buildindex_print_event( fmt.Sprintf("File document class %v metadata size %v", docClass, vs) )
        for i := 0; i < vs; i++ {
            m := metadata.Get(i)

            p := m.GetValue()
            len := m.GetValueLength()
            s := (*[1<<30]byte)(unsafe.Pointer(p))[:len]
            _swig_ret := make([]byte, len, len)

            i := copy(_swig_ret, s)
//            if i != len {
//                err := fmt.Errorf("Wrapped_MetadataPair.WGetValue: expected to copy %v but copied %v", len, i)
//            }

            Buildindex_print_event( fmt.Sprintf("  metadata %v: %v = %v\n", i, p, string(_swig_ret)) )
        }
        break;

      case StringSource:
        Buildindex_print_event( fmt.Sprintf("String document class %v", docClass) )
        break;

      default:
        Buildindex_print_event( fmt.Sprintf("Invalid document type %v", docType) )
        break;
    }
}

func NewMyDocumentMetaEditor() MyDocumentMetaEditor {
  om := &overwrittenMethodsOnIndexDocumentMetaCallback{}
  ins := NewDirectorIndexDocumentMetaCallback(om)
  om.idmc = ins

  idmcgs := &myDocumentMetaEditor{IndexDocumentMetaCallback: ins}
  return idmcgs
}

func DeleteMyDocumentMetaEditor(idmcgs MyDocumentMetaEditor) {
    idmcgs.DeleteIndexDocumentMetaCallback()
}

%}

#endif
