
#ifndef SWIGGO
%typemap(javaimports) vank::query::QueryExpander "import java.util.Map;"
%typemap(javaimports) vank::query::RMExpander "import java.util.Map;"
%typemap(javaimports) vank::query::PonteExpander "import java.util.Map;"
#endif

namespace vank
{
  namespace query
  {
    class QueryExpander {
    public:
      QueryExpander( vank::api::QueryEnvironment * env , vank::api::Parameters& param );
      virtual ~QueryExpander() {};

      // runs original query, expands query based on results ( via expand( .. ) ), then runs expanded query
      std::vector<vank::api::ScoredExtentResult> runExpandedQuery( std::string originalQuery , int resultsRequested , bool verbose = false );

      // creates expanded query from an original query and a ranked list of documents
      virtual std::string expand( std::string originalQuery , std::vector<vank::api::ScoredExtentResult>& results ) = 0;
    };

    class RMExpander : public QueryExpander  {
    public:
      RMExpander( vank::api::QueryEnvironment * env , vank::api::Parameters& param );

      virtual std::string expand( std::string originalQuery , std::vector<vank::api::ScoredExtentResult>& results );
    };
    class PonteExpander : public QueryExpander  {
    public:
      PonteExpander( vank::api::QueryEnvironment * env , vank::api::Parameters& param );

      virtual std::string expand( std::string originalQuery, std::vector<vank::api::ScoredExtentResult>& results );
    };
  }
}
