//========================================================================
//
// BuiltinFontTables.cc
//
// Copyright 2001-2003 Glyph & Cog, LLC
//
//========================================================================

#include <aconf.h>
#include <stdlib.h>
#include "FontEncodingTables.h"
#include "BuiltinFontTables.h"

static BuiltinFontWidth courierWidthsTab[] = {
  { (char*)"Ntilde",                            600, NULL },
  { (char*)"rcaron",                            600, NULL },
  { (char*)"kcommaaccent",                      600, NULL },
  { (char*)"Ncommaaccent",                      600, NULL },
  { (char*)"Zacute",                            600, NULL },
  { (char*)"comma",                             600, NULL },
  { (char*)"cedilla",                           600, NULL },
  { (char*)"plusminus",                         600, NULL },
  { (char*)"circumflex",                        600, NULL },
  { (char*)"dotaccent",                         600, NULL },
  { (char*)"edotaccent",                        600, NULL },
  { (char*)"asciitilde",                        600, NULL },
  { (char*)"colon",                             600, NULL },
  { (char*)"onehalf",                           600, NULL },
  { (char*)"dollar",                            600, NULL },
  { (char*)"Lcaron",                            600, NULL },
  { (char*)"ntilde",                            600, NULL },
  { (char*)"Aogonek",                           600, NULL },
  { (char*)"ncommaaccent",                      600, NULL },
  { (char*)"minus",                             600, NULL },
  { (char*)"Iogonek",                           600, NULL },
  { (char*)"zacute",                            600, NULL },
  { (char*)"yen",                               600, NULL },
  { (char*)"space",                             600, NULL },
  { (char*)"Omacron",                           600, NULL },
  { (char*)"questiondown",                      600, NULL },
  { (char*)"emdash",                            600, NULL },
  { (char*)"Agrave",                            600, NULL },
  { (char*)"three",                             600, NULL },
  { (char*)"numbersign",                        600, NULL },
  { (char*)"lcaron",                            600, NULL },
  { (char*)"A",                                 600, NULL },
  { (char*)"B",                                 600, NULL },
  { (char*)"C",                                 600, NULL },
  { (char*)"aogonek",                           600, NULL },
  { (char*)"D",                                 600, NULL },
  { (char*)"E",                                 600, NULL },
  { (char*)"onequarter",                        600, NULL },
  { (char*)"F",                                 600, NULL },
  { (char*)"G",                                 600, NULL },
  { (char*)"H",                                 600, NULL },
  { (char*)"I",                                 600, NULL },
  { (char*)"J",                                 600, NULL },
  { (char*)"K",                                 600, NULL },
  { (char*)"iogonek",                           600, NULL },
  { (char*)"L",                                 600, NULL },
  { (char*)"backslash",                         600, NULL },
  { (char*)"periodcentered",                    600, NULL },
  { (char*)"M",                                 600, NULL },
  { (char*)"N",                                 600, NULL },
  { (char*)"omacron",                           600, NULL },
  { (char*)"Tcommaaccent",                      600, NULL },
  { (char*)"O",                                 600, NULL },
  { (char*)"P",                                 600, NULL },
  { (char*)"Q",                                 600, NULL },
  { (char*)"Uhungarumlaut",                     600, NULL },
  { (char*)"R",                                 600, NULL },
  { (char*)"Aacute",                            600, NULL },
  { (char*)"caron",                             600, NULL },
  { (char*)"S",                                 600, NULL },
  { (char*)"T",                                 600, NULL },
  { (char*)"U",                                 600, NULL },
  { (char*)"agrave",                            600, NULL },
  { (char*)"V",                                 600, NULL },
  { (char*)"W",                                 600, NULL },
  { (char*)"equal",                             600, NULL },
  { (char*)"question",                          600, NULL },
  { (char*)"X",                                 600, NULL },
  { (char*)"Y",                                 600, NULL },
  { (char*)"Z",                                 600, NULL },
  { (char*)"four",                              600, NULL },
  { (char*)"a",                                 600, NULL },
  { (char*)"Gcommaaccent",                      600, NULL },
  { (char*)"b",                                 600, NULL },
  { (char*)"c",                                 600, NULL },
  { (char*)"d",                                 600, NULL },
  { (char*)"e",                                 600, NULL },
  { (char*)"f",                                 600, NULL },
  { (char*)"g",                                 600, NULL },
  { (char*)"bullet",                            600, NULL },
  { (char*)"h",                                 600, NULL },
  { (char*)"i",                                 600, NULL },
  { (char*)"Oslash",                            600, NULL },
  { (char*)"dagger",                            600, NULL },
  { (char*)"j",                                 600, NULL },
  { (char*)"k",                                 600, NULL },
  { (char*)"l",                                 600, NULL },
  { (char*)"m",                                 600, NULL },
  { (char*)"n",                                 600, NULL },
  { (char*)"tcommaaccent",                      600, NULL },
  { (char*)"o",                                 600, NULL },
  { (char*)"ordfeminine",                       600, NULL },
  { (char*)"ring",                              600, NULL },
  { (char*)"p",                                 600, NULL },
  { (char*)"q",                                 600, NULL },
  { (char*)"uhungarumlaut",                     600, NULL },
  { (char*)"r",                                 600, NULL },
  { (char*)"twosuperior",                       600, NULL },
  { (char*)"aacute",                            600, NULL },
  { (char*)"s",                                 600, NULL },
  { (char*)"OE",                                600, NULL },
  { (char*)"t",                                 600, NULL },
  { (char*)"divide",                            600, NULL },
  { (char*)"u",                                 600, NULL },
  { (char*)"Ccaron",                            600, NULL },
  { (char*)"v",                                 600, NULL },
  { (char*)"w",                                 600, NULL },
  { (char*)"x",                                 600, NULL },
  { (char*)"y",                                 600, NULL },
  { (char*)"z",                                 600, NULL },
  { (char*)"Gbreve",                            600, NULL },
  { (char*)"commaaccent",                       600, NULL },
  { (char*)"hungarumlaut",                      600, NULL },
  { (char*)"Idotaccent",                        600, NULL },
  { (char*)"Nacute",                            600, NULL },
  { (char*)"quotedbl",                          600, NULL },
  { (char*)"gcommaaccent",                      600, NULL },
  { (char*)"mu",                                600, NULL },
  { (char*)"greaterequal",                      600, NULL },
  { (char*)"Scaron",                            600, NULL },
  { (char*)"Lslash",                            600, NULL },
  { (char*)"semicolon",                         600, NULL },
  { (char*)"oslash",                            600, NULL },
  { (char*)"lessequal",                         600, NULL },
  { (char*)"lozenge",                           600, NULL },
  { (char*)"parenright",                        600, NULL },
  { (char*)"ccaron",                            600, NULL },
  { (char*)"Ecircumflex",                       600, NULL },
  { (char*)"gbreve",                            600, NULL },
  { (char*)"trademark",                         600, NULL },
  { (char*)"daggerdbl",                         600, NULL },
  { (char*)"nacute",                            600, NULL },
  { (char*)"macron",                            600, NULL },
  { (char*)"Otilde",                            600, NULL },
  { (char*)"Emacron",                           600, NULL },
  { (char*)"ellipsis",                          600, NULL },
  { (char*)"scaron",                            600, NULL },
  { (char*)"AE",                                600, NULL },
  { (char*)"Ucircumflex",                       600, NULL },
  { (char*)"lslash",                            600, NULL },
  { (char*)"quotedblleft",                      600, NULL },
  { (char*)"hyphen",                            600, NULL },
  { (char*)"guilsinglright",                    600, NULL },
  { (char*)"quotesingle",                       600, NULL },
  { (char*)"eight",                             600, NULL },
  { (char*)"exclamdown",                        600, NULL },
  { (char*)"endash",                            600, NULL },
  { (char*)"oe",                                600, NULL },
  { (char*)"Abreve",                            600, NULL },
  { (char*)"Umacron",                           600, NULL },
  { (char*)"ecircumflex",                       600, NULL },
  { (char*)"Adieresis",                         600, NULL },
  { (char*)"copyright",                         600, NULL },
  { (char*)"Egrave",                            600, NULL },
  { (char*)"slash",                             600, NULL },
  { (char*)"Edieresis",                         600, NULL },
  { (char*)"otilde",                            600, NULL },
  { (char*)"Idieresis",                         600, NULL },
  { (char*)"parenleft",                         600, NULL },
  { (char*)"one",                               600, NULL },
  { (char*)"emacron",                           600, NULL },
  { (char*)"Odieresis",                         600, NULL },
  { (char*)"ucircumflex",                       600, NULL },
  { (char*)"bracketleft",                       600, NULL },
  { (char*)"Ugrave",                            600, NULL },
  { (char*)"quoteright",                        600, NULL },
  { (char*)"Udieresis",                         600, NULL },
  { (char*)"perthousand",                       600, NULL },
  { (char*)"Ydieresis",                         600, NULL },
  { (char*)"umacron",                           600, NULL },
  { (char*)"abreve",                            600, NULL },
  { (char*)"Eacute",                            600, NULL },
  { (char*)"adieresis",                         600, NULL },
  { (char*)"egrave",                            600, NULL },
  { (char*)"edieresis",                         600, NULL },
  { (char*)"idieresis",                         600, NULL },
  { (char*)"Eth",                               600, NULL },
  { (char*)"ae",                                600, NULL },
  { (char*)"asterisk",                          600, NULL },
  { (char*)"odieresis",                         600, NULL },
  { (char*)"Uacute",                            600, NULL },
  { (char*)"ugrave",                            600, NULL },
  { (char*)"five",                              600, NULL },
  { (char*)"nine",                              600, NULL },
  { (char*)"udieresis",                         600, NULL },
  { (char*)"Zcaron",                            600, NULL },
  { (char*)"Scommaaccent",                      600, NULL },
  { (char*)"threequarters",                     600, NULL },
  { (char*)"guillemotright",                    600, NULL },
  { (char*)"Ccedilla",                          600, NULL },
  { (char*)"ydieresis",                         600, NULL },
  { (char*)"tilde",                             600, NULL },
  { (char*)"at",                                600, NULL },
  { (char*)"eacute",                            600, NULL },
  { (char*)"underscore",                        600, NULL },
  { (char*)"Euro",                              600, NULL },
  { (char*)"Dcroat",                            600, NULL },
  { (char*)"zero",                              600, NULL },
  { (char*)"multiply",                          600, NULL },
  { (char*)"eth",                               600, NULL },
  { (char*)"Scedilla",                          600, NULL },
  { (char*)"Racute",                            600, NULL },
  { (char*)"Ograve",                            600, NULL },
  { (char*)"partialdiff",                       600, NULL },
  { (char*)"uacute",                            600, NULL },
  { (char*)"braceleft",                         600, NULL },
  { (char*)"Thorn",                             600, NULL },
  { (char*)"zcaron",                            600, NULL },
  { (char*)"scommaaccent",                      600, NULL },
  { (char*)"ccedilla",                          600, NULL },
  { (char*)"Dcaron",                            600, NULL },
  { (char*)"dcroat",                            600, NULL },
  { (char*)"scedilla",                          600, NULL },
  { (char*)"Oacute",                            600, NULL },
  { (char*)"Ocircumflex",                       600, NULL },
  { (char*)"ogonek",                            600, NULL },
  { (char*)"ograve",                            600, NULL },
  { (char*)"racute",                            600, NULL },
  { (char*)"Tcaron",                            600, NULL },
  { (char*)"Eogonek",                           600, NULL },
  { (char*)"thorn",                             600, NULL },
  { (char*)"degree",                            600, NULL },
  { (char*)"registered",                        600, NULL },
  { (char*)"radical",                           600, NULL },
  { (char*)"Aring",                             600, NULL },
  { (char*)"percent",                           600, NULL },
  { (char*)"six",                               600, NULL },
  { (char*)"paragraph",                         600, NULL },
  { (char*)"dcaron",                            600, NULL },
  { (char*)"Uogonek",                           600, NULL },
  { (char*)"two",                               600, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            600, NULL },
  { (char*)"Lacute",                            600, NULL },
  { (char*)"ocircumflex",                       600, NULL },
  { (char*)"oacute",                            600, NULL },
  { (char*)"Uring",                             600, NULL },
  { (char*)"Lcommaaccent",                      600, NULL },
  { (char*)"tcaron",                            600, NULL },
  { (char*)"eogonek",                           600, NULL },
  { (char*)"Delta",                             600, NULL },
  { (char*)"Ohungarumlaut",                     600, NULL },
  { (char*)"asciicircum",                       600, NULL },
  { (char*)"aring",                             600, NULL },
  { (char*)"grave",                             600, NULL },
  { (char*)"uogonek",                           600, NULL },
  { (char*)"bracketright",                      600, NULL },
  { (char*)"ampersand",                         600, NULL },
  { (char*)"Iacute",                            600, NULL },
  { (char*)"lacute",                            600, NULL },
  { (char*)"igrave",                            600, NULL },
  { (char*)"Ncaron",                            600, NULL },
  { (char*)"plus",                              600, NULL },
  { (char*)"uring",                             600, NULL },
  { (char*)"quotesinglbase",                    600, NULL },
  { (char*)"lcommaaccent",                      600, NULL },
  { (char*)"Yacute",                            600, NULL },
  { (char*)"ohungarumlaut",                     600, NULL },
  { (char*)"threesuperior",                     600, NULL },
  { (char*)"acute",                             600, NULL },
  { (char*)"section",                           600, NULL },
  { (char*)"dieresis",                          600, NULL },
  { (char*)"quotedblbase",                      600, NULL },
  { (char*)"iacute",                            600, NULL },
  { (char*)"ncaron",                            600, NULL },
  { (char*)"florin",                            600, NULL },
  { (char*)"yacute",                            600, NULL },
  { (char*)"Rcommaaccent",                      600, NULL },
  { (char*)"fi",                                600, NULL },
  { (char*)"fl",                                600, NULL },
  { (char*)"Acircumflex",                       600, NULL },
  { (char*)"Cacute",                            600, NULL },
  { (char*)"Icircumflex",                       600, NULL },
  { (char*)"guillemotleft",                     600, NULL },
  { (char*)"germandbls",                        600, NULL },
  { (char*)"seven",                             600, NULL },
  { (char*)"Amacron",                           600, NULL },
  { (char*)"Sacute",                            600, NULL },
  { (char*)"ordmasculine",                      600, NULL },
  { (char*)"dotlessi",                          600, NULL },
  { (char*)"sterling",                          600, NULL },
  { (char*)"notequal",                          600, NULL },
  { (char*)"Imacron",                           600, NULL },
  { (char*)"rcommaaccent",                      600, NULL },
  { (char*)"Zdotaccent",                        600, NULL },
  { (char*)"acircumflex",                       600, NULL },
  { (char*)"cacute",                            600, NULL },
  { (char*)"Ecaron",                            600, NULL },
  { (char*)"braceright",                        600, NULL },
  { (char*)"icircumflex",                       600, NULL },
  { (char*)"quotedblright",                     600, NULL },
  { (char*)"amacron",                           600, NULL },
  { (char*)"sacute",                            600, NULL },
  { (char*)"imacron",                           600, NULL },
  { (char*)"cent",                              600, NULL },
  { (char*)"currency",                          600, NULL },
  { (char*)"logicalnot",                        600, NULL },
  { (char*)"zdotaccent",                        600, NULL },
  { (char*)"Atilde",                            600, NULL },
  { (char*)"breve",                             600, NULL },
  { (char*)"bar",                               600, NULL },
  { (char*)"fraction",                          600, NULL },
  { (char*)"less",                              600, NULL },
  { (char*)"ecaron",                            600, NULL },
  { (char*)"guilsinglleft",                     600, NULL },
  { (char*)"exclam",                            600, NULL },
  { (char*)"period",                            600, NULL },
  { (char*)"Rcaron",                            600, NULL },
  { (char*)"Kcommaaccent",                      600, NULL },
  { (char*)"greater",                           600, NULL },
  { (char*)"atilde",                            600, NULL },
  { (char*)"brokenbar",                         600, NULL },
  { (char*)"quoteleft",                         600, NULL },
  { (char*)"Edotaccent",                        600, NULL },
  { (char*)"onesuperior",                       600, NULL }
};

static BuiltinFontWidth courierBoldWidthsTab[] = {
  { (char*)"Ntilde",                            600, NULL },
  { (char*)"rcaron",                            600, NULL },
  { (char*)"kcommaaccent",                      600, NULL },
  { (char*)"Ncommaaccent",                      600, NULL },
  { (char*)"Zacute",                            600, NULL },
  { (char*)"comma",                             600, NULL },
  { (char*)"cedilla",                           600, NULL },
  { (char*)"plusminus",                         600, NULL },
  { (char*)"circumflex",                        600, NULL },
  { (char*)"dotaccent",                         600, NULL },
  { (char*)"edotaccent",                        600, NULL },
  { (char*)"asciitilde",                        600, NULL },
  { (char*)"colon",                             600, NULL },
  { (char*)"onehalf",                           600, NULL },
  { (char*)"dollar",                            600, NULL },
  { (char*)"Lcaron",                            600, NULL },
  { (char*)"ntilde",                            600, NULL },
  { (char*)"Aogonek",                           600, NULL },
  { (char*)"ncommaaccent",                      600, NULL },
  { (char*)"minus",                             600, NULL },
  { (char*)"Iogonek",                           600, NULL },
  { (char*)"zacute",                            600, NULL },
  { (char*)"yen",                               600, NULL },
  { (char*)"space",                             600, NULL },
  { (char*)"Omacron",                           600, NULL },
  { (char*)"questiondown",                      600, NULL },
  { (char*)"emdash",                            600, NULL },
  { (char*)"Agrave",                            600, NULL },
  { (char*)"three",                             600, NULL },
  { (char*)"numbersign",                        600, NULL },
  { (char*)"lcaron",                            600, NULL },
  { (char*)"A",                                 600, NULL },
  { (char*)"B",                                 600, NULL },
  { (char*)"C",                                 600, NULL },
  { (char*)"aogonek",                           600, NULL },
  { (char*)"D",                                 600, NULL },
  { (char*)"E",                                 600, NULL },
  { (char*)"onequarter",                        600, NULL },
  { (char*)"F",                                 600, NULL },
  { (char*)"G",                                 600, NULL },
  { (char*)"H",                                 600, NULL },
  { (char*)"I",                                 600, NULL },
  { (char*)"J",                                 600, NULL },
  { (char*)"K",                                 600, NULL },
  { (char*)"iogonek",                           600, NULL },
  { (char*)"backslash",                         600, NULL },
  { (char*)"L",                                 600, NULL },
  { (char*)"periodcentered",                    600, NULL },
  { (char*)"M",                                 600, NULL },
  { (char*)"N",                                 600, NULL },
  { (char*)"omacron",                           600, NULL },
  { (char*)"Tcommaaccent",                      600, NULL },
  { (char*)"O",                                 600, NULL },
  { (char*)"P",                                 600, NULL },
  { (char*)"Q",                                 600, NULL },
  { (char*)"Uhungarumlaut",                     600, NULL },
  { (char*)"R",                                 600, NULL },
  { (char*)"Aacute",                            600, NULL },
  { (char*)"caron",                             600, NULL },
  { (char*)"S",                                 600, NULL },
  { (char*)"T",                                 600, NULL },
  { (char*)"U",                                 600, NULL },
  { (char*)"agrave",                            600, NULL },
  { (char*)"V",                                 600, NULL },
  { (char*)"W",                                 600, NULL },
  { (char*)"X",                                 600, NULL },
  { (char*)"question",                          600, NULL },
  { (char*)"equal",                             600, NULL },
  { (char*)"Y",                                 600, NULL },
  { (char*)"Z",                                 600, NULL },
  { (char*)"four",                              600, NULL },
  { (char*)"a",                                 600, NULL },
  { (char*)"Gcommaaccent",                      600, NULL },
  { (char*)"b",                                 600, NULL },
  { (char*)"c",                                 600, NULL },
  { (char*)"d",                                 600, NULL },
  { (char*)"e",                                 600, NULL },
  { (char*)"f",                                 600, NULL },
  { (char*)"g",                                 600, NULL },
  { (char*)"bullet",                            600, NULL },
  { (char*)"h",                                 600, NULL },
  { (char*)"i",                                 600, NULL },
  { (char*)"Oslash",                            600, NULL },
  { (char*)"dagger",                            600, NULL },
  { (char*)"j",                                 600, NULL },
  { (char*)"k",                                 600, NULL },
  { (char*)"l",                                 600, NULL },
  { (char*)"m",                                 600, NULL },
  { (char*)"n",                                 600, NULL },
  { (char*)"tcommaaccent",                      600, NULL },
  { (char*)"o",                                 600, NULL },
  { (char*)"ordfeminine",                       600, NULL },
  { (char*)"ring",                              600, NULL },
  { (char*)"p",                                 600, NULL },
  { (char*)"q",                                 600, NULL },
  { (char*)"uhungarumlaut",                     600, NULL },
  { (char*)"r",                                 600, NULL },
  { (char*)"twosuperior",                       600, NULL },
  { (char*)"aacute",                            600, NULL },
  { (char*)"s",                                 600, NULL },
  { (char*)"OE",                                600, NULL },
  { (char*)"t",                                 600, NULL },
  { (char*)"divide",                            600, NULL },
  { (char*)"u",                                 600, NULL },
  { (char*)"Ccaron",                            600, NULL },
  { (char*)"v",                                 600, NULL },
  { (char*)"w",                                 600, NULL },
  { (char*)"x",                                 600, NULL },
  { (char*)"y",                                 600, NULL },
  { (char*)"z",                                 600, NULL },
  { (char*)"Gbreve",                            600, NULL },
  { (char*)"commaaccent",                       600, NULL },
  { (char*)"hungarumlaut",                      600, NULL },
  { (char*)"Idotaccent",                        600, NULL },
  { (char*)"Nacute",                            600, NULL },
  { (char*)"quotedbl",                          600, NULL },
  { (char*)"gcommaaccent",                      600, NULL },
  { (char*)"mu",                                600, NULL },
  { (char*)"greaterequal",                      600, NULL },
  { (char*)"Scaron",                            600, NULL },
  { (char*)"Lslash",                            600, NULL },
  { (char*)"semicolon",                         600, NULL },
  { (char*)"oslash",                            600, NULL },
  { (char*)"lessequal",                         600, NULL },
  { (char*)"lozenge",                           600, NULL },
  { (char*)"parenright",                        600, NULL },
  { (char*)"ccaron",                            600, NULL },
  { (char*)"Ecircumflex",                       600, NULL },
  { (char*)"gbreve",                            600, NULL },
  { (char*)"trademark",                         600, NULL },
  { (char*)"daggerdbl",                         600, NULL },
  { (char*)"nacute",                            600, NULL },
  { (char*)"macron",                            600, NULL },
  { (char*)"Otilde",                            600, NULL },
  { (char*)"Emacron",                           600, NULL },
  { (char*)"ellipsis",                          600, NULL },
  { (char*)"scaron",                            600, NULL },
  { (char*)"AE",                                600, NULL },
  { (char*)"Ucircumflex",                       600, NULL },
  { (char*)"lslash",                            600, NULL },
  { (char*)"quotedblleft",                      600, NULL },
  { (char*)"guilsinglright",                    600, NULL },
  { (char*)"hyphen",                            600, NULL },
  { (char*)"quotesingle",                       600, NULL },
  { (char*)"eight",                             600, NULL },
  { (char*)"exclamdown",                        600, NULL },
  { (char*)"endash",                            600, NULL },
  { (char*)"oe",                                600, NULL },
  { (char*)"Abreve",                            600, NULL },
  { (char*)"Umacron",                           600, NULL },
  { (char*)"ecircumflex",                       600, NULL },
  { (char*)"Adieresis",                         600, NULL },
  { (char*)"copyright",                         600, NULL },
  { (char*)"Egrave",                            600, NULL },
  { (char*)"slash",                             600, NULL },
  { (char*)"Edieresis",                         600, NULL },
  { (char*)"otilde",                            600, NULL },
  { (char*)"Idieresis",                         600, NULL },
  { (char*)"parenleft",                         600, NULL },
  { (char*)"one",                               600, NULL },
  { (char*)"emacron",                           600, NULL },
  { (char*)"Odieresis",                         600, NULL },
  { (char*)"ucircumflex",                       600, NULL },
  { (char*)"bracketleft",                       600, NULL },
  { (char*)"Ugrave",                            600, NULL },
  { (char*)"quoteright",                        600, NULL },
  { (char*)"Udieresis",                         600, NULL },
  { (char*)"perthousand",                       600, NULL },
  { (char*)"Ydieresis",                         600, NULL },
  { (char*)"umacron",                           600, NULL },
  { (char*)"abreve",                            600, NULL },
  { (char*)"Eacute",                            600, NULL },
  { (char*)"adieresis",                         600, NULL },
  { (char*)"egrave",                            600, NULL },
  { (char*)"edieresis",                         600, NULL },
  { (char*)"idieresis",                         600, NULL },
  { (char*)"Eth",                               600, NULL },
  { (char*)"ae",                                600, NULL },
  { (char*)"asterisk",                          600, NULL },
  { (char*)"odieresis",                         600, NULL },
  { (char*)"Uacute",                            600, NULL },
  { (char*)"ugrave",                            600, NULL },
  { (char*)"nine",                              600, NULL },
  { (char*)"five",                              600, NULL },
  { (char*)"udieresis",                         600, NULL },
  { (char*)"Zcaron",                            600, NULL },
  { (char*)"Scommaaccent",                      600, NULL },
  { (char*)"threequarters",                     600, NULL },
  { (char*)"guillemotright",                    600, NULL },
  { (char*)"Ccedilla",                          600, NULL },
  { (char*)"ydieresis",                         600, NULL },
  { (char*)"tilde",                             600, NULL },
  { (char*)"at",                                600, NULL },
  { (char*)"eacute",                            600, NULL },
  { (char*)"underscore",                        600, NULL },
  { (char*)"Euro",                              600, NULL },
  { (char*)"Dcroat",                            600, NULL },
  { (char*)"multiply",                          600, NULL },
  { (char*)"zero",                              600, NULL },
  { (char*)"eth",                               600, NULL },
  { (char*)"Scedilla",                          600, NULL },
  { (char*)"Ograve",                            600, NULL },
  { (char*)"Racute",                            600, NULL },
  { (char*)"partialdiff",                       600, NULL },
  { (char*)"uacute",                            600, NULL },
  { (char*)"braceleft",                         600, NULL },
  { (char*)"Thorn",                             600, NULL },
  { (char*)"zcaron",                            600, NULL },
  { (char*)"scommaaccent",                      600, NULL },
  { (char*)"ccedilla",                          600, NULL },
  { (char*)"Dcaron",                            600, NULL },
  { (char*)"dcroat",                            600, NULL },
  { (char*)"Ocircumflex",                       600, NULL },
  { (char*)"Oacute",                            600, NULL },
  { (char*)"scedilla",                          600, NULL },
  { (char*)"ogonek",                            600, NULL },
  { (char*)"ograve",                            600, NULL },
  { (char*)"racute",                            600, NULL },
  { (char*)"Tcaron",                            600, NULL },
  { (char*)"Eogonek",                           600, NULL },
  { (char*)"thorn",                             600, NULL },
  { (char*)"degree",                            600, NULL },
  { (char*)"registered",                        600, NULL },
  { (char*)"radical",                           600, NULL },
  { (char*)"Aring",                             600, NULL },
  { (char*)"percent",                           600, NULL },
  { (char*)"six",                               600, NULL },
  { (char*)"paragraph",                         600, NULL },
  { (char*)"dcaron",                            600, NULL },
  { (char*)"Uogonek",                           600, NULL },
  { (char*)"two",                               600, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            600, NULL },
  { (char*)"Lacute",                            600, NULL },
  { (char*)"ocircumflex",                       600, NULL },
  { (char*)"oacute",                            600, NULL },
  { (char*)"Uring",                             600, NULL },
  { (char*)"Lcommaaccent",                      600, NULL },
  { (char*)"tcaron",                            600, NULL },
  { (char*)"eogonek",                           600, NULL },
  { (char*)"Delta",                             600, NULL },
  { (char*)"Ohungarumlaut",                     600, NULL },
  { (char*)"asciicircum",                       600, NULL },
  { (char*)"aring",                             600, NULL },
  { (char*)"grave",                             600, NULL },
  { (char*)"uogonek",                           600, NULL },
  { (char*)"bracketright",                      600, NULL },
  { (char*)"Iacute",                            600, NULL },
  { (char*)"ampersand",                         600, NULL },
  { (char*)"igrave",                            600, NULL },
  { (char*)"lacute",                            600, NULL },
  { (char*)"Ncaron",                            600, NULL },
  { (char*)"plus",                              600, NULL },
  { (char*)"uring",                             600, NULL },
  { (char*)"quotesinglbase",                    600, NULL },
  { (char*)"lcommaaccent",                      600, NULL },
  { (char*)"Yacute",                            600, NULL },
  { (char*)"ohungarumlaut",                     600, NULL },
  { (char*)"threesuperior",                     600, NULL },
  { (char*)"acute",                             600, NULL },
  { (char*)"section",                           600, NULL },
  { (char*)"dieresis",                          600, NULL },
  { (char*)"iacute",                            600, NULL },
  { (char*)"quotedblbase",                      600, NULL },
  { (char*)"ncaron",                            600, NULL },
  { (char*)"florin",                            600, NULL },
  { (char*)"yacute",                            600, NULL },
  { (char*)"Rcommaaccent",                      600, NULL },
  { (char*)"fi",                                600, NULL },
  { (char*)"fl",                                600, NULL },
  { (char*)"Acircumflex",                       600, NULL },
  { (char*)"Cacute",                            600, NULL },
  { (char*)"Icircumflex",                       600, NULL },
  { (char*)"guillemotleft",                     600, NULL },
  { (char*)"germandbls",                        600, NULL },
  { (char*)"Amacron",                           600, NULL },
  { (char*)"seven",                             600, NULL },
  { (char*)"Sacute",                            600, NULL },
  { (char*)"ordmasculine",                      600, NULL },
  { (char*)"dotlessi",                          600, NULL },
  { (char*)"sterling",                          600, NULL },
  { (char*)"notequal",                          600, NULL },
  { (char*)"Imacron",                           600, NULL },
  { (char*)"rcommaaccent",                      600, NULL },
  { (char*)"Zdotaccent",                        600, NULL },
  { (char*)"acircumflex",                       600, NULL },
  { (char*)"cacute",                            600, NULL },
  { (char*)"Ecaron",                            600, NULL },
  { (char*)"icircumflex",                       600, NULL },
  { (char*)"braceright",                        600, NULL },
  { (char*)"quotedblright",                     600, NULL },
  { (char*)"amacron",                           600, NULL },
  { (char*)"sacute",                            600, NULL },
  { (char*)"imacron",                           600, NULL },
  { (char*)"cent",                              600, NULL },
  { (char*)"currency",                          600, NULL },
  { (char*)"logicalnot",                        600, NULL },
  { (char*)"zdotaccent",                        600, NULL },
  { (char*)"Atilde",                            600, NULL },
  { (char*)"breve",                             600, NULL },
  { (char*)"bar",                               600, NULL },
  { (char*)"fraction",                          600, NULL },
  { (char*)"less",                              600, NULL },
  { (char*)"ecaron",                            600, NULL },
  { (char*)"guilsinglleft",                     600, NULL },
  { (char*)"exclam",                            600, NULL },
  { (char*)"period",                            600, NULL },
  { (char*)"Rcaron",                            600, NULL },
  { (char*)"Kcommaaccent",                      600, NULL },
  { (char*)"greater",                           600, NULL },
  { (char*)"atilde",                            600, NULL },
  { (char*)"brokenbar",                         600, NULL },
  { (char*)"quoteleft",                         600, NULL },
  { (char*)"Edotaccent",                        600, NULL },
  { (char*)"onesuperior",                       600, NULL }
};

static BuiltinFontWidth courierBoldObliqueWidthsTab[] = {
  { (char*)"Ntilde",                            600, NULL },
  { (char*)"rcaron",                            600, NULL },
  { (char*)"kcommaaccent",                      600, NULL },
  { (char*)"Ncommaaccent",                      600, NULL },
  { (char*)"Zacute",                            600, NULL },
  { (char*)"comma",                             600, NULL },
  { (char*)"cedilla",                           600, NULL },
  { (char*)"plusminus",                         600, NULL },
  { (char*)"circumflex",                        600, NULL },
  { (char*)"dotaccent",                         600, NULL },
  { (char*)"edotaccent",                        600, NULL },
  { (char*)"asciitilde",                        600, NULL },
  { (char*)"colon",                             600, NULL },
  { (char*)"onehalf",                           600, NULL },
  { (char*)"dollar",                            600, NULL },
  { (char*)"Lcaron",                            600, NULL },
  { (char*)"ntilde",                            600, NULL },
  { (char*)"Aogonek",                           600, NULL },
  { (char*)"ncommaaccent",                      600, NULL },
  { (char*)"minus",                             600, NULL },
  { (char*)"Iogonek",                           600, NULL },
  { (char*)"zacute",                            600, NULL },
  { (char*)"yen",                               600, NULL },
  { (char*)"space",                             600, NULL },
  { (char*)"Omacron",                           600, NULL },
  { (char*)"questiondown",                      600, NULL },
  { (char*)"emdash",                            600, NULL },
  { (char*)"Agrave",                            600, NULL },
  { (char*)"three",                             600, NULL },
  { (char*)"numbersign",                        600, NULL },
  { (char*)"lcaron",                            600, NULL },
  { (char*)"A",                                 600, NULL },
  { (char*)"B",                                 600, NULL },
  { (char*)"C",                                 600, NULL },
  { (char*)"aogonek",                           600, NULL },
  { (char*)"D",                                 600, NULL },
  { (char*)"E",                                 600, NULL },
  { (char*)"onequarter",                        600, NULL },
  { (char*)"F",                                 600, NULL },
  { (char*)"G",                                 600, NULL },
  { (char*)"H",                                 600, NULL },
  { (char*)"I",                                 600, NULL },
  { (char*)"J",                                 600, NULL },
  { (char*)"K",                                 600, NULL },
  { (char*)"iogonek",                           600, NULL },
  { (char*)"backslash",                         600, NULL },
  { (char*)"L",                                 600, NULL },
  { (char*)"periodcentered",                    600, NULL },
  { (char*)"M",                                 600, NULL },
  { (char*)"N",                                 600, NULL },
  { (char*)"omacron",                           600, NULL },
  { (char*)"Tcommaaccent",                      600, NULL },
  { (char*)"O",                                 600, NULL },
  { (char*)"P",                                 600, NULL },
  { (char*)"Q",                                 600, NULL },
  { (char*)"Uhungarumlaut",                     600, NULL },
  { (char*)"R",                                 600, NULL },
  { (char*)"Aacute",                            600, NULL },
  { (char*)"caron",                             600, NULL },
  { (char*)"S",                                 600, NULL },
  { (char*)"T",                                 600, NULL },
  { (char*)"U",                                 600, NULL },
  { (char*)"agrave",                            600, NULL },
  { (char*)"V",                                 600, NULL },
  { (char*)"W",                                 600, NULL },
  { (char*)"X",                                 600, NULL },
  { (char*)"question",                          600, NULL },
  { (char*)"equal",                             600, NULL },
  { (char*)"Y",                                 600, NULL },
  { (char*)"Z",                                 600, NULL },
  { (char*)"four",                              600, NULL },
  { (char*)"a",                                 600, NULL },
  { (char*)"Gcommaaccent",                      600, NULL },
  { (char*)"b",                                 600, NULL },
  { (char*)"c",                                 600, NULL },
  { (char*)"d",                                 600, NULL },
  { (char*)"e",                                 600, NULL },
  { (char*)"f",                                 600, NULL },
  { (char*)"g",                                 600, NULL },
  { (char*)"bullet",                            600, NULL },
  { (char*)"h",                                 600, NULL },
  { (char*)"i",                                 600, NULL },
  { (char*)"Oslash",                            600, NULL },
  { (char*)"dagger",                            600, NULL },
  { (char*)"j",                                 600, NULL },
  { (char*)"k",                                 600, NULL },
  { (char*)"l",                                 600, NULL },
  { (char*)"m",                                 600, NULL },
  { (char*)"n",                                 600, NULL },
  { (char*)"tcommaaccent",                      600, NULL },
  { (char*)"o",                                 600, NULL },
  { (char*)"ordfeminine",                       600, NULL },
  { (char*)"ring",                              600, NULL },
  { (char*)"p",                                 600, NULL },
  { (char*)"q",                                 600, NULL },
  { (char*)"uhungarumlaut",                     600, NULL },
  { (char*)"r",                                 600, NULL },
  { (char*)"twosuperior",                       600, NULL },
  { (char*)"aacute",                            600, NULL },
  { (char*)"s",                                 600, NULL },
  { (char*)"OE",                                600, NULL },
  { (char*)"t",                                 600, NULL },
  { (char*)"divide",                            600, NULL },
  { (char*)"u",                                 600, NULL },
  { (char*)"Ccaron",                            600, NULL },
  { (char*)"v",                                 600, NULL },
  { (char*)"w",                                 600, NULL },
  { (char*)"x",                                 600, NULL },
  { (char*)"y",                                 600, NULL },
  { (char*)"z",                                 600, NULL },
  { (char*)"Gbreve",                            600, NULL },
  { (char*)"commaaccent",                       600, NULL },
  { (char*)"hungarumlaut",                      600, NULL },
  { (char*)"Idotaccent",                        600, NULL },
  { (char*)"Nacute",                            600, NULL },
  { (char*)"quotedbl",                          600, NULL },
  { (char*)"gcommaaccent",                      600, NULL },
  { (char*)"mu",                                600, NULL },
  { (char*)"greaterequal",                      600, NULL },
  { (char*)"Scaron",                            600, NULL },
  { (char*)"Lslash",                            600, NULL },
  { (char*)"semicolon",                         600, NULL },
  { (char*)"oslash",                            600, NULL },
  { (char*)"lessequal",                         600, NULL },
  { (char*)"lozenge",                           600, NULL },
  { (char*)"parenright",                        600, NULL },
  { (char*)"ccaron",                            600, NULL },
  { (char*)"Ecircumflex",                       600, NULL },
  { (char*)"gbreve",                            600, NULL },
  { (char*)"trademark",                         600, NULL },
  { (char*)"daggerdbl",                         600, NULL },
  { (char*)"nacute",                            600, NULL },
  { (char*)"macron",                            600, NULL },
  { (char*)"Otilde",                            600, NULL },
  { (char*)"Emacron",                           600, NULL },
  { (char*)"ellipsis",                          600, NULL },
  { (char*)"scaron",                            600, NULL },
  { (char*)"AE",                                600, NULL },
  { (char*)"Ucircumflex",                       600, NULL },
  { (char*)"lslash",                            600, NULL },
  { (char*)"quotedblleft",                      600, NULL },
  { (char*)"guilsinglright",                    600, NULL },
  { (char*)"hyphen",                            600, NULL },
  { (char*)"quotesingle",                       600, NULL },
  { (char*)"eight",                             600, NULL },
  { (char*)"exclamdown",                        600, NULL },
  { (char*)"endash",                            600, NULL },
  { (char*)"oe",                                600, NULL },
  { (char*)"Abreve",                            600, NULL },
  { (char*)"Umacron",                           600, NULL },
  { (char*)"ecircumflex",                       600, NULL },
  { (char*)"Adieresis",                         600, NULL },
  { (char*)"copyright",                         600, NULL },
  { (char*)"Egrave",                            600, NULL },
  { (char*)"slash",                             600, NULL },
  { (char*)"Edieresis",                         600, NULL },
  { (char*)"otilde",                            600, NULL },
  { (char*)"Idieresis",                         600, NULL },
  { (char*)"parenleft",                         600, NULL },
  { (char*)"one",                               600, NULL },
  { (char*)"emacron",                           600, NULL },
  { (char*)"Odieresis",                         600, NULL },
  { (char*)"ucircumflex",                       600, NULL },
  { (char*)"bracketleft",                       600, NULL },
  { (char*)"Ugrave",                            600, NULL },
  { (char*)"quoteright",                        600, NULL },
  { (char*)"Udieresis",                         600, NULL },
  { (char*)"perthousand",                       600, NULL },
  { (char*)"Ydieresis",                         600, NULL },
  { (char*)"umacron",                           600, NULL },
  { (char*)"abreve",                            600, NULL },
  { (char*)"Eacute",                            600, NULL },
  { (char*)"adieresis",                         600, NULL },
  { (char*)"egrave",                            600, NULL },
  { (char*)"edieresis",                         600, NULL },
  { (char*)"idieresis",                         600, NULL },
  { (char*)"Eth",                               600, NULL },
  { (char*)"ae",                                600, NULL },
  { (char*)"asterisk",                          600, NULL },
  { (char*)"odieresis",                         600, NULL },
  { (char*)"Uacute",                            600, NULL },
  { (char*)"ugrave",                            600, NULL },
  { (char*)"nine",                              600, NULL },
  { (char*)"five",                              600, NULL },
  { (char*)"udieresis",                         600, NULL },
  { (char*)"Zcaron",                            600, NULL },
  { (char*)"Scommaaccent",                      600, NULL },
  { (char*)"threequarters",                     600, NULL },
  { (char*)"guillemotright",                    600, NULL },
  { (char*)"Ccedilla",                          600, NULL },
  { (char*)"ydieresis",                         600, NULL },
  { (char*)"tilde",                             600, NULL },
  { (char*)"at",                                600, NULL },
  { (char*)"eacute",                            600, NULL },
  { (char*)"underscore",                        600, NULL },
  { (char*)"Euro",                              600, NULL },
  { (char*)"Dcroat",                            600, NULL },
  { (char*)"multiply",                          600, NULL },
  { (char*)"zero",                              600, NULL },
  { (char*)"eth",                               600, NULL },
  { (char*)"Scedilla",                          600, NULL },
  { (char*)"Ograve",                            600, NULL },
  { (char*)"Racute",                            600, NULL },
  { (char*)"partialdiff",                       600, NULL },
  { (char*)"uacute",                            600, NULL },
  { (char*)"braceleft",                         600, NULL },
  { (char*)"Thorn",                             600, NULL },
  { (char*)"zcaron",                            600, NULL },
  { (char*)"scommaaccent",                      600, NULL },
  { (char*)"ccedilla",                          600, NULL },
  { (char*)"Dcaron",                            600, NULL },
  { (char*)"dcroat",                            600, NULL },
  { (char*)"Ocircumflex",                       600, NULL },
  { (char*)"Oacute",                            600, NULL },
  { (char*)"scedilla",                          600, NULL },
  { (char*)"ogonek",                            600, NULL },
  { (char*)"ograve",                            600, NULL },
  { (char*)"racute",                            600, NULL },
  { (char*)"Tcaron",                            600, NULL },
  { (char*)"Eogonek",                           600, NULL },
  { (char*)"thorn",                             600, NULL },
  { (char*)"degree",                            600, NULL },
  { (char*)"registered",                        600, NULL },
  { (char*)"radical",                           600, NULL },
  { (char*)"Aring",                             600, NULL },
  { (char*)"percent",                           600, NULL },
  { (char*)"six",                               600, NULL },
  { (char*)"paragraph",                         600, NULL },
  { (char*)"dcaron",                            600, NULL },
  { (char*)"Uogonek",                           600, NULL },
  { (char*)"two",                               600, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            600, NULL },
  { (char*)"Lacute",                            600, NULL },
  { (char*)"ocircumflex",                       600, NULL },
  { (char*)"oacute",                            600, NULL },
  { (char*)"Uring",                             600, NULL },
  { (char*)"Lcommaaccent",                      600, NULL },
  { (char*)"tcaron",                            600, NULL },
  { (char*)"eogonek",                           600, NULL },
  { (char*)"Delta",                             600, NULL },
  { (char*)"Ohungarumlaut",                     600, NULL },
  { (char*)"asciicircum",                       600, NULL },
  { (char*)"aring",                             600, NULL },
  { (char*)"grave",                             600, NULL },
  { (char*)"uogonek",                           600, NULL },
  { (char*)"bracketright",                      600, NULL },
  { (char*)"Iacute",                            600, NULL },
  { (char*)"ampersand",                         600, NULL },
  { (char*)"igrave",                            600, NULL },
  { (char*)"lacute",                            600, NULL },
  { (char*)"Ncaron",                            600, NULL },
  { (char*)"plus",                              600, NULL },
  { (char*)"uring",                             600, NULL },
  { (char*)"quotesinglbase",                    600, NULL },
  { (char*)"lcommaaccent",                      600, NULL },
  { (char*)"Yacute",                            600, NULL },
  { (char*)"ohungarumlaut",                     600, NULL },
  { (char*)"threesuperior",                     600, NULL },
  { (char*)"acute",                             600, NULL },
  { (char*)"section",                           600, NULL },
  { (char*)"dieresis",                          600, NULL },
  { (char*)"iacute",                            600, NULL },
  { (char*)"quotedblbase",                      600, NULL },
  { (char*)"ncaron",                            600, NULL },
  { (char*)"florin",                            600, NULL },
  { (char*)"yacute",                            600, NULL },
  { (char*)"Rcommaaccent",                      600, NULL },
  { (char*)"fi",                                600, NULL },
  { (char*)"fl",                                600, NULL },
  { (char*)"Acircumflex",                       600, NULL },
  { (char*)"Cacute",                            600, NULL },
  { (char*)"Icircumflex",                       600, NULL },
  { (char*)"guillemotleft",                     600, NULL },
  { (char*)"germandbls",                        600, NULL },
  { (char*)"Amacron",                           600, NULL },
  { (char*)"seven",                             600, NULL },
  { (char*)"Sacute",                            600, NULL },
  { (char*)"ordmasculine",                      600, NULL },
  { (char*)"dotlessi",                          600, NULL },
  { (char*)"sterling",                          600, NULL },
  { (char*)"notequal",                          600, NULL },
  { (char*)"Imacron",                           600, NULL },
  { (char*)"rcommaaccent",                      600, NULL },
  { (char*)"Zdotaccent",                        600, NULL },
  { (char*)"acircumflex",                       600, NULL },
  { (char*)"cacute",                            600, NULL },
  { (char*)"Ecaron",                            600, NULL },
  { (char*)"icircumflex",                       600, NULL },
  { (char*)"braceright",                        600, NULL },
  { (char*)"quotedblright",                     600, NULL },
  { (char*)"amacron",                           600, NULL },
  { (char*)"sacute",                            600, NULL },
  { (char*)"imacron",                           600, NULL },
  { (char*)"cent",                              600, NULL },
  { (char*)"currency",                          600, NULL },
  { (char*)"logicalnot",                        600, NULL },
  { (char*)"zdotaccent",                        600, NULL },
  { (char*)"Atilde",                            600, NULL },
  { (char*)"breve",                             600, NULL },
  { (char*)"bar",                               600, NULL },
  { (char*)"fraction",                          600, NULL },
  { (char*)"less",                              600, NULL },
  { (char*)"ecaron",                            600, NULL },
  { (char*)"guilsinglleft",                     600, NULL },
  { (char*)"exclam",                            600, NULL },
  { (char*)"period",                            600, NULL },
  { (char*)"Rcaron",                            600, NULL },
  { (char*)"Kcommaaccent",                      600, NULL },
  { (char*)"greater",                           600, NULL },
  { (char*)"atilde",                            600, NULL },
  { (char*)"brokenbar",                         600, NULL },
  { (char*)"quoteleft",                         600, NULL },
  { (char*)"Edotaccent",                        600, NULL },
  { (char*)"onesuperior",                       600, NULL }
};

static BuiltinFontWidth courierObliqueWidthsTab[] = {
  { (char*)"Ntilde",                            600, NULL },
  { (char*)"rcaron",                            600, NULL },
  { (char*)"kcommaaccent",                      600, NULL },
  { (char*)"Ncommaaccent",                      600, NULL },
  { (char*)"Zacute",                            600, NULL },
  { (char*)"comma",                             600, NULL },
  { (char*)"cedilla",                           600, NULL },
  { (char*)"plusminus",                         600, NULL },
  { (char*)"circumflex",                        600, NULL },
  { (char*)"dotaccent",                         600, NULL },
  { (char*)"edotaccent",                        600, NULL },
  { (char*)"asciitilde",                        600, NULL },
  { (char*)"colon",                             600, NULL },
  { (char*)"onehalf",                           600, NULL },
  { (char*)"dollar",                            600, NULL },
  { (char*)"Lcaron",                            600, NULL },
  { (char*)"ntilde",                            600, NULL },
  { (char*)"Aogonek",                           600, NULL },
  { (char*)"ncommaaccent",                      600, NULL },
  { (char*)"minus",                             600, NULL },
  { (char*)"Iogonek",                           600, NULL },
  { (char*)"zacute",                            600, NULL },
  { (char*)"yen",                               600, NULL },
  { (char*)"space",                             600, NULL },
  { (char*)"Omacron",                           600, NULL },
  { (char*)"questiondown",                      600, NULL },
  { (char*)"emdash",                            600, NULL },
  { (char*)"Agrave",                            600, NULL },
  { (char*)"three",                             600, NULL },
  { (char*)"numbersign",                        600, NULL },
  { (char*)"lcaron",                            600, NULL },
  { (char*)"A",                                 600, NULL },
  { (char*)"B",                                 600, NULL },
  { (char*)"C",                                 600, NULL },
  { (char*)"aogonek",                           600, NULL },
  { (char*)"D",                                 600, NULL },
  { (char*)"E",                                 600, NULL },
  { (char*)"onequarter",                        600, NULL },
  { (char*)"F",                                 600, NULL },
  { (char*)"G",                                 600, NULL },
  { (char*)"H",                                 600, NULL },
  { (char*)"I",                                 600, NULL },
  { (char*)"J",                                 600, NULL },
  { (char*)"K",                                 600, NULL },
  { (char*)"iogonek",                           600, NULL },
  { (char*)"backslash",                         600, NULL },
  { (char*)"L",                                 600, NULL },
  { (char*)"periodcentered",                    600, NULL },
  { (char*)"M",                                 600, NULL },
  { (char*)"N",                                 600, NULL },
  { (char*)"omacron",                           600, NULL },
  { (char*)"Tcommaaccent",                      600, NULL },
  { (char*)"O",                                 600, NULL },
  { (char*)"P",                                 600, NULL },
  { (char*)"Q",                                 600, NULL },
  { (char*)"Uhungarumlaut",                     600, NULL },
  { (char*)"R",                                 600, NULL },
  { (char*)"Aacute",                            600, NULL },
  { (char*)"caron",                             600, NULL },
  { (char*)"S",                                 600, NULL },
  { (char*)"T",                                 600, NULL },
  { (char*)"U",                                 600, NULL },
  { (char*)"agrave",                            600, NULL },
  { (char*)"V",                                 600, NULL },
  { (char*)"W",                                 600, NULL },
  { (char*)"X",                                 600, NULL },
  { (char*)"question",                          600, NULL },
  { (char*)"equal",                             600, NULL },
  { (char*)"Y",                                 600, NULL },
  { (char*)"Z",                                 600, NULL },
  { (char*)"four",                              600, NULL },
  { (char*)"a",                                 600, NULL },
  { (char*)"Gcommaaccent",                      600, NULL },
  { (char*)"b",                                 600, NULL },
  { (char*)"c",                                 600, NULL },
  { (char*)"d",                                 600, NULL },
  { (char*)"e",                                 600, NULL },
  { (char*)"f",                                 600, NULL },
  { (char*)"g",                                 600, NULL },
  { (char*)"bullet",                            600, NULL },
  { (char*)"h",                                 600, NULL },
  { (char*)"i",                                 600, NULL },
  { (char*)"Oslash",                            600, NULL },
  { (char*)"dagger",                            600, NULL },
  { (char*)"j",                                 600, NULL },
  { (char*)"k",                                 600, NULL },
  { (char*)"l",                                 600, NULL },
  { (char*)"m",                                 600, NULL },
  { (char*)"n",                                 600, NULL },
  { (char*)"tcommaaccent",                      600, NULL },
  { (char*)"o",                                 600, NULL },
  { (char*)"ordfeminine",                       600, NULL },
  { (char*)"ring",                              600, NULL },
  { (char*)"p",                                 600, NULL },
  { (char*)"q",                                 600, NULL },
  { (char*)"uhungarumlaut",                     600, NULL },
  { (char*)"r",                                 600, NULL },
  { (char*)"twosuperior",                       600, NULL },
  { (char*)"aacute",                            600, NULL },
  { (char*)"s",                                 600, NULL },
  { (char*)"OE",                                600, NULL },
  { (char*)"t",                                 600, NULL },
  { (char*)"divide",                            600, NULL },
  { (char*)"u",                                 600, NULL },
  { (char*)"Ccaron",                            600, NULL },
  { (char*)"v",                                 600, NULL },
  { (char*)"w",                                 600, NULL },
  { (char*)"x",                                 600, NULL },
  { (char*)"y",                                 600, NULL },
  { (char*)"z",                                 600, NULL },
  { (char*)"Gbreve",                            600, NULL },
  { (char*)"commaaccent",                       600, NULL },
  { (char*)"hungarumlaut",                      600, NULL },
  { (char*)"Idotaccent",                        600, NULL },
  { (char*)"Nacute",                            600, NULL },
  { (char*)"quotedbl",                          600, NULL },
  { (char*)"gcommaaccent",                      600, NULL },
  { (char*)"mu",                                600, NULL },
  { (char*)"greaterequal",                      600, NULL },
  { (char*)"Scaron",                            600, NULL },
  { (char*)"Lslash",                            600, NULL },
  { (char*)"semicolon",                         600, NULL },
  { (char*)"oslash",                            600, NULL },
  { (char*)"lessequal",                         600, NULL },
  { (char*)"lozenge",                           600, NULL },
  { (char*)"parenright",                        600, NULL },
  { (char*)"ccaron",                            600, NULL },
  { (char*)"Ecircumflex",                       600, NULL },
  { (char*)"gbreve",                            600, NULL },
  { (char*)"trademark",                         600, NULL },
  { (char*)"daggerdbl",                         600, NULL },
  { (char*)"nacute",                            600, NULL },
  { (char*)"macron",                            600, NULL },
  { (char*)"Otilde",                            600, NULL },
  { (char*)"Emacron",                           600, NULL },
  { (char*)"ellipsis",                          600, NULL },
  { (char*)"scaron",                            600, NULL },
  { (char*)"AE",                                600, NULL },
  { (char*)"Ucircumflex",                       600, NULL },
  { (char*)"lslash",                            600, NULL },
  { (char*)"quotedblleft",                      600, NULL },
  { (char*)"guilsinglright",                    600, NULL },
  { (char*)"hyphen",                            600, NULL },
  { (char*)"quotesingle",                       600, NULL },
  { (char*)"eight",                             600, NULL },
  { (char*)"exclamdown",                        600, NULL },
  { (char*)"endash",                            600, NULL },
  { (char*)"oe",                                600, NULL },
  { (char*)"Abreve",                            600, NULL },
  { (char*)"Umacron",                           600, NULL },
  { (char*)"ecircumflex",                       600, NULL },
  { (char*)"Adieresis",                         600, NULL },
  { (char*)"copyright",                         600, NULL },
  { (char*)"Egrave",                            600, NULL },
  { (char*)"slash",                             600, NULL },
  { (char*)"Edieresis",                         600, NULL },
  { (char*)"otilde",                            600, NULL },
  { (char*)"Idieresis",                         600, NULL },
  { (char*)"parenleft",                         600, NULL },
  { (char*)"one",                               600, NULL },
  { (char*)"emacron",                           600, NULL },
  { (char*)"Odieresis",                         600, NULL },
  { (char*)"ucircumflex",                       600, NULL },
  { (char*)"bracketleft",                       600, NULL },
  { (char*)"Ugrave",                            600, NULL },
  { (char*)"quoteright",                        600, NULL },
  { (char*)"Udieresis",                         600, NULL },
  { (char*)"perthousand",                       600, NULL },
  { (char*)"Ydieresis",                         600, NULL },
  { (char*)"umacron",                           600, NULL },
  { (char*)"abreve",                            600, NULL },
  { (char*)"Eacute",                            600, NULL },
  { (char*)"adieresis",                         600, NULL },
  { (char*)"egrave",                            600, NULL },
  { (char*)"edieresis",                         600, NULL },
  { (char*)"idieresis",                         600, NULL },
  { (char*)"Eth",                               600, NULL },
  { (char*)"ae",                                600, NULL },
  { (char*)"asterisk",                          600, NULL },
  { (char*)"odieresis",                         600, NULL },
  { (char*)"Uacute",                            600, NULL },
  { (char*)"ugrave",                            600, NULL },
  { (char*)"nine",                              600, NULL },
  { (char*)"five",                              600, NULL },
  { (char*)"udieresis",                         600, NULL },
  { (char*)"Zcaron",                            600, NULL },
  { (char*)"Scommaaccent",                      600, NULL },
  { (char*)"threequarters",                     600, NULL },
  { (char*)"guillemotright",                    600, NULL },
  { (char*)"Ccedilla",                          600, NULL },
  { (char*)"ydieresis",                         600, NULL },
  { (char*)"tilde",                             600, NULL },
  { (char*)"at",                                600, NULL },
  { (char*)"eacute",                            600, NULL },
  { (char*)"underscore",                        600, NULL },
  { (char*)"Euro",                              600, NULL },
  { (char*)"Dcroat",                            600, NULL },
  { (char*)"multiply",                          600, NULL },
  { (char*)"zero",                              600, NULL },
  { (char*)"eth",                               600, NULL },
  { (char*)"Scedilla",                          600, NULL },
  { (char*)"Ograve",                            600, NULL },
  { (char*)"Racute",                            600, NULL },
  { (char*)"partialdiff",                       600, NULL },
  { (char*)"uacute",                            600, NULL },
  { (char*)"braceleft",                         600, NULL },
  { (char*)"Thorn",                             600, NULL },
  { (char*)"zcaron",                            600, NULL },
  { (char*)"scommaaccent",                      600, NULL },
  { (char*)"ccedilla",                          600, NULL },
  { (char*)"Dcaron",                            600, NULL },
  { (char*)"dcroat",                            600, NULL },
  { (char*)"Ocircumflex",                       600, NULL },
  { (char*)"Oacute",                            600, NULL },
  { (char*)"scedilla",                          600, NULL },
  { (char*)"ogonek",                            600, NULL },
  { (char*)"ograve",                            600, NULL },
  { (char*)"racute",                            600, NULL },
  { (char*)"Tcaron",                            600, NULL },
  { (char*)"Eogonek",                           600, NULL },
  { (char*)"thorn",                             600, NULL },
  { (char*)"degree",                            600, NULL },
  { (char*)"registered",                        600, NULL },
  { (char*)"radical",                           600, NULL },
  { (char*)"Aring",                             600, NULL },
  { (char*)"percent",                           600, NULL },
  { (char*)"six",                               600, NULL },
  { (char*)"paragraph",                         600, NULL },
  { (char*)"dcaron",                            600, NULL },
  { (char*)"Uogonek",                           600, NULL },
  { (char*)"two",                               600, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            600, NULL },
  { (char*)"Lacute",                            600, NULL },
  { (char*)"ocircumflex",                       600, NULL },
  { (char*)"oacute",                            600, NULL },
  { (char*)"Uring",                             600, NULL },
  { (char*)"Lcommaaccent",                      600, NULL },
  { (char*)"tcaron",                            600, NULL },
  { (char*)"eogonek",                           600, NULL },
  { (char*)"Delta",                             600, NULL },
  { (char*)"Ohungarumlaut",                     600, NULL },
  { (char*)"asciicircum",                       600, NULL },
  { (char*)"aring",                             600, NULL },
  { (char*)"grave",                             600, NULL },
  { (char*)"uogonek",                           600, NULL },
  { (char*)"bracketright",                      600, NULL },
  { (char*)"Iacute",                            600, NULL },
  { (char*)"ampersand",                         600, NULL },
  { (char*)"igrave",                            600, NULL },
  { (char*)"lacute",                            600, NULL },
  { (char*)"Ncaron",                            600, NULL },
  { (char*)"plus",                              600, NULL },
  { (char*)"uring",                             600, NULL },
  { (char*)"quotesinglbase",                    600, NULL },
  { (char*)"lcommaaccent",                      600, NULL },
  { (char*)"Yacute",                            600, NULL },
  { (char*)"ohungarumlaut",                     600, NULL },
  { (char*)"threesuperior",                     600, NULL },
  { (char*)"acute",                             600, NULL },
  { (char*)"section",                           600, NULL },
  { (char*)"dieresis",                          600, NULL },
  { (char*)"iacute",                            600, NULL },
  { (char*)"quotedblbase",                      600, NULL },
  { (char*)"ncaron",                            600, NULL },
  { (char*)"florin",                            600, NULL },
  { (char*)"yacute",                            600, NULL },
  { (char*)"Rcommaaccent",                      600, NULL },
  { (char*)"fi",                                600, NULL },
  { (char*)"fl",                                600, NULL },
  { (char*)"Acircumflex",                       600, NULL },
  { (char*)"Cacute",                            600, NULL },
  { (char*)"Icircumflex",                       600, NULL },
  { (char*)"guillemotleft",                     600, NULL },
  { (char*)"germandbls",                        600, NULL },
  { (char*)"Amacron",                           600, NULL },
  { (char*)"seven",                             600, NULL },
  { (char*)"Sacute",                            600, NULL },
  { (char*)"ordmasculine",                      600, NULL },
  { (char*)"dotlessi",                          600, NULL },
  { (char*)"sterling",                          600, NULL },
  { (char*)"notequal",                          600, NULL },
  { (char*)"Imacron",                           600, NULL },
  { (char*)"rcommaaccent",                      600, NULL },
  { (char*)"Zdotaccent",                        600, NULL },
  { (char*)"acircumflex",                       600, NULL },
  { (char*)"cacute",                            600, NULL },
  { (char*)"Ecaron",                            600, NULL },
  { (char*)"icircumflex",                       600, NULL },
  { (char*)"braceright",                        600, NULL },
  { (char*)"quotedblright",                     600, NULL },
  { (char*)"amacron",                           600, NULL },
  { (char*)"sacute",                            600, NULL },
  { (char*)"imacron",                           600, NULL },
  { (char*)"cent",                              600, NULL },
  { (char*)"currency",                          600, NULL },
  { (char*)"logicalnot",                        600, NULL },
  { (char*)"zdotaccent",                        600, NULL },
  { (char*)"Atilde",                            600, NULL },
  { (char*)"breve",                             600, NULL },
  { (char*)"bar",                               600, NULL },
  { (char*)"fraction",                          600, NULL },
  { (char*)"less",                              600, NULL },
  { (char*)"ecaron",                            600, NULL },
  { (char*)"guilsinglleft",                     600, NULL },
  { (char*)"exclam",                            600, NULL },
  { (char*)"period",                            600, NULL },
  { (char*)"Rcaron",                            600, NULL },
  { (char*)"Kcommaaccent",                      600, NULL },
  { (char*)"greater",                           600, NULL },
  { (char*)"atilde",                            600, NULL },
  { (char*)"brokenbar",                         600, NULL },
  { (char*)"quoteleft",                         600, NULL },
  { (char*)"Edotaccent",                        600, NULL },
  { (char*)"onesuperior",                       600, NULL }
};

static BuiltinFontWidth helveticaWidthsTab[] = {
  { (char*)"Ntilde",                            722, NULL },
  { (char*)"rcaron",                            333, NULL },
  { (char*)"kcommaaccent",                      500, NULL },
  { (char*)"Ncommaaccent",                      722, NULL },
  { (char*)"Zacute",                            611, NULL },
  { (char*)"comma",                             278, NULL },
  { (char*)"cedilla",                           333, NULL },
  { (char*)"plusminus",                         584, NULL },
  { (char*)"circumflex",                        333, NULL },
  { (char*)"dotaccent",                         333, NULL },
  { (char*)"edotaccent",                        556, NULL },
  { (char*)"asciitilde",                        584, NULL },
  { (char*)"colon",                             278, NULL },
  { (char*)"onehalf",                           834, NULL },
  { (char*)"dollar",                            556, NULL },
  { (char*)"Lcaron",                            556, NULL },
  { (char*)"ntilde",                            556, NULL },
  { (char*)"Aogonek",                           667, NULL },
  { (char*)"ncommaaccent",                      556, NULL },
  { (char*)"minus",                             584, NULL },
  { (char*)"Iogonek",                           278, NULL },
  { (char*)"zacute",                            500, NULL },
  { (char*)"yen",                               556, NULL },
  { (char*)"space",                             278, NULL },
  { (char*)"Omacron",                           778, NULL },
  { (char*)"questiondown",                      611, NULL },
  { (char*)"emdash",                           1000, NULL },
  { (char*)"Agrave",                            667, NULL },
  { (char*)"three",                             556, NULL },
  { (char*)"numbersign",                        556, NULL },
  { (char*)"lcaron",                            299, NULL },
  { (char*)"A",                                 667, NULL },
  { (char*)"B",                                 667, NULL },
  { (char*)"C",                                 722, NULL },
  { (char*)"aogonek",                           556, NULL },
  { (char*)"D",                                 722, NULL },
  { (char*)"E",                                 667, NULL },
  { (char*)"onequarter",                        834, NULL },
  { (char*)"F",                                 611, NULL },
  { (char*)"G",                                 778, NULL },
  { (char*)"H",                                 722, NULL },
  { (char*)"I",                                 278, NULL },
  { (char*)"J",                                 500, NULL },
  { (char*)"K",                                 667, NULL },
  { (char*)"iogonek",                           222, NULL },
  { (char*)"backslash",                         278, NULL },
  { (char*)"L",                                 556, NULL },
  { (char*)"periodcentered",                    278, NULL },
  { (char*)"M",                                 833, NULL },
  { (char*)"N",                                 722, NULL },
  { (char*)"omacron",                           556, NULL },
  { (char*)"Tcommaaccent",                      611, NULL },
  { (char*)"O",                                 778, NULL },
  { (char*)"P",                                 667, NULL },
  { (char*)"Q",                                 778, NULL },
  { (char*)"Uhungarumlaut",                     722, NULL },
  { (char*)"R",                                 722, NULL },
  { (char*)"Aacute",                            667, NULL },
  { (char*)"caron",                             333, NULL },
  { (char*)"S",                                 667, NULL },
  { (char*)"T",                                 611, NULL },
  { (char*)"U",                                 722, NULL },
  { (char*)"agrave",                            556, NULL },
  { (char*)"V",                                 667, NULL },
  { (char*)"W",                                 944, NULL },
  { (char*)"X",                                 667, NULL },
  { (char*)"question",                          556, NULL },
  { (char*)"equal",                             584, NULL },
  { (char*)"Y",                                 667, NULL },
  { (char*)"Z",                                 611, NULL },
  { (char*)"four",                              556, NULL },
  { (char*)"a",                                 556, NULL },
  { (char*)"Gcommaaccent",                      778, NULL },
  { (char*)"b",                                 556, NULL },
  { (char*)"c",                                 500, NULL },
  { (char*)"d",                                 556, NULL },
  { (char*)"e",                                 556, NULL },
  { (char*)"f",                                 278, NULL },
  { (char*)"g",                                 556, NULL },
  { (char*)"bullet",                            350, NULL },
  { (char*)"h",                                 556, NULL },
  { (char*)"i",                                 222, NULL },
  { (char*)"Oslash",                            778, NULL },
  { (char*)"dagger",                            556, NULL },
  { (char*)"j",                                 222, NULL },
  { (char*)"k",                                 500, NULL },
  { (char*)"l",                                 222, NULL },
  { (char*)"m",                                 833, NULL },
  { (char*)"n",                                 556, NULL },
  { (char*)"tcommaaccent",                      278, NULL },
  { (char*)"o",                                 556, NULL },
  { (char*)"ordfeminine",                       370, NULL },
  { (char*)"ring",                              333, NULL },
  { (char*)"p",                                 556, NULL },
  { (char*)"q",                                 556, NULL },
  { (char*)"uhungarumlaut",                     556, NULL },
  { (char*)"r",                                 333, NULL },
  { (char*)"twosuperior",                       333, NULL },
  { (char*)"aacute",                            556, NULL },
  { (char*)"s",                                 500, NULL },
  { (char*)"OE",                               1000, NULL },
  { (char*)"t",                                 278, NULL },
  { (char*)"divide",                            584, NULL },
  { (char*)"u",                                 556, NULL },
  { (char*)"Ccaron",                            722, NULL },
  { (char*)"v",                                 500, NULL },
  { (char*)"w",                                 722, NULL },
  { (char*)"x",                                 500, NULL },
  { (char*)"y",                                 500, NULL },
  { (char*)"z",                                 500, NULL },
  { (char*)"Gbreve",                            778, NULL },
  { (char*)"commaaccent",                       250, NULL },
  { (char*)"hungarumlaut",                      333, NULL },
  { (char*)"Idotaccent",                        278, NULL },
  { (char*)"Nacute",                            722, NULL },
  { (char*)"quotedbl",                          355, NULL },
  { (char*)"gcommaaccent",                      556, NULL },
  { (char*)"mu",                                556, NULL },
  { (char*)"greaterequal",                      549, NULL },
  { (char*)"Scaron",                            667, NULL },
  { (char*)"Lslash",                            556, NULL },
  { (char*)"semicolon",                         278, NULL },
  { (char*)"oslash",                            611, NULL },
  { (char*)"lessequal",                         549, NULL },
  { (char*)"lozenge",                           471, NULL },
  { (char*)"parenright",                        333, NULL },
  { (char*)"ccaron",                            500, NULL },
  { (char*)"Ecircumflex",                       667, NULL },
  { (char*)"gbreve",                            556, NULL },
  { (char*)"trademark",                        1000, NULL },
  { (char*)"daggerdbl",                         556, NULL },
  { (char*)"nacute",                            556, NULL },
  { (char*)"macron",                            333, NULL },
  { (char*)"Otilde",                            778, NULL },
  { (char*)"Emacron",                           667, NULL },
  { (char*)"ellipsis",                         1000, NULL },
  { (char*)"scaron",                            500, NULL },
  { (char*)"AE",                               1000, NULL },
  { (char*)"Ucircumflex",                       722, NULL },
  { (char*)"lslash",                            222, NULL },
  { (char*)"quotedblleft",                      333, NULL },
  { (char*)"guilsinglright",                    333, NULL },
  { (char*)"hyphen",                            333, NULL },
  { (char*)"quotesingle",                       191, NULL },
  { (char*)"eight",                             556, NULL },
  { (char*)"exclamdown",                        333, NULL },
  { (char*)"endash",                            556, NULL },
  { (char*)"oe",                                944, NULL },
  { (char*)"Abreve",                            667, NULL },
  { (char*)"Umacron",                           722, NULL },
  { (char*)"ecircumflex",                       556, NULL },
  { (char*)"Adieresis",                         667, NULL },
  { (char*)"copyright",                         737, NULL },
  { (char*)"Egrave",                            667, NULL },
  { (char*)"slash",                             278, NULL },
  { (char*)"Edieresis",                         667, NULL },
  { (char*)"otilde",                            556, NULL },
  { (char*)"Idieresis",                         278, NULL },
  { (char*)"parenleft",                         333, NULL },
  { (char*)"one",                               556, NULL },
  { (char*)"emacron",                           556, NULL },
  { (char*)"Odieresis",                         778, NULL },
  { (char*)"ucircumflex",                       556, NULL },
  { (char*)"bracketleft",                       278, NULL },
  { (char*)"Ugrave",                            722, NULL },
  { (char*)"quoteright",                        222, NULL },
  { (char*)"Udieresis",                         722, NULL },
  { (char*)"perthousand",                      1000, NULL },
  { (char*)"Ydieresis",                         667, NULL },
  { (char*)"umacron",                           556, NULL },
  { (char*)"abreve",                            556, NULL },
  { (char*)"Eacute",                            667, NULL },
  { (char*)"adieresis",                         556, NULL },
  { (char*)"egrave",                            556, NULL },
  { (char*)"edieresis",                         556, NULL },
  { (char*)"idieresis",                         278, NULL },
  { (char*)"Eth",                               722, NULL },
  { (char*)"ae",                                889, NULL },
  { (char*)"asterisk",                          389, NULL },
  { (char*)"odieresis",                         556, NULL },
  { (char*)"Uacute",                            722, NULL },
  { (char*)"ugrave",                            556, NULL },
  { (char*)"nine",                              556, NULL },
  { (char*)"five",                              556, NULL },
  { (char*)"udieresis",                         556, NULL },
  { (char*)"Zcaron",                            611, NULL },
  { (char*)"Scommaaccent",                      667, NULL },
  { (char*)"threequarters",                     834, NULL },
  { (char*)"guillemotright",                    556, NULL },
  { (char*)"Ccedilla",                          722, NULL },
  { (char*)"ydieresis",                         500, NULL },
  { (char*)"tilde",                             333, NULL },
  { (char*)"at",                               1015, NULL },
  { (char*)"eacute",                            556, NULL },
  { (char*)"underscore",                        556, NULL },
  { (char*)"Euro",                              556, NULL },
  { (char*)"Dcroat",                            722, NULL },
  { (char*)"multiply",                          584, NULL },
  { (char*)"zero",                              556, NULL },
  { (char*)"eth",                               556, NULL },
  { (char*)"Scedilla",                          667, NULL },
  { (char*)"Ograve",                            778, NULL },
  { (char*)"Racute",                            722, NULL },
  { (char*)"partialdiff",                       476, NULL },
  { (char*)"uacute",                            556, NULL },
  { (char*)"braceleft",                         334, NULL },
  { (char*)"Thorn",                             667, NULL },
  { (char*)"zcaron",                            500, NULL },
  { (char*)"scommaaccent",                      500, NULL },
  { (char*)"ccedilla",                          500, NULL },
  { (char*)"Dcaron",                            722, NULL },
  { (char*)"dcroat",                            556, NULL },
  { (char*)"Ocircumflex",                       778, NULL },
  { (char*)"Oacute",                            778, NULL },
  { (char*)"scedilla",                          500, NULL },
  { (char*)"ogonek",                            333, NULL },
  { (char*)"ograve",                            556, NULL },
  { (char*)"racute",                            333, NULL },
  { (char*)"Tcaron",                            611, NULL },
  { (char*)"Eogonek",                           667, NULL },
  { (char*)"thorn",                             556, NULL },
  { (char*)"degree",                            400, NULL },
  { (char*)"registered",                        737, NULL },
  { (char*)"radical",                           453, NULL },
  { (char*)"Aring",                             667, NULL },
  { (char*)"percent",                           889, NULL },
  { (char*)"six",                               556, NULL },
  { (char*)"paragraph",                         537, NULL },
  { (char*)"dcaron",                            643, NULL },
  { (char*)"Uogonek",                           722, NULL },
  { (char*)"two",                               556, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            278, NULL },
  { (char*)"Lacute",                            556, NULL },
  { (char*)"ocircumflex",                       556, NULL },
  { (char*)"oacute",                            556, NULL },
  { (char*)"Uring",                             722, NULL },
  { (char*)"Lcommaaccent",                      556, NULL },
  { (char*)"tcaron",                            317, NULL },
  { (char*)"eogonek",                           556, NULL },
  { (char*)"Delta",                             612, NULL },
  { (char*)"Ohungarumlaut",                     778, NULL },
  { (char*)"asciicircum",                       469, NULL },
  { (char*)"aring",                             556, NULL },
  { (char*)"grave",                             333, NULL },
  { (char*)"uogonek",                           556, NULL },
  { (char*)"bracketright",                      278, NULL },
  { (char*)"Iacute",                            278, NULL },
  { (char*)"ampersand",                         667, NULL },
  { (char*)"igrave",                            278, NULL },
  { (char*)"lacute",                            222, NULL },
  { (char*)"Ncaron",                            722, NULL },
  { (char*)"plus",                              584, NULL },
  { (char*)"uring",                             556, NULL },
  { (char*)"quotesinglbase",                    222, NULL },
  { (char*)"lcommaaccent",                      222, NULL },
  { (char*)"Yacute",                            667, NULL },
  { (char*)"ohungarumlaut",                     556, NULL },
  { (char*)"threesuperior",                     333, NULL },
  { (char*)"acute",                             333, NULL },
  { (char*)"section",                           556, NULL },
  { (char*)"dieresis",                          333, NULL },
  { (char*)"iacute",                            278, NULL },
  { (char*)"quotedblbase",                      333, NULL },
  { (char*)"ncaron",                            556, NULL },
  { (char*)"florin",                            556, NULL },
  { (char*)"yacute",                            500, NULL },
  { (char*)"Rcommaaccent",                      722, NULL },
  { (char*)"fi",                                500, NULL },
  { (char*)"fl",                                500, NULL },
  { (char*)"Acircumflex",                       667, NULL },
  { (char*)"Cacute",                            722, NULL },
  { (char*)"Icircumflex",                       278, NULL },
  { (char*)"guillemotleft",                     556, NULL },
  { (char*)"germandbls",                        611, NULL },
  { (char*)"Amacron",                           667, NULL },
  { (char*)"seven",                             556, NULL },
  { (char*)"Sacute",                            667, NULL },
  { (char*)"ordmasculine",                      365, NULL },
  { (char*)"dotlessi",                          278, NULL },
  { (char*)"sterling",                          556, NULL },
  { (char*)"notequal",                          549, NULL },
  { (char*)"Imacron",                           278, NULL },
  { (char*)"rcommaaccent",                      333, NULL },
  { (char*)"Zdotaccent",                        611, NULL },
  { (char*)"acircumflex",                       556, NULL },
  { (char*)"cacute",                            500, NULL },
  { (char*)"Ecaron",                            667, NULL },
  { (char*)"icircumflex",                       278, NULL },
  { (char*)"braceright",                        334, NULL },
  { (char*)"quotedblright",                     333, NULL },
  { (char*)"amacron",                           556, NULL },
  { (char*)"sacute",                            500, NULL },
  { (char*)"imacron",                           278, NULL },
  { (char*)"cent",                              556, NULL },
  { (char*)"currency",                          556, NULL },
  { (char*)"logicalnot",                        584, NULL },
  { (char*)"zdotaccent",                        500, NULL },
  { (char*)"Atilde",                            667, NULL },
  { (char*)"breve",                             333, NULL },
  { (char*)"bar",                               260, NULL },
  { (char*)"fraction",                          167, NULL },
  { (char*)"less",                              584, NULL },
  { (char*)"ecaron",                            556, NULL },
  { (char*)"guilsinglleft",                     333, NULL },
  { (char*)"exclam",                            278, NULL },
  { (char*)"period",                            278, NULL },
  { (char*)"Rcaron",                            722, NULL },
  { (char*)"Kcommaaccent",                      667, NULL },
  { (char*)"greater",                           584, NULL },
  { (char*)"atilde",                            556, NULL },
  { (char*)"brokenbar",                         260, NULL },
  { (char*)"quoteleft",                         222, NULL },
  { (char*)"Edotaccent",                        667, NULL },
  { (char*)"onesuperior",                       333, NULL }
};

static BuiltinFontWidth helveticaBoldWidthsTab[] = {
  { (char*)"Ntilde",                            722, NULL },
  { (char*)"rcaron",                            389, NULL },
  { (char*)"kcommaaccent",                      556, NULL },
  { (char*)"Ncommaaccent",                      722, NULL },
  { (char*)"Zacute",                            611, NULL },
  { (char*)"comma",                             278, NULL },
  { (char*)"cedilla",                           333, NULL },
  { (char*)"plusminus",                         584, NULL },
  { (char*)"circumflex",                        333, NULL },
  { (char*)"dotaccent",                         333, NULL },
  { (char*)"edotaccent",                        556, NULL },
  { (char*)"asciitilde",                        584, NULL },
  { (char*)"colon",                             333, NULL },
  { (char*)"onehalf",                           834, NULL },
  { (char*)"dollar",                            556, NULL },
  { (char*)"Lcaron",                            611, NULL },
  { (char*)"ntilde",                            611, NULL },
  { (char*)"Aogonek",                           722, NULL },
  { (char*)"ncommaaccent",                      611, NULL },
  { (char*)"minus",                             584, NULL },
  { (char*)"Iogonek",                           278, NULL },
  { (char*)"zacute",                            500, NULL },
  { (char*)"yen",                               556, NULL },
  { (char*)"space",                             278, NULL },
  { (char*)"Omacron",                           778, NULL },
  { (char*)"questiondown",                      611, NULL },
  { (char*)"emdash",                           1000, NULL },
  { (char*)"Agrave",                            722, NULL },
  { (char*)"three",                             556, NULL },
  { (char*)"numbersign",                        556, NULL },
  { (char*)"lcaron",                            400, NULL },
  { (char*)"A",                                 722, NULL },
  { (char*)"B",                                 722, NULL },
  { (char*)"C",                                 722, NULL },
  { (char*)"aogonek",                           556, NULL },
  { (char*)"D",                                 722, NULL },
  { (char*)"E",                                 667, NULL },
  { (char*)"onequarter",                        834, NULL },
  { (char*)"F",                                 611, NULL },
  { (char*)"G",                                 778, NULL },
  { (char*)"H",                                 722, NULL },
  { (char*)"I",                                 278, NULL },
  { (char*)"J",                                 556, NULL },
  { (char*)"K",                                 722, NULL },
  { (char*)"iogonek",                           278, NULL },
  { (char*)"backslash",                         278, NULL },
  { (char*)"L",                                 611, NULL },
  { (char*)"periodcentered",                    278, NULL },
  { (char*)"M",                                 833, NULL },
  { (char*)"N",                                 722, NULL },
  { (char*)"omacron",                           611, NULL },
  { (char*)"Tcommaaccent",                      611, NULL },
  { (char*)"O",                                 778, NULL },
  { (char*)"P",                                 667, NULL },
  { (char*)"Q",                                 778, NULL },
  { (char*)"Uhungarumlaut",                     722, NULL },
  { (char*)"R",                                 722, NULL },
  { (char*)"Aacute",                            722, NULL },
  { (char*)"caron",                             333, NULL },
  { (char*)"S",                                 667, NULL },
  { (char*)"T",                                 611, NULL },
  { (char*)"U",                                 722, NULL },
  { (char*)"agrave",                            556, NULL },
  { (char*)"V",                                 667, NULL },
  { (char*)"W",                                 944, NULL },
  { (char*)"X",                                 667, NULL },
  { (char*)"question",                          611, NULL },
  { (char*)"equal",                             584, NULL },
  { (char*)"Y",                                 667, NULL },
  { (char*)"Z",                                 611, NULL },
  { (char*)"four",                              556, NULL },
  { (char*)"a",                                 556, NULL },
  { (char*)"Gcommaaccent",                      778, NULL },
  { (char*)"b",                                 611, NULL },
  { (char*)"c",                                 556, NULL },
  { (char*)"d",                                 611, NULL },
  { (char*)"e",                                 556, NULL },
  { (char*)"f",                                 333, NULL },
  { (char*)"g",                                 611, NULL },
  { (char*)"bullet",                            350, NULL },
  { (char*)"h",                                 611, NULL },
  { (char*)"i",                                 278, NULL },
  { (char*)"Oslash",                            778, NULL },
  { (char*)"dagger",                            556, NULL },
  { (char*)"j",                                 278, NULL },
  { (char*)"k",                                 556, NULL },
  { (char*)"l",                                 278, NULL },
  { (char*)"m",                                 889, NULL },
  { (char*)"n",                                 611, NULL },
  { (char*)"tcommaaccent",                      333, NULL },
  { (char*)"o",                                 611, NULL },
  { (char*)"ordfeminine",                       370, NULL },
  { (char*)"ring",                              333, NULL },
  { (char*)"p",                                 611, NULL },
  { (char*)"q",                                 611, NULL },
  { (char*)"uhungarumlaut",                     611, NULL },
  { (char*)"r",                                 389, NULL },
  { (char*)"twosuperior",                       333, NULL },
  { (char*)"aacute",                            556, NULL },
  { (char*)"s",                                 556, NULL },
  { (char*)"OE",                               1000, NULL },
  { (char*)"t",                                 333, NULL },
  { (char*)"divide",                            584, NULL },
  { (char*)"u",                                 611, NULL },
  { (char*)"Ccaron",                            722, NULL },
  { (char*)"v",                                 556, NULL },
  { (char*)"w",                                 778, NULL },
  { (char*)"x",                                 556, NULL },
  { (char*)"y",                                 556, NULL },
  { (char*)"z",                                 500, NULL },
  { (char*)"Gbreve",                            778, NULL },
  { (char*)"commaaccent",                       250, NULL },
  { (char*)"hungarumlaut",                      333, NULL },
  { (char*)"Idotaccent",                        278, NULL },
  { (char*)"Nacute",                            722, NULL },
  { (char*)"quotedbl",                          474, NULL },
  { (char*)"gcommaaccent",                      611, NULL },
  { (char*)"mu",                                611, NULL },
  { (char*)"greaterequal",                      549, NULL },
  { (char*)"Scaron",                            667, NULL },
  { (char*)"Lslash",                            611, NULL },
  { (char*)"semicolon",                         333, NULL },
  { (char*)"oslash",                            611, NULL },
  { (char*)"lessequal",                         549, NULL },
  { (char*)"lozenge",                           494, NULL },
  { (char*)"parenright",                        333, NULL },
  { (char*)"ccaron",                            556, NULL },
  { (char*)"Ecircumflex",                       667, NULL },
  { (char*)"gbreve",                            611, NULL },
  { (char*)"trademark",                        1000, NULL },
  { (char*)"daggerdbl",                         556, NULL },
  { (char*)"nacute",                            611, NULL },
  { (char*)"macron",                            333, NULL },
  { (char*)"Otilde",                            778, NULL },
  { (char*)"Emacron",                           667, NULL },
  { (char*)"ellipsis",                         1000, NULL },
  { (char*)"scaron",                            556, NULL },
  { (char*)"AE",                               1000, NULL },
  { (char*)"Ucircumflex",                       722, NULL },
  { (char*)"lslash",                            278, NULL },
  { (char*)"quotedblleft",                      500, NULL },
  { (char*)"guilsinglright",                    333, NULL },
  { (char*)"hyphen",                            333, NULL },
  { (char*)"quotesingle",                       238, NULL },
  { (char*)"eight",                             556, NULL },
  { (char*)"exclamdown",                        333, NULL },
  { (char*)"endash",                            556, NULL },
  { (char*)"oe",                                944, NULL },
  { (char*)"Abreve",                            722, NULL },
  { (char*)"Umacron",                           722, NULL },
  { (char*)"ecircumflex",                       556, NULL },
  { (char*)"Adieresis",                         722, NULL },
  { (char*)"copyright",                         737, NULL },
  { (char*)"Egrave",                            667, NULL },
  { (char*)"slash",                             278, NULL },
  { (char*)"Edieresis",                         667, NULL },
  { (char*)"otilde",                            611, NULL },
  { (char*)"Idieresis",                         278, NULL },
  { (char*)"parenleft",                         333, NULL },
  { (char*)"one",                               556, NULL },
  { (char*)"emacron",                           556, NULL },
  { (char*)"Odieresis",                         778, NULL },
  { (char*)"ucircumflex",                       611, NULL },
  { (char*)"bracketleft",                       333, NULL },
  { (char*)"Ugrave",                            722, NULL },
  { (char*)"quoteright",                        278, NULL },
  { (char*)"Udieresis",                         722, NULL },
  { (char*)"perthousand",                      1000, NULL },
  { (char*)"Ydieresis",                         667, NULL },
  { (char*)"umacron",                           611, NULL },
  { (char*)"abreve",                            556, NULL },
  { (char*)"Eacute",                            667, NULL },
  { (char*)"adieresis",                         556, NULL },
  { (char*)"egrave",                            556, NULL },
  { (char*)"edieresis",                         556, NULL },
  { (char*)"idieresis",                         278, NULL },
  { (char*)"Eth",                               722, NULL },
  { (char*)"ae",                                889, NULL },
  { (char*)"asterisk",                          389, NULL },
  { (char*)"odieresis",                         611, NULL },
  { (char*)"Uacute",                            722, NULL },
  { (char*)"ugrave",                            611, NULL },
  { (char*)"nine",                              556, NULL },
  { (char*)"five",                              556, NULL },
  { (char*)"udieresis",                         611, NULL },
  { (char*)"Zcaron",                            611, NULL },
  { (char*)"Scommaaccent",                      667, NULL },
  { (char*)"threequarters",                     834, NULL },
  { (char*)"guillemotright",                    556, NULL },
  { (char*)"Ccedilla",                          722, NULL },
  { (char*)"ydieresis",                         556, NULL },
  { (char*)"tilde",                             333, NULL },
  { (char*)"dbldaggerumlaut",                   556, NULL },
  { (char*)"at",                                975, NULL },
  { (char*)"eacute",                            556, NULL },
  { (char*)"underscore",                        556, NULL },
  { (char*)"Euro",                              556, NULL },
  { (char*)"Dcroat",                            722, NULL },
  { (char*)"multiply",                          584, NULL },
  { (char*)"zero",                              556, NULL },
  { (char*)"eth",                               611, NULL },
  { (char*)"Scedilla",                          667, NULL },
  { (char*)"Ograve",                            778, NULL },
  { (char*)"Racute",                            722, NULL },
  { (char*)"partialdiff",                       494, NULL },
  { (char*)"uacute",                            611, NULL },
  { (char*)"braceleft",                         389, NULL },
  { (char*)"Thorn",                             667, NULL },
  { (char*)"zcaron",                            500, NULL },
  { (char*)"scommaaccent",                      556, NULL },
  { (char*)"ccedilla",                          556, NULL },
  { (char*)"Dcaron",                            722, NULL },
  { (char*)"dcroat",                            611, NULL },
  { (char*)"Ocircumflex",                       778, NULL },
  { (char*)"Oacute",                            778, NULL },
  { (char*)"scedilla",                          556, NULL },
  { (char*)"ogonek",                            333, NULL },
  { (char*)"ograve",                            611, NULL },
  { (char*)"racute",                            389, NULL },
  { (char*)"Tcaron",                            611, NULL },
  { (char*)"Eogonek",                           667, NULL },
  { (char*)"thorn",                             611, NULL },
  { (char*)"degree",                            400, NULL },
  { (char*)"registered",                        737, NULL },
  { (char*)"radical",                           549, NULL },
  { (char*)"Aring",                             722, NULL },
  { (char*)"percent",                           889, NULL },
  { (char*)"six",                               556, NULL },
  { (char*)"paragraph",                         556, NULL },
  { (char*)"dcaron",                            743, NULL },
  { (char*)"Uogonek",                           722, NULL },
  { (char*)"two",                               556, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            278, NULL },
  { (char*)"Lacute",                            611, NULL },
  { (char*)"ocircumflex",                       611, NULL },
  { (char*)"oacute",                            611, NULL },
  { (char*)"Uring",                             722, NULL },
  { (char*)"Lcommaaccent",                      611, NULL },
  { (char*)"tcaron",                            389, NULL },
  { (char*)"eogonek",                           556, NULL },
  { (char*)"Delta",                             612, NULL },
  { (char*)"Ohungarumlaut",                     778, NULL },
  { (char*)"asciicircum",                       584, NULL },
  { (char*)"aring",                             556, NULL },
  { (char*)"grave",                             333, NULL },
  { (char*)"uogonek",                           611, NULL },
  { (char*)"bracketright",                      333, NULL },
  { (char*)"Iacute",                            278, NULL },
  { (char*)"ampersand",                         722, NULL },
  { (char*)"igrave",                            278, NULL },
  { (char*)"lacute",                            278, NULL },
  { (char*)"Ncaron",                            722, NULL },
  { (char*)"plus",                              584, NULL },
  { (char*)"uring",                             611, NULL },
  { (char*)"quotesinglbase",                    278, NULL },
  { (char*)"lcommaaccent",                      278, NULL },
  { (char*)"Yacute",                            667, NULL },
  { (char*)"ohungarumlaut",                     611, NULL },
  { (char*)"threesuperior",                     333, NULL },
  { (char*)"acute",                             333, NULL },
  { (char*)"section",                           556, NULL },
  { (char*)"dieresis",                          333, NULL },
  { (char*)"iacute",                            278, NULL },
  { (char*)"quotedblbase",                      500, NULL },
  { (char*)"ncaron",                            611, NULL },
  { (char*)"florin",                            556, NULL },
  { (char*)"yacute",                            556, NULL },
  { (char*)"Rcommaaccent",                      722, NULL },
  { (char*)"fi",                                611, NULL },
  { (char*)"fl",                                611, NULL },
  { (char*)"Acircumflex",                       722, NULL },
  { (char*)"Cacute",                            722, NULL },
  { (char*)"Icircumflex",                       278, NULL },
  { (char*)"guillemotleft",                     556, NULL },
  { (char*)"germandbls",                        611, NULL },
  { (char*)"Amacron",                           722, NULL },
  { (char*)"seven",                             556, NULL },
  { (char*)"Sacute",                            667, NULL },
  { (char*)"ordmasculine",                      365, NULL },
  { (char*)"dotlessi",                          278, NULL },
  { (char*)"sterling",                          556, NULL },
  { (char*)"notequal",                          549, NULL },
  { (char*)"Imacron",                           278, NULL },
  { (char*)"rcommaaccent",                      389, NULL },
  { (char*)"Zdotaccent",                        611, NULL },
  { (char*)"acircumflex",                       556, NULL },
  { (char*)"cacute",                            556, NULL },
  { (char*)"Ecaron",                            667, NULL },
  { (char*)"icircumflex",                       278, NULL },
  { (char*)"braceright",                        389, NULL },
  { (char*)"quotedblright",                     500, NULL },
  { (char*)"amacron",                           556, NULL },
  { (char*)"sacute",                            556, NULL },
  { (char*)"imacron",                           278, NULL },
  { (char*)"cent",                              556, NULL },
  { (char*)"currency",                          556, NULL },
  { (char*)"logicalnot",                        584, NULL },
  { (char*)"zdotaccent",                        500, NULL },
  { (char*)"Atilde",                            722, NULL },
  { (char*)"breve",                             333, NULL },
  { (char*)"bar",                               280, NULL },
  { (char*)"fraction",                          167, NULL },
  { (char*)"less",                              584, NULL },
  { (char*)"ecaron",                            556, NULL },
  { (char*)"guilsinglleft",                     333, NULL },
  { (char*)"exclam",                            333, NULL },
  { (char*)"period",                            278, NULL },
  { (char*)"Rcaron",                            722, NULL },
  { (char*)"Kcommaaccent",                      722, NULL },
  { (char*)"greater",                           584, NULL },
  { (char*)"atilde",                            556, NULL },
  { (char*)"brokenbar",                         280, NULL },
  { (char*)"quoteleft",                         278, NULL },
  { (char*)"Edotaccent",                        667, NULL },
  { (char*)"onesuperior",                       333, NULL }
};

static BuiltinFontWidth helveticaBoldObliqueWidthsTab[] = {
  { (char*)"Ntilde",                            722, NULL },
  { (char*)"rcaron",                            389, NULL },
  { (char*)"kcommaaccent",                      556, NULL },
  { (char*)"Ncommaaccent",                      722, NULL },
  { (char*)"Zacute",                            611, NULL },
  { (char*)"comma",                             278, NULL },
  { (char*)"cedilla",                           333, NULL },
  { (char*)"plusminus",                         584, NULL },
  { (char*)"circumflex",                        333, NULL },
  { (char*)"dotaccent",                         333, NULL },
  { (char*)"edotaccent",                        556, NULL },
  { (char*)"asciitilde",                        584, NULL },
  { (char*)"colon",                             333, NULL },
  { (char*)"onehalf",                           834, NULL },
  { (char*)"dollar",                            556, NULL },
  { (char*)"Lcaron",                            611, NULL },
  { (char*)"ntilde",                            611, NULL },
  { (char*)"Aogonek",                           722, NULL },
  { (char*)"ncommaaccent",                      611, NULL },
  { (char*)"minus",                             584, NULL },
  { (char*)"Iogonek",                           278, NULL },
  { (char*)"zacute",                            500, NULL },
  { (char*)"yen",                               556, NULL },
  { (char*)"space",                             278, NULL },
  { (char*)"Omacron",                           778, NULL },
  { (char*)"questiondown",                      611, NULL },
  { (char*)"emdash",                           1000, NULL },
  { (char*)"Agrave",                            722, NULL },
  { (char*)"three",                             556, NULL },
  { (char*)"numbersign",                        556, NULL },
  { (char*)"lcaron",                            400, NULL },
  { (char*)"A",                                 722, NULL },
  { (char*)"B",                                 722, NULL },
  { (char*)"C",                                 722, NULL },
  { (char*)"aogonek",                           556, NULL },
  { (char*)"D",                                 722, NULL },
  { (char*)"E",                                 667, NULL },
  { (char*)"onequarter",                        834, NULL },
  { (char*)"F",                                 611, NULL },
  { (char*)"G",                                 778, NULL },
  { (char*)"H",                                 722, NULL },
  { (char*)"I",                                 278, NULL },
  { (char*)"J",                                 556, NULL },
  { (char*)"K",                                 722, NULL },
  { (char*)"iogonek",                           278, NULL },
  { (char*)"backslash",                         278, NULL },
  { (char*)"L",                                 611, NULL },
  { (char*)"periodcentered",                    278, NULL },
  { (char*)"M",                                 833, NULL },
  { (char*)"N",                                 722, NULL },
  { (char*)"omacron",                           611, NULL },
  { (char*)"Tcommaaccent",                      611, NULL },
  { (char*)"O",                                 778, NULL },
  { (char*)"P",                                 667, NULL },
  { (char*)"Q",                                 778, NULL },
  { (char*)"Uhungarumlaut",                     722, NULL },
  { (char*)"R",                                 722, NULL },
  { (char*)"Aacute",                            722, NULL },
  { (char*)"caron",                             333, NULL },
  { (char*)"S",                                 667, NULL },
  { (char*)"T",                                 611, NULL },
  { (char*)"U",                                 722, NULL },
  { (char*)"agrave",                            556, NULL },
  { (char*)"V",                                 667, NULL },
  { (char*)"W",                                 944, NULL },
  { (char*)"X",                                 667, NULL },
  { (char*)"question",                          611, NULL },
  { (char*)"equal",                             584, NULL },
  { (char*)"Y",                                 667, NULL },
  { (char*)"Z",                                 611, NULL },
  { (char*)"four",                              556, NULL },
  { (char*)"a",                                 556, NULL },
  { (char*)"Gcommaaccent",                      778, NULL },
  { (char*)"b",                                 611, NULL },
  { (char*)"c",                                 556, NULL },
  { (char*)"d",                                 611, NULL },
  { (char*)"e",                                 556, NULL },
  { (char*)"f",                                 333, NULL },
  { (char*)"g",                                 611, NULL },
  { (char*)"bullet",                            350, NULL },
  { (char*)"h",                                 611, NULL },
  { (char*)"i",                                 278, NULL },
  { (char*)"Oslash",                            778, NULL },
  { (char*)"dagger",                            556, NULL },
  { (char*)"j",                                 278, NULL },
  { (char*)"k",                                 556, NULL },
  { (char*)"l",                                 278, NULL },
  { (char*)"m",                                 889, NULL },
  { (char*)"n",                                 611, NULL },
  { (char*)"tcommaaccent",                      333, NULL },
  { (char*)"o",                                 611, NULL },
  { (char*)"ordfeminine",                       370, NULL },
  { (char*)"ring",                              333, NULL },
  { (char*)"p",                                 611, NULL },
  { (char*)"q",                                 611, NULL },
  { (char*)"uhungarumlaut",                     611, NULL },
  { (char*)"r",                                 389, NULL },
  { (char*)"twosuperior",                       333, NULL },
  { (char*)"aacute",                            556, NULL },
  { (char*)"s",                                 556, NULL },
  { (char*)"OE",                               1000, NULL },
  { (char*)"t",                                 333, NULL },
  { (char*)"divide",                            584, NULL },
  { (char*)"u",                                 611, NULL },
  { (char*)"Ccaron",                            722, NULL },
  { (char*)"v",                                 556, NULL },
  { (char*)"w",                                 778, NULL },
  { (char*)"x",                                 556, NULL },
  { (char*)"y",                                 556, NULL },
  { (char*)"z",                                 500, NULL },
  { (char*)"Gbreve",                            778, NULL },
  { (char*)"commaaccent",                       250, NULL },
  { (char*)"hungarumlaut",                      333, NULL },
  { (char*)"Idotaccent",                        278, NULL },
  { (char*)"Nacute",                            722, NULL },
  { (char*)"quotedbl",                          474, NULL },
  { (char*)"gcommaaccent",                      611, NULL },
  { (char*)"mu",                                611, NULL },
  { (char*)"greaterequal",                      549, NULL },
  { (char*)"Scaron",                            667, NULL },
  { (char*)"Lslash",                            611, NULL },
  { (char*)"semicolon",                         333, NULL },
  { (char*)"oslash",                            611, NULL },
  { (char*)"lessequal",                         549, NULL },
  { (char*)"lozenge",                           494, NULL },
  { (char*)"parenright",                        333, NULL },
  { (char*)"ccaron",                            556, NULL },
  { (char*)"Ecircumflex",                       667, NULL },
  { (char*)"gbreve",                            611, NULL },
  { (char*)"trademark",                        1000, NULL },
  { (char*)"daggerdbl",                         556, NULL },
  { (char*)"nacute",                            611, NULL },
  { (char*)"macron",                            333, NULL },
  { (char*)"Otilde",                            778, NULL },
  { (char*)"Emacron",                           667, NULL },
  { (char*)"ellipsis",                         1000, NULL },
  { (char*)"scaron",                            556, NULL },
  { (char*)"AE",                               1000, NULL },
  { (char*)"Ucircumflex",                       722, NULL },
  { (char*)"lslash",                            278, NULL },
  { (char*)"quotedblleft",                      500, NULL },
  { (char*)"guilsinglright",                    333, NULL },
  { (char*)"hyphen",                            333, NULL },
  { (char*)"quotesingle",                       238, NULL },
  { (char*)"eight",                             556, NULL },
  { (char*)"exclamdown",                        333, NULL },
  { (char*)"endash",                            556, NULL },
  { (char*)"oe",                                944, NULL },
  { (char*)"Abreve",                            722, NULL },
  { (char*)"Umacron",                           722, NULL },
  { (char*)"ecircumflex",                       556, NULL },
  { (char*)"Adieresis",                         722, NULL },
  { (char*)"copyright",                         737, NULL },
  { (char*)"Egrave",                            667, NULL },
  { (char*)"slash",                             278, NULL },
  { (char*)"Edieresis",                         667, NULL },
  { (char*)"otilde",                            611, NULL },
  { (char*)"Idieresis",                         278, NULL },
  { (char*)"parenleft",                         333, NULL },
  { (char*)"one",                               556, NULL },
  { (char*)"emacron",                           556, NULL },
  { (char*)"Odieresis",                         778, NULL },
  { (char*)"ucircumflex",                       611, NULL },
  { (char*)"bracketleft",                       333, NULL },
  { (char*)"Ugrave",                            722, NULL },
  { (char*)"quoteright",                        278, NULL },
  { (char*)"Udieresis",                         722, NULL },
  { (char*)"perthousand",                      1000, NULL },
  { (char*)"Ydieresis",                         667, NULL },
  { (char*)"umacron",                           611, NULL },
  { (char*)"abreve",                            556, NULL },
  { (char*)"Eacute",                            667, NULL },
  { (char*)"adieresis",                         556, NULL },
  { (char*)"egrave",                            556, NULL },
  { (char*)"edieresis",                         556, NULL },
  { (char*)"idieresis",                         278, NULL },
  { (char*)"Eth",                               722, NULL },
  { (char*)"ae",                                889, NULL },
  { (char*)"asterisk",                          389, NULL },
  { (char*)"odieresis",                         611, NULL },
  { (char*)"Uacute",                            722, NULL },
  { (char*)"ugrave",                            611, NULL },
  { (char*)"nine",                              556, NULL },
  { (char*)"five",                              556, NULL },
  { (char*)"udieresis",                         611, NULL },
  { (char*)"Zcaron",                            611, NULL },
  { (char*)"Scommaaccent",                      667, NULL },
  { (char*)"threequarters",                     834, NULL },
  { (char*)"guillemotright",                    556, NULL },
  { (char*)"Ccedilla",                          722, NULL },
  { (char*)"ydieresis",                         556, NULL },
  { (char*)"tilde",                             333, NULL },
  { (char*)"at",                                975, NULL },
  { (char*)"eacute",                            556, NULL },
  { (char*)"underscore",                        556, NULL },
  { (char*)"Euro",                              556, NULL },
  { (char*)"Dcroat",                            722, NULL },
  { (char*)"multiply",                          584, NULL },
  { (char*)"zero",                              556, NULL },
  { (char*)"eth",                               611, NULL },
  { (char*)"Scedilla",                          667, NULL },
  { (char*)"Ograve",                            778, NULL },
  { (char*)"Racute",                            722, NULL },
  { (char*)"partialdiff",                       494, NULL },
  { (char*)"uacute",                            611, NULL },
  { (char*)"braceleft",                         389, NULL },
  { (char*)"Thorn",                             667, NULL },
  { (char*)"zcaron",                            500, NULL },
  { (char*)"scommaaccent",                      556, NULL },
  { (char*)"ccedilla",                          556, NULL },
  { (char*)"Dcaron",                            722, NULL },
  { (char*)"dcroat",                            611, NULL },
  { (char*)"Ocircumflex",                       778, NULL },
  { (char*)"Oacute",                            778, NULL },
  { (char*)"scedilla",                          556, NULL },
  { (char*)"ogonek",                            333, NULL },
  { (char*)"ograve",                            611, NULL },
  { (char*)"racute",                            389, NULL },
  { (char*)"Tcaron",                            611, NULL },
  { (char*)"Eogonek",                           667, NULL },
  { (char*)"thorn",                             611, NULL },
  { (char*)"degree",                            400, NULL },
  { (char*)"registered",                        737, NULL },
  { (char*)"radical",                           549, NULL },
  { (char*)"Aring",                             722, NULL },
  { (char*)"percent",                           889, NULL },
  { (char*)"six",                               556, NULL },
  { (char*)"paragraph",                         556, NULL },
  { (char*)"dcaron",                            743, NULL },
  { (char*)"Uogonek",                           722, NULL },
  { (char*)"two",                               556, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            278, NULL },
  { (char*)"Lacute",                            611, NULL },
  { (char*)"ocircumflex",                       611, NULL },
  { (char*)"oacute",                            611, NULL },
  { (char*)"Uring",                             722, NULL },
  { (char*)"Lcommaaccent",                      611, NULL },
  { (char*)"tcaron",                            389, NULL },
  { (char*)"eogonek",                           556, NULL },
  { (char*)"Delta",                             612, NULL },
  { (char*)"Ohungarumlaut",                     778, NULL },
  { (char*)"asciicircum",                       584, NULL },
  { (char*)"aring",                             556, NULL },
  { (char*)"grave",                             333, NULL },
  { (char*)"uogonek",                           611, NULL },
  { (char*)"bracketright",                      333, NULL },
  { (char*)"Iacute",                            278, NULL },
  { (char*)"ampersand",                         722, NULL },
  { (char*)"igrave",                            278, NULL },
  { (char*)"lacute",                            278, NULL },
  { (char*)"Ncaron",                            722, NULL },
  { (char*)"plus",                              584, NULL },
  { (char*)"uring",                             611, NULL },
  { (char*)"quotesinglbase",                    278, NULL },
  { (char*)"lcommaaccent",                      278, NULL },
  { (char*)"Yacute",                            667, NULL },
  { (char*)"ohungarumlaut",                     611, NULL },
  { (char*)"threesuperior",                     333, NULL },
  { (char*)"acute",                             333, NULL },
  { (char*)"section",                           556, NULL },
  { (char*)"dieresis",                          333, NULL },
  { (char*)"iacute",                            278, NULL },
  { (char*)"quotedblbase",                      500, NULL },
  { (char*)"ncaron",                            611, NULL },
  { (char*)"florin",                            556, NULL },
  { (char*)"yacute",                            556, NULL },
  { (char*)"Rcommaaccent",                      722, NULL },
  { (char*)"fi",                                611, NULL },
  { (char*)"fl",                                611, NULL },
  { (char*)"Acircumflex",                       722, NULL },
  { (char*)"Cacute",                            722, NULL },
  { (char*)"Icircumflex",                       278, NULL },
  { (char*)"guillemotleft",                     556, NULL },
  { (char*)"germandbls",                        611, NULL },
  { (char*)"Amacron",                           722, NULL },
  { (char*)"seven",                             556, NULL },
  { (char*)"Sacute",                            667, NULL },
  { (char*)"ordmasculine",                      365, NULL },
  { (char*)"dotlessi",                          278, NULL },
  { (char*)"sterling",                          556, NULL },
  { (char*)"notequal",                          549, NULL },
  { (char*)"Imacron",                           278, NULL },
  { (char*)"rcommaaccent",                      389, NULL },
  { (char*)"Zdotaccent",                        611, NULL },
  { (char*)"acircumflex",                       556, NULL },
  { (char*)"cacute",                            556, NULL },
  { (char*)"Ecaron",                            667, NULL },
  { (char*)"icircumflex",                       278, NULL },
  { (char*)"braceright",                        389, NULL },
  { (char*)"quotedblright",                     500, NULL },
  { (char*)"amacron",                           556, NULL },
  { (char*)"sacute",                            556, NULL },
  { (char*)"imacron",                           278, NULL },
  { (char*)"cent",                              556, NULL },
  { (char*)"currency",                          556, NULL },
  { (char*)"logicalnot",                        584, NULL },
  { (char*)"zdotaccent",                        500, NULL },
  { (char*)"Atilde",                            722, NULL },
  { (char*)"breve",                             333, NULL },
  { (char*)"bar",                               280, NULL },
  { (char*)"fraction",                          167, NULL },
  { (char*)"less",                              584, NULL },
  { (char*)"ecaron",                            556, NULL },
  { (char*)"guilsinglleft",                     333, NULL },
  { (char*)"exclam",                            333, NULL },
  { (char*)"period",                            278, NULL },
  { (char*)"Rcaron",                            722, NULL },
  { (char*)"Kcommaaccent",                      722, NULL },
  { (char*)"greater",                           584, NULL },
  { (char*)"atilde",                            556, NULL },
  { (char*)"brokenbar",                         280, NULL },
  { (char*)"quoteleft",                         278, NULL },
  { (char*)"Edotaccent",                        667, NULL },
  { (char*)"onesuperior",                       333, NULL }
};

static BuiltinFontWidth helveticaObliqueWidthsTab[] = {
  { (char*)"Ntilde",                            722, NULL },
  { (char*)"rcaron",                            333, NULL },
  { (char*)"kcommaaccent",                      500, NULL },
  { (char*)"Ncommaaccent",                      722, NULL },
  { (char*)"Zacute",                            611, NULL },
  { (char*)"comma",                             278, NULL },
  { (char*)"cedilla",                           333, NULL },
  { (char*)"plusminus",                         584, NULL },
  { (char*)"circumflex",                        333, NULL },
  { (char*)"dotaccent",                         333, NULL },
  { (char*)"edotaccent",                        556, NULL },
  { (char*)"asciitilde",                        584, NULL },
  { (char*)"colon",                             278, NULL },
  { (char*)"onehalf",                           834, NULL },
  { (char*)"dollar",                            556, NULL },
  { (char*)"Lcaron",                            556, NULL },
  { (char*)"ntilde",                            556, NULL },
  { (char*)"Aogonek",                           667, NULL },
  { (char*)"ncommaaccent",                      556, NULL },
  { (char*)"minus",                             584, NULL },
  { (char*)"Iogonek",                           278, NULL },
  { (char*)"zacute",                            500, NULL },
  { (char*)"yen",                               556, NULL },
  { (char*)"space",                             278, NULL },
  { (char*)"Omacron",                           778, NULL },
  { (char*)"questiondown",                      611, NULL },
  { (char*)"emdash",                           1000, NULL },
  { (char*)"Agrave",                            667, NULL },
  { (char*)"three",                             556, NULL },
  { (char*)"numbersign",                        556, NULL },
  { (char*)"lcaron",                            299, NULL },
  { (char*)"A",                                 667, NULL },
  { (char*)"B",                                 667, NULL },
  { (char*)"C",                                 722, NULL },
  { (char*)"aogonek",                           556, NULL },
  { (char*)"D",                                 722, NULL },
  { (char*)"E",                                 667, NULL },
  { (char*)"onequarter",                        834, NULL },
  { (char*)"F",                                 611, NULL },
  { (char*)"G",                                 778, NULL },
  { (char*)"H",                                 722, NULL },
  { (char*)"I",                                 278, NULL },
  { (char*)"J",                                 500, NULL },
  { (char*)"K",                                 667, NULL },
  { (char*)"iogonek",                           222, NULL },
  { (char*)"backslash",                         278, NULL },
  { (char*)"L",                                 556, NULL },
  { (char*)"periodcentered",                    278, NULL },
  { (char*)"M",                                 833, NULL },
  { (char*)"N",                                 722, NULL },
  { (char*)"omacron",                           556, NULL },
  { (char*)"Tcommaaccent",                      611, NULL },
  { (char*)"O",                                 778, NULL },
  { (char*)"P",                                 667, NULL },
  { (char*)"Q",                                 778, NULL },
  { (char*)"Uhungarumlaut",                     722, NULL },
  { (char*)"R",                                 722, NULL },
  { (char*)"Aacute",                            667, NULL },
  { (char*)"caron",                             333, NULL },
  { (char*)"S",                                 667, NULL },
  { (char*)"T",                                 611, NULL },
  { (char*)"U",                                 722, NULL },
  { (char*)"agrave",                            556, NULL },
  { (char*)"V",                                 667, NULL },
  { (char*)"W",                                 944, NULL },
  { (char*)"X",                                 667, NULL },
  { (char*)"question",                          556, NULL },
  { (char*)"equal",                             584, NULL },
  { (char*)"Y",                                 667, NULL },
  { (char*)"Z",                                 611, NULL },
  { (char*)"four",                              556, NULL },
  { (char*)"a",                                 556, NULL },
  { (char*)"Gcommaaccent",                      778, NULL },
  { (char*)"b",                                 556, NULL },
  { (char*)"c",                                 500, NULL },
  { (char*)"d",                                 556, NULL },
  { (char*)"e",                                 556, NULL },
  { (char*)"f",                                 278, NULL },
  { (char*)"g",                                 556, NULL },
  { (char*)"bullet",                            350, NULL },
  { (char*)"h",                                 556, NULL },
  { (char*)"i",                                 222, NULL },
  { (char*)"Oslash",                            778, NULL },
  { (char*)"dagger",                            556, NULL },
  { (char*)"j",                                 222, NULL },
  { (char*)"k",                                 500, NULL },
  { (char*)"l",                                 222, NULL },
  { (char*)"m",                                 833, NULL },
  { (char*)"n",                                 556, NULL },
  { (char*)"tcommaaccent",                      278, NULL },
  { (char*)"o",                                 556, NULL },
  { (char*)"ordfeminine",                       370, NULL },
  { (char*)"ring",                              333, NULL },
  { (char*)"p",                                 556, NULL },
  { (char*)"q",                                 556, NULL },
  { (char*)"uhungarumlaut",                     556, NULL },
  { (char*)"r",                                 333, NULL },
  { (char*)"twosuperior",                       333, NULL },
  { (char*)"aacute",                            556, NULL },
  { (char*)"s",                                 500, NULL },
  { (char*)"OE",                               1000, NULL },
  { (char*)"t",                                 278, NULL },
  { (char*)"divide",                            584, NULL },
  { (char*)"u",                                 556, NULL },
  { (char*)"Ccaron",                            722, NULL },
  { (char*)"v",                                 500, NULL },
  { (char*)"w",                                 722, NULL },
  { (char*)"x",                                 500, NULL },
  { (char*)"y",                                 500, NULL },
  { (char*)"z",                                 500, NULL },
  { (char*)"Gbreve",                            778, NULL },
  { (char*)"commaaccent",                       250, NULL },
  { (char*)"hungarumlaut",                      333, NULL },
  { (char*)"Idotaccent",                        278, NULL },
  { (char*)"Nacute",                            722, NULL },
  { (char*)"quotedbl",                          355, NULL },
  { (char*)"gcommaaccent",                      556, NULL },
  { (char*)"mu",                                556, NULL },
  { (char*)"greaterequal",                      549, NULL },
  { (char*)"Scaron",                            667, NULL },
  { (char*)"Lslash",                            556, NULL },
  { (char*)"semicolon",                         278, NULL },
  { (char*)"oslash",                            611, NULL },
  { (char*)"lessequal",                         549, NULL },
  { (char*)"lozenge",                           471, NULL },
  { (char*)"parenright",                        333, NULL },
  { (char*)"ccaron",                            500, NULL },
  { (char*)"Ecircumflex",                       667, NULL },
  { (char*)"gbreve",                            556, NULL },
  { (char*)"trademark",                        1000, NULL },
  { (char*)"daggerdbl",                         556, NULL },
  { (char*)"nacute",                            556, NULL },
  { (char*)"macron",                            333, NULL },
  { (char*)"Otilde",                            778, NULL },
  { (char*)"Emacron",                           667, NULL },
  { (char*)"ellipsis",                         1000, NULL },
  { (char*)"scaron",                            500, NULL },
  { (char*)"AE",                               1000, NULL },
  { (char*)"Ucircumflex",                       722, NULL },
  { (char*)"lslash",                            222, NULL },
  { (char*)"quotedblleft",                      333, NULL },
  { (char*)"guilsinglright",                    333, NULL },
  { (char*)"hyphen",                            333, NULL },
  { (char*)"quotesingle",                       191, NULL },
  { (char*)"eight",                             556, NULL },
  { (char*)"exclamdown",                        333, NULL },
  { (char*)"endash",                            556, NULL },
  { (char*)"oe",                                944, NULL },
  { (char*)"Abreve",                            667, NULL },
  { (char*)"Umacron",                           722, NULL },
  { (char*)"ecircumflex",                       556, NULL },
  { (char*)"Adieresis",                         667, NULL },
  { (char*)"copyright",                         737, NULL },
  { (char*)"Egrave",                            667, NULL },
  { (char*)"slash",                             278, NULL },
  { (char*)"Edieresis",                         667, NULL },
  { (char*)"otilde",                            556, NULL },
  { (char*)"Idieresis",                         278, NULL },
  { (char*)"parenleft",                         333, NULL },
  { (char*)"one",                               556, NULL },
  { (char*)"emacron",                           556, NULL },
  { (char*)"Odieresis",                         778, NULL },
  { (char*)"ucircumflex",                       556, NULL },
  { (char*)"bracketleft",                       278, NULL },
  { (char*)"Ugrave",                            722, NULL },
  { (char*)"quoteright",                        222, NULL },
  { (char*)"Udieresis",                         722, NULL },
  { (char*)"perthousand",                      1000, NULL },
  { (char*)"Ydieresis",                         667, NULL },
  { (char*)"umacron",                           556, NULL },
  { (char*)"abreve",                            556, NULL },
  { (char*)"Eacute",                            667, NULL },
  { (char*)"adieresis",                         556, NULL },
  { (char*)"egrave",                            556, NULL },
  { (char*)"edieresis",                         556, NULL },
  { (char*)"idieresis",                         278, NULL },
  { (char*)"Eth",                               722, NULL },
  { (char*)"ae",                                889, NULL },
  { (char*)"asterisk",                          389, NULL },
  { (char*)"odieresis",                         556, NULL },
  { (char*)"Uacute",                            722, NULL },
  { (char*)"ugrave",                            556, NULL },
  { (char*)"nine",                              556, NULL },
  { (char*)"five",                              556, NULL },
  { (char*)"udieresis",                         556, NULL },
  { (char*)"Zcaron",                            611, NULL },
  { (char*)"Scommaaccent",                      667, NULL },
  { (char*)"threequarters",                     834, NULL },
  { (char*)"guillemotright",                    556, NULL },
  { (char*)"Ccedilla",                          722, NULL },
  { (char*)"ydieresis",                         500, NULL },
  { (char*)"tilde",                             333, NULL },
  { (char*)"at",                               1015, NULL },
  { (char*)"eacute",                            556, NULL },
  { (char*)"underscore",                        556, NULL },
  { (char*)"Euro",                              556, NULL },
  { (char*)"Dcroat",                            722, NULL },
  { (char*)"multiply",                          584, NULL },
  { (char*)"zero",                              556, NULL },
  { (char*)"eth",                               556, NULL },
  { (char*)"Scedilla",                          667, NULL },
  { (char*)"Ograve",                            778, NULL },
  { (char*)"Racute",                            722, NULL },
  { (char*)"partialdiff",                       476, NULL },
  { (char*)"uacute",                            556, NULL },
  { (char*)"braceleft",                         334, NULL },
  { (char*)"Thorn",                             667, NULL },
  { (char*)"zcaron",                            500, NULL },
  { (char*)"scommaaccent",                      500, NULL },
  { (char*)"ccedilla",                          500, NULL },
  { (char*)"Dcaron",                            722, NULL },
  { (char*)"dcroat",                            556, NULL },
  { (char*)"Ocircumflex",                       778, NULL },
  { (char*)"Oacute",                            778, NULL },
  { (char*)"scedilla",                          500, NULL },
  { (char*)"ogonek",                            333, NULL },
  { (char*)"ograve",                            556, NULL },
  { (char*)"racute",                            333, NULL },
  { (char*)"Tcaron",                            611, NULL },
  { (char*)"Eogonek",                           667, NULL },
  { (char*)"thorn",                             556, NULL },
  { (char*)"degree",                            400, NULL },
  { (char*)"registered",                        737, NULL },
  { (char*)"radical",                           453, NULL },
  { (char*)"Aring",                             667, NULL },
  { (char*)"percent",                           889, NULL },
  { (char*)"six",                               556, NULL },
  { (char*)"paragraph",                         537, NULL },
  { (char*)"dcaron",                            643, NULL },
  { (char*)"Uogonek",                           722, NULL },
  { (char*)"two",                               556, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            278, NULL },
  { (char*)"Lacute",                            556, NULL },
  { (char*)"ocircumflex",                       556, NULL },
  { (char*)"oacute",                            556, NULL },
  { (char*)"Uring",                             722, NULL },
  { (char*)"Lcommaaccent",                      556, NULL },
  { (char*)"tcaron",                            317, NULL },
  { (char*)"eogonek",                           556, NULL },
  { (char*)"Delta",                             612, NULL },
  { (char*)"Ohungarumlaut",                     778, NULL },
  { (char*)"asciicircum",                       469, NULL },
  { (char*)"aring",                             556, NULL },
  { (char*)"grave",                             333, NULL },
  { (char*)"uogonek",                           556, NULL },
  { (char*)"bracketright",                      278, NULL },
  { (char*)"Iacute",                            278, NULL },
  { (char*)"ampersand",                         667, NULL },
  { (char*)"igrave",                            278, NULL },
  { (char*)"lacute",                            222, NULL },
  { (char*)"Ncaron",                            722, NULL },
  { (char*)"plus",                              584, NULL },
  { (char*)"uring",                             556, NULL },
  { (char*)"quotesinglbase",                    222, NULL },
  { (char*)"lcommaaccent",                      222, NULL },
  { (char*)"Yacute",                            667, NULL },
  { (char*)"ohungarumlaut",                     556, NULL },
  { (char*)"threesuperior",                     333, NULL },
  { (char*)"acute",                             333, NULL },
  { (char*)"section",                           556, NULL },
  { (char*)"dieresis",                          333, NULL },
  { (char*)"iacute",                            278, NULL },
  { (char*)"quotedblbase",                      333, NULL },
  { (char*)"ncaron",                            556, NULL },
  { (char*)"florin",                            556, NULL },
  { (char*)"yacute",                            500, NULL },
  { (char*)"Rcommaaccent",                      722, NULL },
  { (char*)"fi",                                500, NULL },
  { (char*)"fl",                                500, NULL },
  { (char*)"Acircumflex",                       667, NULL },
  { (char*)"Cacute",                            722, NULL },
  { (char*)"Icircumflex",                       278, NULL },
  { (char*)"guillemotleft",                     556, NULL },
  { (char*)"germandbls",                        611, NULL },
  { (char*)"Amacron",                           667, NULL },
  { (char*)"seven",                             556, NULL },
  { (char*)"Sacute",                            667, NULL },
  { (char*)"ordmasculine",                      365, NULL },
  { (char*)"dotlessi",                          278, NULL },
  { (char*)"sterling",                          556, NULL },
  { (char*)"notequal",                          549, NULL },
  { (char*)"Imacron",                           278, NULL },
  { (char*)"rcommaaccent",                      333, NULL },
  { (char*)"Zdotaccent",                        611, NULL },
  { (char*)"acircumflex",                       556, NULL },
  { (char*)"cacute",                            500, NULL },
  { (char*)"Ecaron",                            667, NULL },
  { (char*)"icircumflex",                       278, NULL },
  { (char*)"braceright",                        334, NULL },
  { (char*)"quotedblright",                     333, NULL },
  { (char*)"amacron",                           556, NULL },
  { (char*)"sacute",                            500, NULL },
  { (char*)"imacron",                           278, NULL },
  { (char*)"cent",                              556, NULL },
  { (char*)"currency",                          556, NULL },
  { (char*)"logicalnot",                        584, NULL },
  { (char*)"zdotaccent",                        500, NULL },
  { (char*)"Atilde",                            667, NULL },
  { (char*)"breve",                             333, NULL },
  { (char*)"bar",                               260, NULL },
  { (char*)"fraction",                          167, NULL },
  { (char*)"less",                              584, NULL },
  { (char*)"ecaron",                            556, NULL },
  { (char*)"guilsinglleft",                     333, NULL },
  { (char*)"exclam",                            278, NULL },
  { (char*)"period",                            278, NULL },
  { (char*)"Rcaron",                            722, NULL },
  { (char*)"Kcommaaccent",                      667, NULL },
  { (char*)"greater",                           584, NULL },
  { (char*)"atilde",                            556, NULL },
  { (char*)"brokenbar",                         260, NULL },
  { (char*)"quoteleft",                         222, NULL },
  { (char*)"Edotaccent",                        667, NULL },
  { (char*)"onesuperior",                       333, NULL }
};

static BuiltinFontWidth symbolWidthsTab[] = {
  { (char*)"bracketleftex",                     384, NULL },
  { (char*)"alpha",                             631, NULL },
  { (char*)"union",                             768, NULL },
  { (char*)"infinity",                          713, NULL },
  { (char*)"comma",                             250, NULL },
  { (char*)"copyrightsans",                     790, NULL },
  { (char*)"plusminus",                         549, NULL },
  { (char*)"arrowup",                           603, NULL },
  { (char*)"apple",                             790, NULL },
  { (char*)"parenleftbt",                       384, NULL },
  { (char*)"notelement",                        713, NULL },
  { (char*)"colon",                             278, NULL },
  { (char*)"beta",                              549, NULL },
  { (char*)"braceleftbt",                       494, NULL },
  { (char*)"Lambda",                            686, NULL },
  { (char*)"Phi",                               763, NULL },
  { (char*)"minus",                             549, NULL },
  { (char*)"space",                             250, NULL },
  { (char*)"Sigma",                             592, NULL },
  { (char*)"approxequal",                       549, NULL },
  { (char*)"minute",                            247, NULL },
  { (char*)"circleplus",                        768, NULL },
  { (char*)"Omicron",                           722, NULL },
  { (char*)"three",                             500, NULL },
  { (char*)"numbersign",                        500, NULL },
  { (char*)"lambda",                            549, NULL },
  { (char*)"phi",                               521, NULL },
  { (char*)"aleph",                             823, NULL },
  { (char*)"Tau",                               611, NULL },
  { (char*)"spade",                             753, NULL },
  { (char*)"logicaland",                        603, NULL },
  { (char*)"sigma",                             603, NULL },
  { (char*)"propersuperset",                    713, NULL },
  { (char*)"omicron",                           549, NULL },
  { (char*)"question",                          444, NULL },
  { (char*)"equal",                             549, NULL },
  { (char*)"Epsilon",                           611, NULL },
  { (char*)"emptyset",                          823, NULL },
  { (char*)"diamond",                           753, NULL },
  { (char*)"four",                              500, NULL },
  { (char*)"Mu",                                889, NULL },
  { (char*)"parenlefttp",                       384, NULL },
  { (char*)"club",                              753, NULL },
  { (char*)"bullet",                            460, NULL },
  { (char*)"Omega",                             768, NULL },
  { (char*)"tau",                               439, NULL },
  { (char*)"Upsilon",                           690, NULL },
  { (char*)"bracelefttp",                       494, NULL },
  { (char*)"heart",                             753, NULL },
  { (char*)"divide",                            549, NULL },
  { (char*)"epsilon",                           439, NULL },
  { (char*)"logicalor",                         603, NULL },
  { (char*)"parenleftex",                       384, NULL },
  { (char*)"greaterequal",                      549, NULL },
  { (char*)"mu",                                576, NULL },
  { (char*)"Nu",                                722, NULL },
  { (char*)"therefore",                         863, NULL },
  { (char*)"notsubset",                         713, NULL },
  { (char*)"omega",                             686, NULL },
  { (char*)"semicolon",                         278, NULL },
  { (char*)"element",                           713, NULL },
  { (char*)"upsilon",                           576, NULL },
  { (char*)"existential",                       549, NULL },
  { (char*)"integralbt",                        686, NULL },
  { (char*)"lessequal",                         549, NULL },
  { (char*)"phi1",                              603, NULL },
  { (char*)"lozenge",                           494, NULL },
  { (char*)"trademarkserif",                    890, NULL },
  { (char*)"parenright",                        333, NULL },
  { (char*)"reflexsuperset",                    713, NULL },
  { (char*)"sigma1",                            439, NULL },
  { (char*)"nu",                                521, NULL },
  { (char*)"Gamma",                             603, NULL },
  { (char*)"angleright",                        329, NULL },
  { (char*)"ellipsis",                         1000, NULL },
  { (char*)"Rho",                               556, NULL },
  { (char*)"parenrightbt",                      384, NULL },
  { (char*)"radicalex",                         500, NULL },
  { (char*)"eight",                             500, NULL },
  { (char*)"angleleft",                         329, NULL },
  { (char*)"arrowdbldown",                      603, NULL },
  { (char*)"congruent",                         549, NULL },
  { (char*)"Theta",                             741, NULL },
  { (char*)"intersection",                      768, NULL },
  { (char*)"Pi",                                768, NULL },
  { (char*)"slash",                             278, NULL },
  { (char*)"registerserif",                     790, NULL },
  { (char*)"parenleft",                         333, NULL },
  { (char*)"one",                               500, NULL },
  { (char*)"gamma",                             411, NULL },
  { (char*)"bracketleft",                       333, NULL },
  { (char*)"rho",                               549, NULL },
  { (char*)"circlemultiply",                    768, NULL },
  { (char*)"Chi",                               722, NULL },
  { (char*)"theta",                             521, NULL },
  { (char*)"pi",                                549, NULL },
  { (char*)"integraltp",                        686, NULL },
  { (char*)"Eta",                               722, NULL },
  { (char*)"product",                           823, NULL },
  { (char*)"nine",                              500, NULL },
  { (char*)"five",                              500, NULL },
  { (char*)"propersubset",                      713, NULL },
  { (char*)"bracketrightbt",                    384, NULL },
  { (char*)"trademarksans",                     786, NULL },
  { (char*)"dotmath",                           250, NULL },
  { (char*)"integralex",                        686, NULL },
  { (char*)"chi",                               549, NULL },
  { (char*)"parenrighttp",                      384, NULL },
  { (char*)"eta",                               603, NULL },
  { (char*)"underscore",                        500, NULL },
  { (char*)"Euro",                              750, NULL },
  { (char*)"multiply",                          549, NULL },
  { (char*)"zero",                              500, NULL },
  { (char*)"partialdiff",                       494, NULL },
  { (char*)"angle",                             768, NULL },
  { (char*)"arrowdblleft",                      987, NULL },
  { (char*)"braceleft",                         480, NULL },
  { (char*)"parenrightex",                      384, NULL },
  { (char*)"Rfraktur",                          795, NULL },
  { (char*)"Zeta",                              611, NULL },
  { (char*)"braceex",                           494, NULL },
  { (char*)"arrowdblup",                        603, NULL },
  { (char*)"arrowdown",                         603, NULL },
  { (char*)"Ifraktur",                          686, NULL },
  { (char*)"degree",                            400, NULL },
  { (char*)"Iota",                              333, NULL },
  { (char*)"perpendicular",                     658, NULL },
  { (char*)"radical",                           549, NULL },
  { (char*)"asteriskmath",                      500, NULL },
  { (char*)"percent",                           833, NULL },
  { (char*)"zeta",                              494, NULL },
  { (char*)"six",                               500, NULL },
  { (char*)"two",                               500, NULL },
  { (char*)"weierstrass",                       987, NULL },
  { (char*)"summation",                         713, NULL },
  { (char*)"bracketrighttp",                    384, NULL },
  { (char*)"carriagereturn",                    658, NULL },
  { (char*)"suchthat",                          439, NULL },
  { (char*)"arrowvertex",                       603, NULL },
  { (char*)"Delta",                             612, NULL },
  { (char*)"iota",                              329, NULL },
  { (char*)"arrowhorizex",                     1000, NULL },
  { (char*)"bracketrightex",                    384, NULL },
  { (char*)"bracketright",                      333, NULL },
  { (char*)"ampersand",                         778, NULL },
  { (char*)"plus",                              549, NULL },
  { (char*)"proportional",                      713, NULL },
  { (char*)"delta",                             494, NULL },
  { (char*)"copyrightserif",                    790, NULL },
  { (char*)"bracerightmid",                     494, NULL },
  { (char*)"arrowleft",                         987, NULL },
  { (char*)"second",                            411, NULL },
  { (char*)"arrowdblboth",                     1042, NULL },
  { (char*)"florin",                            500, NULL },
  { (char*)"Psi",                               795, NULL },
  { (char*)"bracerightbt",                      494, NULL },
  { (char*)"bracketleftbt",                     384, NULL },
  { (char*)"seven",                             500, NULL },
  { (char*)"braceleftmid",                      494, NULL },
  { (char*)"notequal",                          549, NULL },
  { (char*)"psi",                               686, NULL },
  { (char*)"equivalence",                       549, NULL },
  { (char*)"universal",                         713, NULL },
  { (char*)"arrowdblright",                     987, NULL },
  { (char*)"braceright",                        480, NULL },
  { (char*)"reflexsubset",                      713, NULL },
  { (char*)"Xi",                                645, NULL },
  { (char*)"theta1",                            631, NULL },
  { (char*)"logicalnot",                        713, NULL },
  { (char*)"Kappa",                             722, NULL },
  { (char*)"similar",                           549, NULL },
  { (char*)"bar",                               200, NULL },
  { (char*)"fraction",                          167, NULL },
  { (char*)"less",                              549, NULL },
  { (char*)"registersans",                      790, NULL },
  { (char*)"omega1",                            713, NULL },
  { (char*)"exclam",                            333, NULL },
  { (char*)"Upsilon1",                          620, NULL },
  { (char*)"bracerighttp",                      494, NULL },
  { (char*)"xi",                                493, NULL },
  { (char*)"period",                            250, NULL },
  { (char*)"Alpha",                             722, NULL },
  { (char*)"arrowright",                        987, NULL },
  { (char*)"greater",                           549, NULL },
  { (char*)"bracketlefttp",                     384, NULL },
  { (char*)"kappa",                             549, NULL },
  { (char*)"gradient",                          713, NULL },
  { (char*)"integral",                          274, NULL },
  { (char*)"arrowboth",                        1042, NULL },
  { (char*)"Beta",                              667, NULL }
};

static BuiltinFontWidth timesBoldWidthsTab[] = {
  { (char*)"Ntilde",                            722, NULL },
  { (char*)"rcaron",                            444, NULL },
  { (char*)"kcommaaccent",                      556, NULL },
  { (char*)"Ncommaaccent",                      722, NULL },
  { (char*)"Zacute",                            667, NULL },
  { (char*)"comma",                             250, NULL },
  { (char*)"cedilla",                           333, NULL },
  { (char*)"plusminus",                         570, NULL },
  { (char*)"circumflex",                        333, NULL },
  { (char*)"dotaccent",                         333, NULL },
  { (char*)"edotaccent",                        444, NULL },
  { (char*)"asciitilde",                        520, NULL },
  { (char*)"colon",                             333, NULL },
  { (char*)"onehalf",                           750, NULL },
  { (char*)"dollar",                            500, NULL },
  { (char*)"Lcaron",                            667, NULL },
  { (char*)"ntilde",                            556, NULL },
  { (char*)"Aogonek",                           722, NULL },
  { (char*)"ncommaaccent",                      556, NULL },
  { (char*)"minus",                             570, NULL },
  { (char*)"Iogonek",                           389, NULL },
  { (char*)"zacute",                            444, NULL },
  { (char*)"yen",                               500, NULL },
  { (char*)"space",                             250, NULL },
  { (char*)"Omacron",                           778, NULL },
  { (char*)"questiondown",                      500, NULL },
  { (char*)"emdash",                           1000, NULL },
  { (char*)"Agrave",                            722, NULL },
  { (char*)"three",                             500, NULL },
  { (char*)"numbersign",                        500, NULL },
  { (char*)"lcaron",                            394, NULL },
  { (char*)"A",                                 722, NULL },
  { (char*)"B",                                 667, NULL },
  { (char*)"C",                                 722, NULL },
  { (char*)"aogonek",                           500, NULL },
  { (char*)"D",                                 722, NULL },
  { (char*)"E",                                 667, NULL },
  { (char*)"onequarter",                        750, NULL },
  { (char*)"F",                                 611, NULL },
  { (char*)"G",                                 778, NULL },
  { (char*)"H",                                 778, NULL },
  { (char*)"I",                                 389, NULL },
  { (char*)"J",                                 500, NULL },
  { (char*)"K",                                 778, NULL },
  { (char*)"iogonek",                           278, NULL },
  { (char*)"backslash",                         278, NULL },
  { (char*)"L",                                 667, NULL },
  { (char*)"periodcentered",                    250, NULL },
  { (char*)"M",                                 944, NULL },
  { (char*)"N",                                 722, NULL },
  { (char*)"omacron",                           500, NULL },
  { (char*)"Tcommaaccent",                      667, NULL },
  { (char*)"O",                                 778, NULL },
  { (char*)"P",                                 611, NULL },
  { (char*)"Q",                                 778, NULL },
  { (char*)"Uhungarumlaut",                     722, NULL },
  { (char*)"R",                                 722, NULL },
  { (char*)"Aacute",                            722, NULL },
  { (char*)"caron",                             333, NULL },
  { (char*)"S",                                 556, NULL },
  { (char*)"T",                                 667, NULL },
  { (char*)"U",                                 722, NULL },
  { (char*)"agrave",                            500, NULL },
  { (char*)"V",                                 722, NULL },
  { (char*)"W",                                1000, NULL },
  { (char*)"X",                                 722, NULL },
  { (char*)"question",                          500, NULL },
  { (char*)"equal",                             570, NULL },
  { (char*)"Y",                                 722, NULL },
  { (char*)"Z",                                 667, NULL },
  { (char*)"four",                              500, NULL },
  { (char*)"a",                                 500, NULL },
  { (char*)"Gcommaaccent",                      778, NULL },
  { (char*)"b",                                 556, NULL },
  { (char*)"c",                                 444, NULL },
  { (char*)"d",                                 556, NULL },
  { (char*)"e",                                 444, NULL },
  { (char*)"f",                                 333, NULL },
  { (char*)"g",                                 500, NULL },
  { (char*)"bullet",                            350, NULL },
  { (char*)"h",                                 556, NULL },
  { (char*)"i",                                 278, NULL },
  { (char*)"Oslash",                            778, NULL },
  { (char*)"dagger",                            500, NULL },
  { (char*)"j",                                 333, NULL },
  { (char*)"k",                                 556, NULL },
  { (char*)"l",                                 278, NULL },
  { (char*)"m",                                 833, NULL },
  { (char*)"n",                                 556, NULL },
  { (char*)"tcommaaccent",                      333, NULL },
  { (char*)"o",                                 500, NULL },
  { (char*)"ordfeminine",                       300, NULL },
  { (char*)"ring",                              333, NULL },
  { (char*)"p",                                 556, NULL },
  { (char*)"q",                                 556, NULL },
  { (char*)"uhungarumlaut",                     556, NULL },
  { (char*)"r",                                 444, NULL },
  { (char*)"twosuperior",                       300, NULL },
  { (char*)"aacute",                            500, NULL },
  { (char*)"s",                                 389, NULL },
  { (char*)"OE",                               1000, NULL },
  { (char*)"t",                                 333, NULL },
  { (char*)"divide",                            570, NULL },
  { (char*)"u",                                 556, NULL },
  { (char*)"Ccaron",                            722, NULL },
  { (char*)"v",                                 500, NULL },
  { (char*)"w",                                 722, NULL },
  { (char*)"x",                                 500, NULL },
  { (char*)"y",                                 500, NULL },
  { (char*)"z",                                 444, NULL },
  { (char*)"Gbreve",                            778, NULL },
  { (char*)"commaaccent",                       250, NULL },
  { (char*)"hungarumlaut",                      333, NULL },
  { (char*)"Idotaccent",                        389, NULL },
  { (char*)"Nacute",                            722, NULL },
  { (char*)"quotedbl",                          555, NULL },
  { (char*)"gcommaaccent",                      500, NULL },
  { (char*)"mu",                                556, NULL },
  { (char*)"greaterequal",                      549, NULL },
  { (char*)"Scaron",                            556, NULL },
  { (char*)"Lslash",                            667, NULL },
  { (char*)"semicolon",                         333, NULL },
  { (char*)"oslash",                            500, NULL },
  { (char*)"lessequal",                         549, NULL },
  { (char*)"lozenge",                           494, NULL },
  { (char*)"parenright",                        333, NULL },
  { (char*)"ccaron",                            444, NULL },
  { (char*)"Ecircumflex",                       667, NULL },
  { (char*)"gbreve",                            500, NULL },
  { (char*)"trademark",                        1000, NULL },
  { (char*)"daggerdbl",                         500, NULL },
  { (char*)"nacute",                            556, NULL },
  { (char*)"macron",                            333, NULL },
  { (char*)"Otilde",                            778, NULL },
  { (char*)"Emacron",                           667, NULL },
  { (char*)"ellipsis",                         1000, NULL },
  { (char*)"scaron",                            389, NULL },
  { (char*)"AE",                               1000, NULL },
  { (char*)"Ucircumflex",                       722, NULL },
  { (char*)"lslash",                            278, NULL },
  { (char*)"quotedblleft",                      500, NULL },
  { (char*)"guilsinglright",                    333, NULL },
  { (char*)"hyphen",                            333, NULL },
  { (char*)"quotesingle",                       278, NULL },
  { (char*)"eight",                             500, NULL },
  { (char*)"exclamdown",                        333, NULL },
  { (char*)"endash",                            500, NULL },
  { (char*)"oe",                                722, NULL },
  { (char*)"Abreve",                            722, NULL },
  { (char*)"Umacron",                           722, NULL },
  { (char*)"ecircumflex",                       444, NULL },
  { (char*)"Adieresis",                         722, NULL },
  { (char*)"copyright",                         747, NULL },
  { (char*)"Egrave",                            667, NULL },
  { (char*)"slash",                             278, NULL },
  { (char*)"Edieresis",                         667, NULL },
  { (char*)"otilde",                            500, NULL },
  { (char*)"Idieresis",                         389, NULL },
  { (char*)"parenleft",                         333, NULL },
  { (char*)"one",                               500, NULL },
  { (char*)"emacron",                           444, NULL },
  { (char*)"Odieresis",                         778, NULL },
  { (char*)"ucircumflex",                       556, NULL },
  { (char*)"bracketleft",                       333, NULL },
  { (char*)"Ugrave",                            722, NULL },
  { (char*)"quoteright",                        333, NULL },
  { (char*)"Udieresis",                         722, NULL },
  { (char*)"perthousand",                      1000, NULL },
  { (char*)"Ydieresis",                         722, NULL },
  { (char*)"umacron",                           556, NULL },
  { (char*)"abreve",                            500, NULL },
  { (char*)"Eacute",                            667, NULL },
  { (char*)"adieresis",                         500, NULL },
  { (char*)"egrave",                            444, NULL },
  { (char*)"edieresis",                         444, NULL },
  { (char*)"idieresis",                         278, NULL },
  { (char*)"Eth",                               722, NULL },
  { (char*)"ae",                                722, NULL },
  { (char*)"asterisk",                          500, NULL },
  { (char*)"odieresis",                         500, NULL },
  { (char*)"Uacute",                            722, NULL },
  { (char*)"ugrave",                            556, NULL },
  { (char*)"nine",                              500, NULL },
  { (char*)"five",                              500, NULL },
  { (char*)"udieresis",                         556, NULL },
  { (char*)"Zcaron",                            667, NULL },
  { (char*)"Scommaaccent",                      556, NULL },
  { (char*)"threequarters",                     750, NULL },
  { (char*)"guillemotright",                    500, NULL },
  { (char*)"Ccedilla",                          722, NULL },
  { (char*)"ydieresis",                         500, NULL },
  { (char*)"tilde",                             333, NULL },
  { (char*)"at",                                930, NULL },
  { (char*)"eacute",                            444, NULL },
  { (char*)"underscore",                        500, NULL },
  { (char*)"Euro",                              500, NULL },
  { (char*)"Dcroat",                            722, NULL },
  { (char*)"multiply",                          570, NULL },
  { (char*)"zero",                              500, NULL },
  { (char*)"eth",                               500, NULL },
  { (char*)"Scedilla",                          556, NULL },
  { (char*)"Ograve",                            778, NULL },
  { (char*)"Racute",                            722, NULL },
  { (char*)"partialdiff",                       494, NULL },
  { (char*)"uacute",                            556, NULL },
  { (char*)"braceleft",                         394, NULL },
  { (char*)"Thorn",                             611, NULL },
  { (char*)"zcaron",                            444, NULL },
  { (char*)"scommaaccent",                      389, NULL },
  { (char*)"ccedilla",                          444, NULL },
  { (char*)"Dcaron",                            722, NULL },
  { (char*)"dcroat",                            556, NULL },
  { (char*)"Ocircumflex",                       778, NULL },
  { (char*)"Oacute",                            778, NULL },
  { (char*)"scedilla",                          389, NULL },
  { (char*)"ogonek",                            333, NULL },
  { (char*)"ograve",                            500, NULL },
  { (char*)"racute",                            444, NULL },
  { (char*)"Tcaron",                            667, NULL },
  { (char*)"Eogonek",                           667, NULL },
  { (char*)"thorn",                             556, NULL },
  { (char*)"degree",                            400, NULL },
  { (char*)"registered",                        747, NULL },
  { (char*)"radical",                           549, NULL },
  { (char*)"Aring",                             722, NULL },
  { (char*)"percent",                          1000, NULL },
  { (char*)"six",                               500, NULL },
  { (char*)"paragraph",                         540, NULL },
  { (char*)"dcaron",                            672, NULL },
  { (char*)"Uogonek",                           722, NULL },
  { (char*)"two",                               500, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            389, NULL },
  { (char*)"Lacute",                            667, NULL },
  { (char*)"ocircumflex",                       500, NULL },
  { (char*)"oacute",                            500, NULL },
  { (char*)"Uring",                             722, NULL },
  { (char*)"Lcommaaccent",                      667, NULL },
  { (char*)"tcaron",                            416, NULL },
  { (char*)"eogonek",                           444, NULL },
  { (char*)"Delta",                             612, NULL },
  { (char*)"Ohungarumlaut",                     778, NULL },
  { (char*)"asciicircum",                       581, NULL },
  { (char*)"aring",                             500, NULL },
  { (char*)"grave",                             333, NULL },
  { (char*)"uogonek",                           556, NULL },
  { (char*)"bracketright",                      333, NULL },
  { (char*)"Iacute",                            389, NULL },
  { (char*)"ampersand",                         833, NULL },
  { (char*)"igrave",                            278, NULL },
  { (char*)"lacute",                            278, NULL },
  { (char*)"Ncaron",                            722, NULL },
  { (char*)"plus",                              570, NULL },
  { (char*)"uring",                             556, NULL },
  { (char*)"quotesinglbase",                    333, NULL },
  { (char*)"lcommaaccent",                      278, NULL },
  { (char*)"Yacute",                            722, NULL },
  { (char*)"ohungarumlaut",                     500, NULL },
  { (char*)"threesuperior",                     300, NULL },
  { (char*)"acute",                             333, NULL },
  { (char*)"section",                           500, NULL },
  { (char*)"dieresis",                          333, NULL },
  { (char*)"iacute",                            278, NULL },
  { (char*)"quotedblbase",                      500, NULL },
  { (char*)"ncaron",                            556, NULL },
  { (char*)"florin",                            500, NULL },
  { (char*)"yacute",                            500, NULL },
  { (char*)"Rcommaaccent",                      722, NULL },
  { (char*)"fi",                                556, NULL },
  { (char*)"fl",                                556, NULL },
  { (char*)"Acircumflex",                       722, NULL },
  { (char*)"Cacute",                            722, NULL },
  { (char*)"Icircumflex",                       389, NULL },
  { (char*)"guillemotleft",                     500, NULL },
  { (char*)"germandbls",                        556, NULL },
  { (char*)"Amacron",                           722, NULL },
  { (char*)"seven",                             500, NULL },
  { (char*)"Sacute",                            556, NULL },
  { (char*)"ordmasculine",                      330, NULL },
  { (char*)"dotlessi",                          278, NULL },
  { (char*)"sterling",                          500, NULL },
  { (char*)"notequal",                          549, NULL },
  { (char*)"Imacron",                           389, NULL },
  { (char*)"rcommaaccent",                      444, NULL },
  { (char*)"Zdotaccent",                        667, NULL },
  { (char*)"acircumflex",                       500, NULL },
  { (char*)"cacute",                            444, NULL },
  { (char*)"Ecaron",                            667, NULL },
  { (char*)"icircumflex",                       278, NULL },
  { (char*)"braceright",                        394, NULL },
  { (char*)"quotedblright",                     500, NULL },
  { (char*)"amacron",                           500, NULL },
  { (char*)"sacute",                            389, NULL },
  { (char*)"imacron",                           278, NULL },
  { (char*)"cent",                              500, NULL },
  { (char*)"currency",                          500, NULL },
  { (char*)"logicalnot",                        570, NULL },
  { (char*)"zdotaccent",                        444, NULL },
  { (char*)"Atilde",                            722, NULL },
  { (char*)"breve",                             333, NULL },
  { (char*)"bar",                               220, NULL },
  { (char*)"fraction",                          167, NULL },
  { (char*)"less",                              570, NULL },
  { (char*)"ecaron",                            444, NULL },
  { (char*)"guilsinglleft",                     333, NULL },
  { (char*)"exclam",                            333, NULL },
  { (char*)"period",                            250, NULL },
  { (char*)"Rcaron",                            722, NULL },
  { (char*)"Kcommaaccent",                      778, NULL },
  { (char*)"greater",                           570, NULL },
  { (char*)"atilde",                            500, NULL },
  { (char*)"brokenbar",                         220, NULL },
  { (char*)"quoteleft",                         333, NULL },
  { (char*)"Edotaccent",                        667, NULL },
  { (char*)"onesuperior",                       300, NULL }
};

static BuiltinFontWidth timesBoldItalicWidthsTab[] = {
  { (char*)"Ntilde",                            722, NULL },
  { (char*)"rcaron",                            389, NULL },
  { (char*)"kcommaaccent",                      500, NULL },
  { (char*)"Ncommaaccent",                      722, NULL },
  { (char*)"Zacute",                            611, NULL },
  { (char*)"comma",                             250, NULL },
  { (char*)"cedilla",                           333, NULL },
  { (char*)"plusminus",                         570, NULL },
  { (char*)"circumflex",                        333, NULL },
  { (char*)"dotaccent",                         333, NULL },
  { (char*)"edotaccent",                        444, NULL },
  { (char*)"asciitilde",                        570, NULL },
  { (char*)"colon",                             333, NULL },
  { (char*)"onehalf",                           750, NULL },
  { (char*)"dollar",                            500, NULL },
  { (char*)"Lcaron",                            611, NULL },
  { (char*)"ntilde",                            556, NULL },
  { (char*)"Aogonek",                           667, NULL },
  { (char*)"ncommaaccent",                      556, NULL },
  { (char*)"minus",                             606, NULL },
  { (char*)"Iogonek",                           389, NULL },
  { (char*)"zacute",                            389, NULL },
  { (char*)"yen",                               500, NULL },
  { (char*)"space",                             250, NULL },
  { (char*)"Omacron",                           722, NULL },
  { (char*)"questiondown",                      500, NULL },
  { (char*)"emdash",                           1000, NULL },
  { (char*)"Agrave",                            667, NULL },
  { (char*)"three",                             500, NULL },
  { (char*)"numbersign",                        500, NULL },
  { (char*)"lcaron",                            382, NULL },
  { (char*)"A",                                 667, NULL },
  { (char*)"B",                                 667, NULL },
  { (char*)"C",                                 667, NULL },
  { (char*)"aogonek",                           500, NULL },
  { (char*)"D",                                 722, NULL },
  { (char*)"E",                                 667, NULL },
  { (char*)"onequarter",                        750, NULL },
  { (char*)"F",                                 667, NULL },
  { (char*)"G",                                 722, NULL },
  { (char*)"H",                                 778, NULL },
  { (char*)"I",                                 389, NULL },
  { (char*)"J",                                 500, NULL },
  { (char*)"K",                                 667, NULL },
  { (char*)"iogonek",                           278, NULL },
  { (char*)"backslash",                         278, NULL },
  { (char*)"L",                                 611, NULL },
  { (char*)"periodcentered",                    250, NULL },
  { (char*)"M",                                 889, NULL },
  { (char*)"N",                                 722, NULL },
  { (char*)"omacron",                           500, NULL },
  { (char*)"Tcommaaccent",                      611, NULL },
  { (char*)"O",                                 722, NULL },
  { (char*)"P",                                 611, NULL },
  { (char*)"Q",                                 722, NULL },
  { (char*)"Uhungarumlaut",                     722, NULL },
  { (char*)"R",                                 667, NULL },
  { (char*)"Aacute",                            667, NULL },
  { (char*)"caron",                             333, NULL },
  { (char*)"S",                                 556, NULL },
  { (char*)"T",                                 611, NULL },
  { (char*)"U",                                 722, NULL },
  { (char*)"agrave",                            500, NULL },
  { (char*)"V",                                 667, NULL },
  { (char*)"W",                                 889, NULL },
  { (char*)"X",                                 667, NULL },
  { (char*)"question",                          500, NULL },
  { (char*)"equal",                             570, NULL },
  { (char*)"Y",                                 611, NULL },
  { (char*)"Z",                                 611, NULL },
  { (char*)"four",                              500, NULL },
  { (char*)"a",                                 500, NULL },
  { (char*)"Gcommaaccent",                      722, NULL },
  { (char*)"b",                                 500, NULL },
  { (char*)"c",                                 444, NULL },
  { (char*)"d",                                 500, NULL },
  { (char*)"e",                                 444, NULL },
  { (char*)"f",                                 333, NULL },
  { (char*)"g",                                 500, NULL },
  { (char*)"bullet",                            350, NULL },
  { (char*)"h",                                 556, NULL },
  { (char*)"i",                                 278, NULL },
  { (char*)"Oslash",                            722, NULL },
  { (char*)"dagger",                            500, NULL },
  { (char*)"j",                                 278, NULL },
  { (char*)"k",                                 500, NULL },
  { (char*)"l",                                 278, NULL },
  { (char*)"m",                                 778, NULL },
  { (char*)"n",                                 556, NULL },
  { (char*)"tcommaaccent",                      278, NULL },
  { (char*)"o",                                 500, NULL },
  { (char*)"ordfeminine",                       266, NULL },
  { (char*)"ring",                              333, NULL },
  { (char*)"p",                                 500, NULL },
  { (char*)"q",                                 500, NULL },
  { (char*)"uhungarumlaut",                     556, NULL },
  { (char*)"r",                                 389, NULL },
  { (char*)"twosuperior",                       300, NULL },
  { (char*)"aacute",                            500, NULL },
  { (char*)"s",                                 389, NULL },
  { (char*)"OE",                                944, NULL },
  { (char*)"t",                                 278, NULL },
  { (char*)"divide",                            570, NULL },
  { (char*)"u",                                 556, NULL },
  { (char*)"Ccaron",                            667, NULL },
  { (char*)"v",                                 444, NULL },
  { (char*)"w",                                 667, NULL },
  { (char*)"x",                                 500, NULL },
  { (char*)"y",                                 444, NULL },
  { (char*)"z",                                 389, NULL },
  { (char*)"Gbreve",                            722, NULL },
  { (char*)"commaaccent",                       250, NULL },
  { (char*)"hungarumlaut",                      333, NULL },
  { (char*)"Idotaccent",                        389, NULL },
  { (char*)"Nacute",                            722, NULL },
  { (char*)"quotedbl",                          555, NULL },
  { (char*)"gcommaaccent",                      500, NULL },
  { (char*)"mu",                                576, NULL },
  { (char*)"greaterequal",                      549, NULL },
  { (char*)"Scaron",                            556, NULL },
  { (char*)"Lslash",                            611, NULL },
  { (char*)"semicolon",                         333, NULL },
  { (char*)"oslash",                            500, NULL },
  { (char*)"lessequal",                         549, NULL },
  { (char*)"lozenge",                           494, NULL },
  { (char*)"parenright",                        333, NULL },
  { (char*)"ccaron",                            444, NULL },
  { (char*)"Ecircumflex",                       667, NULL },
  { (char*)"gbreve",                            500, NULL },
  { (char*)"trademark",                        1000, NULL },
  { (char*)"daggerdbl",                         500, NULL },
  { (char*)"nacute",                            556, NULL },
  { (char*)"macron",                            333, NULL },
  { (char*)"Otilde",                            722, NULL },
  { (char*)"Emacron",                           667, NULL },
  { (char*)"ellipsis",                         1000, NULL },
  { (char*)"scaron",                            389, NULL },
  { (char*)"AE",                                944, NULL },
  { (char*)"Ucircumflex",                       722, NULL },
  { (char*)"lslash",                            278, NULL },
  { (char*)"quotedblleft",                      500, NULL },
  { (char*)"guilsinglright",                    333, NULL },
  { (char*)"hyphen",                            333, NULL },
  { (char*)"quotesingle",                       278, NULL },
  { (char*)"eight",                             500, NULL },
  { (char*)"exclamdown",                        389, NULL },
  { (char*)"endash",                            500, NULL },
  { (char*)"oe",                                722, NULL },
  { (char*)"Abreve",                            667, NULL },
  { (char*)"Umacron",                           722, NULL },
  { (char*)"ecircumflex",                       444, NULL },
  { (char*)"Adieresis",                         667, NULL },
  { (char*)"copyright",                         747, NULL },
  { (char*)"Egrave",                            667, NULL },
  { (char*)"slash",                             278, NULL },
  { (char*)"Edieresis",                         667, NULL },
  { (char*)"otilde",                            500, NULL },
  { (char*)"Idieresis",                         389, NULL },
  { (char*)"parenleft",                         333, NULL },
  { (char*)"one",                               500, NULL },
  { (char*)"emacron",                           444, NULL },
  { (char*)"Odieresis",                         722, NULL },
  { (char*)"ucircumflex",                       556, NULL },
  { (char*)"bracketleft",                       333, NULL },
  { (char*)"Ugrave",                            722, NULL },
  { (char*)"quoteright",                        333, NULL },
  { (char*)"Udieresis",                         722, NULL },
  { (char*)"perthousand",                      1000, NULL },
  { (char*)"Ydieresis",                         611, NULL },
  { (char*)"umacron",                           556, NULL },
  { (char*)"abreve",                            500, NULL },
  { (char*)"Eacute",                            667, NULL },
  { (char*)"adieresis",                         500, NULL },
  { (char*)"egrave",                            444, NULL },
  { (char*)"edieresis",                         444, NULL },
  { (char*)"idieresis",                         278, NULL },
  { (char*)"Eth",                               722, NULL },
  { (char*)"ae",                                722, NULL },
  { (char*)"asterisk",                          500, NULL },
  { (char*)"odieresis",                         500, NULL },
  { (char*)"Uacute",                            722, NULL },
  { (char*)"ugrave",                            556, NULL },
  { (char*)"nine",                              500, NULL },
  { (char*)"five",                              500, NULL },
  { (char*)"udieresis",                         556, NULL },
  { (char*)"Zcaron",                            611, NULL },
  { (char*)"Scommaaccent",                      556, NULL },
  { (char*)"threequarters",                     750, NULL },
  { (char*)"guillemotright",                    500, NULL },
  { (char*)"Ccedilla",                          667, NULL },
  { (char*)"ydieresis",                         444, NULL },
  { (char*)"tilde",                             333, NULL },
  { (char*)"at",                                832, NULL },
  { (char*)"eacute",                            444, NULL },
  { (char*)"underscore",                        500, NULL },
  { (char*)"Euro",                              500, NULL },
  { (char*)"Dcroat",                            722, NULL },
  { (char*)"multiply",                          570, NULL },
  { (char*)"zero",                              500, NULL },
  { (char*)"eth",                               500, NULL },
  { (char*)"Scedilla",                          556, NULL },
  { (char*)"Ograve",                            722, NULL },
  { (char*)"Racute",                            667, NULL },
  { (char*)"partialdiff",                       494, NULL },
  { (char*)"uacute",                            556, NULL },
  { (char*)"braceleft",                         348, NULL },
  { (char*)"Thorn",                             611, NULL },
  { (char*)"zcaron",                            389, NULL },
  { (char*)"scommaaccent",                      389, NULL },
  { (char*)"ccedilla",                          444, NULL },
  { (char*)"Dcaron",                            722, NULL },
  { (char*)"dcroat",                            500, NULL },
  { (char*)"Ocircumflex",                       722, NULL },
  { (char*)"Oacute",                            722, NULL },
  { (char*)"scedilla",                          389, NULL },
  { (char*)"ogonek",                            333, NULL },
  { (char*)"ograve",                            500, NULL },
  { (char*)"racute",                            389, NULL },
  { (char*)"Tcaron",                            611, NULL },
  { (char*)"Eogonek",                           667, NULL },
  { (char*)"thorn",                             500, NULL },
  { (char*)"degree",                            400, NULL },
  { (char*)"registered",                        747, NULL },
  { (char*)"radical",                           549, NULL },
  { (char*)"Aring",                             667, NULL },
  { (char*)"percent",                           833, NULL },
  { (char*)"six",                               500, NULL },
  { (char*)"paragraph",                         500, NULL },
  { (char*)"dcaron",                            608, NULL },
  { (char*)"Uogonek",                           722, NULL },
  { (char*)"two",                               500, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            389, NULL },
  { (char*)"Lacute",                            611, NULL },
  { (char*)"ocircumflex",                       500, NULL },
  { (char*)"oacute",                            500, NULL },
  { (char*)"Uring",                             722, NULL },
  { (char*)"Lcommaaccent",                      611, NULL },
  { (char*)"tcaron",                            366, NULL },
  { (char*)"eogonek",                           444, NULL },
  { (char*)"Delta",                             612, NULL },
  { (char*)"Ohungarumlaut",                     722, NULL },
  { (char*)"asciicircum",                       570, NULL },
  { (char*)"aring",                             500, NULL },
  { (char*)"grave",                             333, NULL },
  { (char*)"uogonek",                           556, NULL },
  { (char*)"bracketright",                      333, NULL },
  { (char*)"Iacute",                            389, NULL },
  { (char*)"ampersand",                         778, NULL },
  { (char*)"igrave",                            278, NULL },
  { (char*)"lacute",                            278, NULL },
  { (char*)"Ncaron",                            722, NULL },
  { (char*)"plus",                              570, NULL },
  { (char*)"uring",                             556, NULL },
  { (char*)"quotesinglbase",                    333, NULL },
  { (char*)"lcommaaccent",                      278, NULL },
  { (char*)"Yacute",                            611, NULL },
  { (char*)"ohungarumlaut",                     500, NULL },
  { (char*)"threesuperior",                     300, NULL },
  { (char*)"acute",                             333, NULL },
  { (char*)"section",                           500, NULL },
  { (char*)"dieresis",                          333, NULL },
  { (char*)"iacute",                            278, NULL },
  { (char*)"quotedblbase",                      500, NULL },
  { (char*)"ncaron",                            556, NULL },
  { (char*)"florin",                            500, NULL },
  { (char*)"yacute",                            444, NULL },
  { (char*)"Rcommaaccent",                      667, NULL },
  { (char*)"fi",                                556, NULL },
  { (char*)"fl",                                556, NULL },
  { (char*)"Acircumflex",                       667, NULL },
  { (char*)"Cacute",                            667, NULL },
  { (char*)"Icircumflex",                       389, NULL },
  { (char*)"guillemotleft",                     500, NULL },
  { (char*)"germandbls",                        500, NULL },
  { (char*)"Amacron",                           667, NULL },
  { (char*)"seven",                             500, NULL },
  { (char*)"Sacute",                            556, NULL },
  { (char*)"ordmasculine",                      300, NULL },
  { (char*)"dotlessi",                          278, NULL },
  { (char*)"sterling",                          500, NULL },
  { (char*)"notequal",                          549, NULL },
  { (char*)"Imacron",                           389, NULL },
  { (char*)"rcommaaccent",                      389, NULL },
  { (char*)"Zdotaccent",                        611, NULL },
  { (char*)"acircumflex",                       500, NULL },
  { (char*)"cacute",                            444, NULL },
  { (char*)"Ecaron",                            667, NULL },
  { (char*)"icircumflex",                       278, NULL },
  { (char*)"braceright",                        348, NULL },
  { (char*)"quotedblright",                     500, NULL },
  { (char*)"amacron",                           500, NULL },
  { (char*)"sacute",                            389, NULL },
  { (char*)"imacron",                           278, NULL },
  { (char*)"cent",                              500, NULL },
  { (char*)"currency",                          500, NULL },
  { (char*)"logicalnot",                        606, NULL },
  { (char*)"zdotaccent",                        389, NULL },
  { (char*)"Atilde",                            667, NULL },
  { (char*)"breve",                             333, NULL },
  { (char*)"bar",                               220, NULL },
  { (char*)"fraction",                          167, NULL },
  { (char*)"less",                              570, NULL },
  { (char*)"ecaron",                            444, NULL },
  { (char*)"guilsinglleft",                     333, NULL },
  { (char*)"exclam",                            389, NULL },
  { (char*)"period",                            250, NULL },
  { (char*)"Rcaron",                            667, NULL },
  { (char*)"Kcommaaccent",                      667, NULL },
  { (char*)"greater",                           570, NULL },
  { (char*)"atilde",                            500, NULL },
  { (char*)"brokenbar",                         220, NULL },
  { (char*)"quoteleft",                         333, NULL },
  { (char*)"Edotaccent",                        667, NULL },
  { (char*)"onesuperior",                       300, NULL }
};

static BuiltinFontWidth timesItalicWidthsTab[] = {
  { (char*)"Ntilde",                            667, NULL },
  { (char*)"rcaron",                            389, NULL },
  { (char*)"kcommaaccent",                      444, NULL },
  { (char*)"Ncommaaccent",                      667, NULL },
  { (char*)"Zacute",                            556, NULL },
  { (char*)"comma",                             250, NULL },
  { (char*)"cedilla",                           333, NULL },
  { (char*)"plusminus",                         675, NULL },
  { (char*)"circumflex",                        333, NULL },
  { (char*)"dotaccent",                         333, NULL },
  { (char*)"edotaccent",                        444, NULL },
  { (char*)"asciitilde",                        541, NULL },
  { (char*)"colon",                             333, NULL },
  { (char*)"onehalf",                           750, NULL },
  { (char*)"dollar",                            500, NULL },
  { (char*)"Lcaron",                            611, NULL },
  { (char*)"ntilde",                            500, NULL },
  { (char*)"Aogonek",                           611, NULL },
  { (char*)"ncommaaccent",                      500, NULL },
  { (char*)"minus",                             675, NULL },
  { (char*)"Iogonek",                           333, NULL },
  { (char*)"zacute",                            389, NULL },
  { (char*)"yen",                               500, NULL },
  { (char*)"space",                             250, NULL },
  { (char*)"Omacron",                           722, NULL },
  { (char*)"questiondown",                      500, NULL },
  { (char*)"emdash",                            889, NULL },
  { (char*)"Agrave",                            611, NULL },
  { (char*)"three",                             500, NULL },
  { (char*)"numbersign",                        500, NULL },
  { (char*)"lcaron",                            300, NULL },
  { (char*)"A",                                 611, NULL },
  { (char*)"B",                                 611, NULL },
  { (char*)"C",                                 667, NULL },
  { (char*)"aogonek",                           500, NULL },
  { (char*)"D",                                 722, NULL },
  { (char*)"E",                                 611, NULL },
  { (char*)"onequarter",                        750, NULL },
  { (char*)"F",                                 611, NULL },
  { (char*)"G",                                 722, NULL },
  { (char*)"H",                                 722, NULL },
  { (char*)"I",                                 333, NULL },
  { (char*)"J",                                 444, NULL },
  { (char*)"K",                                 667, NULL },
  { (char*)"iogonek",                           278, NULL },
  { (char*)"backslash",                         278, NULL },
  { (char*)"L",                                 556, NULL },
  { (char*)"periodcentered",                    250, NULL },
  { (char*)"M",                                 833, NULL },
  { (char*)"N",                                 667, NULL },
  { (char*)"omacron",                           500, NULL },
  { (char*)"Tcommaaccent",                      556, NULL },
  { (char*)"O",                                 722, NULL },
  { (char*)"P",                                 611, NULL },
  { (char*)"Q",                                 722, NULL },
  { (char*)"Uhungarumlaut",                     722, NULL },
  { (char*)"R",                                 611, NULL },
  { (char*)"Aacute",                            611, NULL },
  { (char*)"caron",                             333, NULL },
  { (char*)"S",                                 500, NULL },
  { (char*)"T",                                 556, NULL },
  { (char*)"U",                                 722, NULL },
  { (char*)"agrave",                            500, NULL },
  { (char*)"V",                                 611, NULL },
  { (char*)"W",                                 833, NULL },
  { (char*)"X",                                 611, NULL },
  { (char*)"question",                          500, NULL },
  { (char*)"equal",                             675, NULL },
  { (char*)"Y",                                 556, NULL },
  { (char*)"Z",                                 556, NULL },
  { (char*)"four",                              500, NULL },
  { (char*)"a",                                 500, NULL },
  { (char*)"Gcommaaccent",                      722, NULL },
  { (char*)"b",                                 500, NULL },
  { (char*)"c",                                 444, NULL },
  { (char*)"d",                                 500, NULL },
  { (char*)"e",                                 444, NULL },
  { (char*)"f",                                 278, NULL },
  { (char*)"g",                                 500, NULL },
  { (char*)"bullet",                            350, NULL },
  { (char*)"h",                                 500, NULL },
  { (char*)"i",                                 278, NULL },
  { (char*)"Oslash",                            722, NULL },
  { (char*)"dagger",                            500, NULL },
  { (char*)"j",                                 278, NULL },
  { (char*)"k",                                 444, NULL },
  { (char*)"l",                                 278, NULL },
  { (char*)"m",                                 722, NULL },
  { (char*)"n",                                 500, NULL },
  { (char*)"tcommaaccent",                      278, NULL },
  { (char*)"o",                                 500, NULL },
  { (char*)"ordfeminine",                       276, NULL },
  { (char*)"ring",                              333, NULL },
  { (char*)"p",                                 500, NULL },
  { (char*)"q",                                 500, NULL },
  { (char*)"uhungarumlaut",                     500, NULL },
  { (char*)"r",                                 389, NULL },
  { (char*)"twosuperior",                       300, NULL },
  { (char*)"aacute",                            500, NULL },
  { (char*)"s",                                 389, NULL },
  { (char*)"OE",                                944, NULL },
  { (char*)"t",                                 278, NULL },
  { (char*)"divide",                            675, NULL },
  { (char*)"u",                                 500, NULL },
  { (char*)"Ccaron",                            667, NULL },
  { (char*)"v",                                 444, NULL },
  { (char*)"w",                                 667, NULL },
  { (char*)"x",                                 444, NULL },
  { (char*)"y",                                 444, NULL },
  { (char*)"z",                                 389, NULL },
  { (char*)"Gbreve",                            722, NULL },
  { (char*)"commaaccent",                       250, NULL },
  { (char*)"hungarumlaut",                      333, NULL },
  { (char*)"Idotaccent",                        333, NULL },
  { (char*)"Nacute",                            667, NULL },
  { (char*)"quotedbl",                          420, NULL },
  { (char*)"gcommaaccent",                      500, NULL },
  { (char*)"mu",                                500, NULL },
  { (char*)"greaterequal",                      549, NULL },
  { (char*)"Scaron",                            500, NULL },
  { (char*)"Lslash",                            556, NULL },
  { (char*)"semicolon",                         333, NULL },
  { (char*)"oslash",                            500, NULL },
  { (char*)"lessequal",                         549, NULL },
  { (char*)"lozenge",                           471, NULL },
  { (char*)"parenright",                        333, NULL },
  { (char*)"ccaron",                            444, NULL },
  { (char*)"Ecircumflex",                       611, NULL },
  { (char*)"gbreve",                            500, NULL },
  { (char*)"trademark",                         980, NULL },
  { (char*)"daggerdbl",                         500, NULL },
  { (char*)"nacute",                            500, NULL },
  { (char*)"macron",                            333, NULL },
  { (char*)"Otilde",                            722, NULL },
  { (char*)"Emacron",                           611, NULL },
  { (char*)"ellipsis",                          889, NULL },
  { (char*)"scaron",                            389, NULL },
  { (char*)"AE",                                889, NULL },
  { (char*)"Ucircumflex",                       722, NULL },
  { (char*)"lslash",                            278, NULL },
  { (char*)"quotedblleft",                      556, NULL },
  { (char*)"guilsinglright",                    333, NULL },
  { (char*)"hyphen",                            333, NULL },
  { (char*)"quotesingle",                       214, NULL },
  { (char*)"eight",                             500, NULL },
  { (char*)"exclamdown",                        389, NULL },
  { (char*)"endash",                            500, NULL },
  { (char*)"oe",                                667, NULL },
  { (char*)"Abreve",                            611, NULL },
  { (char*)"Umacron",                           722, NULL },
  { (char*)"ecircumflex",                       444, NULL },
  { (char*)"Adieresis",                         611, NULL },
  { (char*)"copyright",                         760, NULL },
  { (char*)"Egrave",                            611, NULL },
  { (char*)"slash",                             278, NULL },
  { (char*)"Edieresis",                         611, NULL },
  { (char*)"otilde",                            500, NULL },
  { (char*)"Idieresis",                         333, NULL },
  { (char*)"parenleft",                         333, NULL },
  { (char*)"one",                               500, NULL },
  { (char*)"emacron",                           444, NULL },
  { (char*)"Odieresis",                         722, NULL },
  { (char*)"ucircumflex",                       500, NULL },
  { (char*)"bracketleft",                       389, NULL },
  { (char*)"Ugrave",                            722, NULL },
  { (char*)"quoteright",                        333, NULL },
  { (char*)"Udieresis",                         722, NULL },
  { (char*)"perthousand",                      1000, NULL },
  { (char*)"Ydieresis",                         556, NULL },
  { (char*)"umacron",                           500, NULL },
  { (char*)"abreve",                            500, NULL },
  { (char*)"Eacute",                            611, NULL },
  { (char*)"adieresis",                         500, NULL },
  { (char*)"egrave",                            444, NULL },
  { (char*)"edieresis",                         444, NULL },
  { (char*)"idieresis",                         278, NULL },
  { (char*)"Eth",                               722, NULL },
  { (char*)"ae",                                667, NULL },
  { (char*)"asterisk",                          500, NULL },
  { (char*)"odieresis",                         500, NULL },
  { (char*)"Uacute",                            722, NULL },
  { (char*)"ugrave",                            500, NULL },
  { (char*)"nine",                              500, NULL },
  { (char*)"five",                              500, NULL },
  { (char*)"udieresis",                         500, NULL },
  { (char*)"Zcaron",                            556, NULL },
  { (char*)"Scommaaccent",                      500, NULL },
  { (char*)"threequarters",                     750, NULL },
  { (char*)"guillemotright",                    500, NULL },
  { (char*)"Ccedilla",                          667, NULL },
  { (char*)"ydieresis",                         444, NULL },
  { (char*)"tilde",                             333, NULL },
  { (char*)"at",                                920, NULL },
  { (char*)"eacute",                            444, NULL },
  { (char*)"underscore",                        500, NULL },
  { (char*)"Euro",                              500, NULL },
  { (char*)"Dcroat",                            722, NULL },
  { (char*)"multiply",                          675, NULL },
  { (char*)"zero",                              500, NULL },
  { (char*)"eth",                               500, NULL },
  { (char*)"Scedilla",                          500, NULL },
  { (char*)"Ograve",                            722, NULL },
  { (char*)"Racute",                            611, NULL },
  { (char*)"partialdiff",                       476, NULL },
  { (char*)"uacute",                            500, NULL },
  { (char*)"braceleft",                         400, NULL },
  { (char*)"Thorn",                             611, NULL },
  { (char*)"zcaron",                            389, NULL },
  { (char*)"scommaaccent",                      389, NULL },
  { (char*)"ccedilla",                          444, NULL },
  { (char*)"Dcaron",                            722, NULL },
  { (char*)"dcroat",                            500, NULL },
  { (char*)"Ocircumflex",                       722, NULL },
  { (char*)"Oacute",                            722, NULL },
  { (char*)"scedilla",                          389, NULL },
  { (char*)"ogonek",                            333, NULL },
  { (char*)"ograve",                            500, NULL },
  { (char*)"racute",                            389, NULL },
  { (char*)"Tcaron",                            556, NULL },
  { (char*)"Eogonek",                           611, NULL },
  { (char*)"thorn",                             500, NULL },
  { (char*)"degree",                            400, NULL },
  { (char*)"registered",                        760, NULL },
  { (char*)"radical",                           453, NULL },
  { (char*)"Aring",                             611, NULL },
  { (char*)"percent",                           833, NULL },
  { (char*)"six",                               500, NULL },
  { (char*)"paragraph",                         523, NULL },
  { (char*)"dcaron",                            544, NULL },
  { (char*)"Uogonek",                           722, NULL },
  { (char*)"two",                               500, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            333, NULL },
  { (char*)"Lacute",                            556, NULL },
  { (char*)"ocircumflex",                       500, NULL },
  { (char*)"oacute",                            500, NULL },
  { (char*)"Uring",                             722, NULL },
  { (char*)"Lcommaaccent",                      556, NULL },
  { (char*)"tcaron",                            300, NULL },
  { (char*)"eogonek",                           444, NULL },
  { (char*)"Delta",                             612, NULL },
  { (char*)"Ohungarumlaut",                     722, NULL },
  { (char*)"asciicircum",                       422, NULL },
  { (char*)"aring",                             500, NULL },
  { (char*)"grave",                             333, NULL },
  { (char*)"uogonek",                           500, NULL },
  { (char*)"bracketright",                      389, NULL },
  { (char*)"Iacute",                            333, NULL },
  { (char*)"ampersand",                         778, NULL },
  { (char*)"igrave",                            278, NULL },
  { (char*)"lacute",                            278, NULL },
  { (char*)"Ncaron",                            667, NULL },
  { (char*)"plus",                              675, NULL },
  { (char*)"uring",                             500, NULL },
  { (char*)"quotesinglbase",                    333, NULL },
  { (char*)"lcommaaccent",                      278, NULL },
  { (char*)"Yacute",                            556, NULL },
  { (char*)"ohungarumlaut",                     500, NULL },
  { (char*)"threesuperior",                     300, NULL },
  { (char*)"acute",                             333, NULL },
  { (char*)"section",                           500, NULL },
  { (char*)"dieresis",                          333, NULL },
  { (char*)"iacute",                            278, NULL },
  { (char*)"quotedblbase",                      556, NULL },
  { (char*)"ncaron",                            500, NULL },
  { (char*)"florin",                            500, NULL },
  { (char*)"yacute",                            444, NULL },
  { (char*)"Rcommaaccent",                      611, NULL },
  { (char*)"fi",                                500, NULL },
  { (char*)"fl",                                500, NULL },
  { (char*)"Acircumflex",                       611, NULL },
  { (char*)"Cacute",                            667, NULL },
  { (char*)"Icircumflex",                       333, NULL },
  { (char*)"guillemotleft",                     500, NULL },
  { (char*)"germandbls",                        500, NULL },
  { (char*)"Amacron",                           611, NULL },
  { (char*)"seven",                             500, NULL },
  { (char*)"Sacute",                            500, NULL },
  { (char*)"ordmasculine",                      310, NULL },
  { (char*)"dotlessi",                          278, NULL },
  { (char*)"sterling",                          500, NULL },
  { (char*)"notequal",                          549, NULL },
  { (char*)"Imacron",                           333, NULL },
  { (char*)"rcommaaccent",                      389, NULL },
  { (char*)"Zdotaccent",                        556, NULL },
  { (char*)"acircumflex",                       500, NULL },
  { (char*)"cacute",                            444, NULL },
  { (char*)"Ecaron",                            611, NULL },
  { (char*)"icircumflex",                       278, NULL },
  { (char*)"braceright",                        400, NULL },
  { (char*)"quotedblright",                     556, NULL },
  { (char*)"amacron",                           500, NULL },
  { (char*)"sacute",                            389, NULL },
  { (char*)"imacron",                           278, NULL },
  { (char*)"cent",                              500, NULL },
  { (char*)"currency",                          500, NULL },
  { (char*)"logicalnot",                        675, NULL },
  { (char*)"zdotaccent",                        389, NULL },
  { (char*)"Atilde",                            611, NULL },
  { (char*)"breve",                             333, NULL },
  { (char*)"bar",                               275, NULL },
  { (char*)"fraction",                          167, NULL },
  { (char*)"less",                              675, NULL },
  { (char*)"ecaron",                            444, NULL },
  { (char*)"guilsinglleft",                     333, NULL },
  { (char*)"exclam",                            333, NULL },
  { (char*)"period",                            250, NULL },
  { (char*)"Rcaron",                            611, NULL },
  { (char*)"Kcommaaccent",                      667, NULL },
  { (char*)"greater",                           675, NULL },
  { (char*)"atilde",                            500, NULL },
  { (char*)"brokenbar",                         275, NULL },
  { (char*)"quoteleft",                         333, NULL },
  { (char*)"Edotaccent",                        611, NULL },
  { (char*)"onesuperior",                       300, NULL }
};

static BuiltinFontWidth timesRomanWidthsTab[] = {
  { (char*)"Ntilde",                            722, NULL },
  { (char*)"rcaron",                            333, NULL },
  { (char*)"kcommaaccent",                      500, NULL },
  { (char*)"Ncommaaccent",                      722, NULL },
  { (char*)"Zacute",                            611, NULL },
  { (char*)"comma",                             250, NULL },
  { (char*)"cedilla",                           333, NULL },
  { (char*)"plusminus",                         564, NULL },
  { (char*)"circumflex",                        333, NULL },
  { (char*)"dotaccent",                         333, NULL },
  { (char*)"edotaccent",                        444, NULL },
  { (char*)"asciitilde",                        541, NULL },
  { (char*)"colon",                             278, NULL },
  { (char*)"onehalf",                           750, NULL },
  { (char*)"dollar",                            500, NULL },
  { (char*)"Lcaron",                            611, NULL },
  { (char*)"ntilde",                            500, NULL },
  { (char*)"Aogonek",                           722, NULL },
  { (char*)"ncommaaccent",                      500, NULL },
  { (char*)"minus",                             564, NULL },
  { (char*)"Iogonek",                           333, NULL },
  { (char*)"zacute",                            444, NULL },
  { (char*)"yen",                               500, NULL },
  { (char*)"space",                             250, NULL },
  { (char*)"Omacron",                           722, NULL },
  { (char*)"questiondown",                      444, NULL },
  { (char*)"emdash",                           1000, NULL },
  { (char*)"Agrave",                            722, NULL },
  { (char*)"three",                             500, NULL },
  { (char*)"numbersign",                        500, NULL },
  { (char*)"lcaron",                            344, NULL },
  { (char*)"A",                                 722, NULL },
  { (char*)"B",                                 667, NULL },
  { (char*)"C",                                 667, NULL },
  { (char*)"aogonek",                           444, NULL },
  { (char*)"D",                                 722, NULL },
  { (char*)"E",                                 611, NULL },
  { (char*)"onequarter",                        750, NULL },
  { (char*)"F",                                 556, NULL },
  { (char*)"G",                                 722, NULL },
  { (char*)"H",                                 722, NULL },
  { (char*)"I",                                 333, NULL },
  { (char*)"J",                                 389, NULL },
  { (char*)"K",                                 722, NULL },
  { (char*)"iogonek",                           278, NULL },
  { (char*)"backslash",                         278, NULL },
  { (char*)"L",                                 611, NULL },
  { (char*)"periodcentered",                    250, NULL },
  { (char*)"M",                                 889, NULL },
  { (char*)"N",                                 722, NULL },
  { (char*)"omacron",                           500, NULL },
  { (char*)"Tcommaaccent",                      611, NULL },
  { (char*)"O",                                 722, NULL },
  { (char*)"P",                                 556, NULL },
  { (char*)"Q",                                 722, NULL },
  { (char*)"Uhungarumlaut",                     722, NULL },
  { (char*)"R",                                 667, NULL },
  { (char*)"Aacute",                            722, NULL },
  { (char*)"caron",                             333, NULL },
  { (char*)"S",                                 556, NULL },
  { (char*)"T",                                 611, NULL },
  { (char*)"U",                                 722, NULL },
  { (char*)"agrave",                            444, NULL },
  { (char*)"V",                                 722, NULL },
  { (char*)"W",                                 944, NULL },
  { (char*)"X",                                 722, NULL },
  { (char*)"question",                          444, NULL },
  { (char*)"equal",                             564, NULL },
  { (char*)"Y",                                 722, NULL },
  { (char*)"Z",                                 611, NULL },
  { (char*)"four",                              500, NULL },
  { (char*)"a",                                 444, NULL },
  { (char*)"Gcommaaccent",                      722, NULL },
  { (char*)"b",                                 500, NULL },
  { (char*)"c",                                 444, NULL },
  { (char*)"d",                                 500, NULL },
  { (char*)"e",                                 444, NULL },
  { (char*)"f",                                 333, NULL },
  { (char*)"g",                                 500, NULL },
  { (char*)"bullet",                            350, NULL },
  { (char*)"h",                                 500, NULL },
  { (char*)"i",                                 278, NULL },
  { (char*)"Oslash",                            722, NULL },
  { (char*)"dagger",                            500, NULL },
  { (char*)"j",                                 278, NULL },
  { (char*)"k",                                 500, NULL },
  { (char*)"l",                                 278, NULL },
  { (char*)"m",                                 778, NULL },
  { (char*)"n",                                 500, NULL },
  { (char*)"tcommaaccent",                      278, NULL },
  { (char*)"o",                                 500, NULL },
  { (char*)"ordfeminine",                       276, NULL },
  { (char*)"ring",                              333, NULL },
  { (char*)"p",                                 500, NULL },
  { (char*)"q",                                 500, NULL },
  { (char*)"uhungarumlaut",                     500, NULL },
  { (char*)"r",                                 333, NULL },
  { (char*)"twosuperior",                       300, NULL },
  { (char*)"aacute",                            444, NULL },
  { (char*)"s",                                 389, NULL },
  { (char*)"OE",                                889, NULL },
  { (char*)"t",                                 278, NULL },
  { (char*)"divide",                            564, NULL },
  { (char*)"u",                                 500, NULL },
  { (char*)"Ccaron",                            667, NULL },
  { (char*)"v",                                 500, NULL },
  { (char*)"w",                                 722, NULL },
  { (char*)"x",                                 500, NULL },
  { (char*)"y",                                 500, NULL },
  { (char*)"z",                                 444, NULL },
  { (char*)"Gbreve",                            722, NULL },
  { (char*)"commaaccent",                       250, NULL },
  { (char*)"hungarumlaut",                      333, NULL },
  { (char*)"Idotaccent",                        333, NULL },
  { (char*)"Nacute",                            722, NULL },
  { (char*)"quotedbl",                          408, NULL },
  { (char*)"gcommaaccent",                      500, NULL },
  { (char*)"mu",                                500, NULL },
  { (char*)"greaterequal",                      549, NULL },
  { (char*)"Scaron",                            556, NULL },
  { (char*)"Lslash",                            611, NULL },
  { (char*)"semicolon",                         278, NULL },
  { (char*)"oslash",                            500, NULL },
  { (char*)"lessequal",                         549, NULL },
  { (char*)"lozenge",                           471, NULL },
  { (char*)"parenright",                        333, NULL },
  { (char*)"ccaron",                            444, NULL },
  { (char*)"Ecircumflex",                       611, NULL },
  { (char*)"gbreve",                            500, NULL },
  { (char*)"trademark",                         980, NULL },
  { (char*)"daggerdbl",                         500, NULL },
  { (char*)"nacute",                            500, NULL },
  { (char*)"macron",                            333, NULL },
  { (char*)"Otilde",                            722, NULL },
  { (char*)"Emacron",                           611, NULL },
  { (char*)"ellipsis",                         1000, NULL },
  { (char*)"scaron",                            389, NULL },
  { (char*)"AE",                                889, NULL },
  { (char*)"Ucircumflex",                       722, NULL },
  { (char*)"lslash",                            278, NULL },
  { (char*)"quotedblleft",                      444, NULL },
  { (char*)"guilsinglright",                    333, NULL },
  { (char*)"hyphen",                            333, NULL },
  { (char*)"quotesingle",                       180, NULL },
  { (char*)"eight",                             500, NULL },
  { (char*)"exclamdown",                        333, NULL },
  { (char*)"endash",                            500, NULL },
  { (char*)"oe",                                722, NULL },
  { (char*)"Abreve",                            722, NULL },
  { (char*)"Umacron",                           722, NULL },
  { (char*)"ecircumflex",                       444, NULL },
  { (char*)"Adieresis",                         722, NULL },
  { (char*)"copyright",                         760, NULL },
  { (char*)"Egrave",                            611, NULL },
  { (char*)"slash",                             278, NULL },
  { (char*)"Edieresis",                         611, NULL },
  { (char*)"otilde",                            500, NULL },
  { (char*)"Idieresis",                         333, NULL },
  { (char*)"parenleft",                         333, NULL },
  { (char*)"one",                               500, NULL },
  { (char*)"emacron",                           444, NULL },
  { (char*)"Odieresis",                         722, NULL },
  { (char*)"ucircumflex",                       500, NULL },
  { (char*)"bracketleft",                       333, NULL },
  { (char*)"Ugrave",                            722, NULL },
  { (char*)"quoteright",                        333, NULL },
  { (char*)"Udieresis",                         722, NULL },
  { (char*)"perthousand",                      1000, NULL },
  { (char*)"Ydieresis",                         722, NULL },
  { (char*)"umacron",                           500, NULL },
  { (char*)"abreve",                            444, NULL },
  { (char*)"Eacute",                            611, NULL },
  { (char*)"adieresis",                         444, NULL },
  { (char*)"egrave",                            444, NULL },
  { (char*)"edieresis",                         444, NULL },
  { (char*)"idieresis",                         278, NULL },
  { (char*)"Eth",                               722, NULL },
  { (char*)"ae",                                667, NULL },
  { (char*)"asterisk",                          500, NULL },
  { (char*)"odieresis",                         500, NULL },
  { (char*)"Uacute",                            722, NULL },
  { (char*)"ugrave",                            500, NULL },
  { (char*)"nine",                              500, NULL },
  { (char*)"five",                              500, NULL },
  { (char*)"udieresis",                         500, NULL },
  { (char*)"Zcaron",                            611, NULL },
  { (char*)"Scommaaccent",                      556, NULL },
  { (char*)"threequarters",                     750, NULL },
  { (char*)"guillemotright",                    500, NULL },
  { (char*)"Ccedilla",                          667, NULL },
  { (char*)"ydieresis",                         500, NULL },
  { (char*)"tilde",                             333, NULL },
  { (char*)"at",                                921, NULL },
  { (char*)"eacute",                            444, NULL },
  { (char*)"underscore",                        500, NULL },
  { (char*)"Euro",                              500, NULL },
  { (char*)"Dcroat",                            722, NULL },
  { (char*)"multiply",                          564, NULL },
  { (char*)"zero",                              500, NULL },
  { (char*)"eth",                               500, NULL },
  { (char*)"Scedilla",                          556, NULL },
  { (char*)"Ograve",                            722, NULL },
  { (char*)"Racute",                            667, NULL },
  { (char*)"partialdiff",                       476, NULL },
  { (char*)"uacute",                            500, NULL },
  { (char*)"braceleft",                         480, NULL },
  { (char*)"Thorn",                             556, NULL },
  { (char*)"zcaron",                            444, NULL },
  { (char*)"scommaaccent",                      389, NULL },
  { (char*)"ccedilla",                          444, NULL },
  { (char*)"Dcaron",                            722, NULL },
  { (char*)"dcroat",                            500, NULL },
  { (char*)"Ocircumflex",                       722, NULL },
  { (char*)"Oacute",                            722, NULL },
  { (char*)"scedilla",                          389, NULL },
  { (char*)"ogonek",                            333, NULL },
  { (char*)"ograve",                            500, NULL },
  { (char*)"racute",                            333, NULL },
  { (char*)"Tcaron",                            611, NULL },
  { (char*)"Eogonek",                           611, NULL },
  { (char*)"thorn",                             500, NULL },
  { (char*)"degree",                            400, NULL },
  { (char*)"registered",                        760, NULL },
  { (char*)"radical",                           453, NULL },
  { (char*)"Aring",                             722, NULL },
  { (char*)"percent",                           833, NULL },
  { (char*)"six",                               500, NULL },
  { (char*)"paragraph",                         453, NULL },
  { (char*)"dcaron",                            588, NULL },
  { (char*)"Uogonek",                           722, NULL },
  { (char*)"two",                               500, NULL },
  { (char*)"summation",                         600, NULL },
  { (char*)"Igrave",                            333, NULL },
  { (char*)"Lacute",                            611, NULL },
  { (char*)"ocircumflex",                       500, NULL },
  { (char*)"oacute",                            500, NULL },
  { (char*)"Uring",                             722, NULL },
  { (char*)"Lcommaaccent",                      611, NULL },
  { (char*)"tcaron",                            326, NULL },
  { (char*)"eogonek",                           444, NULL },
  { (char*)"Delta",                             612, NULL },
  { (char*)"Ohungarumlaut",                     722, NULL },
  { (char*)"asciicircum",                       469, NULL },
  { (char*)"aring",                             444, NULL },
  { (char*)"grave",                             333, NULL },
  { (char*)"uogonek",                           500, NULL },
  { (char*)"bracketright",                      333, NULL },
  { (char*)"Iacute",                            333, NULL },
  { (char*)"ampersand",                         778, NULL },
  { (char*)"igrave",                            278, NULL },
  { (char*)"lacute",                            278, NULL },
  { (char*)"Ncaron",                            722, NULL },
  { (char*)"plus",                              564, NULL },
  { (char*)"uring",                             500, NULL },
  { (char*)"quotesinglbase",                    333, NULL },
  { (char*)"lcommaaccent",                      278, NULL },
  { (char*)"Yacute",                            722, NULL },
  { (char*)"ohungarumlaut",                     500, NULL },
  { (char*)"threesuperior",                     300, NULL },
  { (char*)"acute",                             333, NULL },
  { (char*)"section",                           500, NULL },
  { (char*)"dieresis",                          333, NULL },
  { (char*)"iacute",                            278, NULL },
  { (char*)"quotedblbase",                      444, NULL },
  { (char*)"ncaron",                            500, NULL },
  { (char*)"florin",                            500, NULL },
  { (char*)"yacute",                            500, NULL },
  { (char*)"Rcommaaccent",                      667, NULL },
  { (char*)"fi",                                556, NULL },
  { (char*)"fl",                                556, NULL },
  { (char*)"Acircumflex",                       722, NULL },
  { (char*)"Cacute",                            667, NULL },
  { (char*)"Icircumflex",                       333, NULL },
  { (char*)"guillemotleft",                     500, NULL },
  { (char*)"germandbls",                        500, NULL },
  { (char*)"Amacron",                           722, NULL },
  { (char*)"seven",                             500, NULL },
  { (char*)"Sacute",                            556, NULL },
  { (char*)"ordmasculine",                      310, NULL },
  { (char*)"dotlessi",                          278, NULL },
  { (char*)"sterling",                          500, NULL },
  { (char*)"notequal",                          549, NULL },
  { (char*)"Imacron",                           333, NULL },
  { (char*)"rcommaaccent",                      333, NULL },
  { (char*)"Zdotaccent",                        611, NULL },
  { (char*)"acircumflex",                       444, NULL },
  { (char*)"cacute",                            444, NULL },
  { (char*)"Ecaron",                            611, NULL },
  { (char*)"icircumflex",                       278, NULL },
  { (char*)"braceright",                        480, NULL },
  { (char*)"quotedblright",                     444, NULL },
  { (char*)"amacron",                           444, NULL },
  { (char*)"sacute",                            389, NULL },
  { (char*)"imacron",                           278, NULL },
  { (char*)"cent",                              500, NULL },
  { (char*)"currency",                          500, NULL },
  { (char*)"logicalnot",                        564, NULL },
  { (char*)"zdotaccent",                        444, NULL },
  { (char*)"Atilde",                            722, NULL },
  { (char*)"breve",                             333, NULL },
  { (char*)"bar",                               200, NULL },
  { (char*)"fraction",                          167, NULL },
  { (char*)"less",                              564, NULL },
  { (char*)"ecaron",                            444, NULL },
  { (char*)"guilsinglleft",                     333, NULL },
  { (char*)"exclam",                            333, NULL },
  { (char*)"period",                            250, NULL },
  { (char*)"Rcaron",                            667, NULL },
  { (char*)"Kcommaaccent",                      722, NULL },
  { (char*)"greater",                           564, NULL },
  { (char*)"atilde",                            444, NULL },
  { (char*)"brokenbar",                         200, NULL },
  { (char*)"quoteleft",                         333, NULL },
  { (char*)"Edotaccent",                        611, NULL },
  { (char*)"onesuperior",                       300, NULL }
};

static BuiltinFontWidth zapfDingbatsWidthsTab[] = {
  { (char*)"a81",                               438, NULL },
  { (char*)"a82",                               138, NULL },
  { (char*)"a83",                               277, NULL },
  { (char*)"a84",                               415, NULL },
  { (char*)"a85",                               509, NULL },
  { (char*)"a86",                               410, NULL },
  { (char*)"a87",                               234, NULL },
  { (char*)"a88",                               234, NULL },
  { (char*)"a89",                               390, NULL },
  { (char*)"a140",                              788, NULL },
  { (char*)"a141",                              788, NULL },
  { (char*)"a142",                              788, NULL },
  { (char*)"a143",                              788, NULL },
  { (char*)"a144",                              788, NULL },
  { (char*)"a145",                              788, NULL },
  { (char*)"a146",                              788, NULL },
  { (char*)"a147",                              788, NULL },
  { (char*)"a148",                              788, NULL },
  { (char*)"a149",                              788, NULL },
  { (char*)"a90",                               390, NULL },
  { (char*)"a91",                               276, NULL },
  { (char*)"a92",                               276, NULL },
  { (char*)"space",                             278, NULL },
  { (char*)"a93",                               317, NULL },
  { (char*)"a94",                               317, NULL },
  { (char*)"a95",                               334, NULL },
  { (char*)"a96",                               334, NULL },
  { (char*)"a97",                               392, NULL },
  { (char*)"a98",                               392, NULL },
  { (char*)"a99",                               668, NULL },
  { (char*)"a150",                              788, NULL },
  { (char*)"a151",                              788, NULL },
  { (char*)"a152",                              788, NULL },
  { (char*)"a153",                              788, NULL },
  { (char*)"a154",                              788, NULL },
  { (char*)"a155",                              788, NULL },
  { (char*)"a156",                              788, NULL },
  { (char*)"a157",                              788, NULL },
  { (char*)"a158",                              788, NULL },
  { (char*)"a159",                              788, NULL },
  { (char*)"a160",                              894, NULL },
  { (char*)"a161",                              838, NULL },
  { (char*)"a162",                              924, NULL },
  { (char*)"a163",                             1016, NULL },
  { (char*)"a164",                              458, NULL },
  { (char*)"a165",                              924, NULL },
  { (char*)"a166",                              918, NULL },
  { (char*)"a167",                              927, NULL },
  { (char*)"a168",                              928, NULL },
  { (char*)"a169",                              928, NULL },
  { (char*)"a170",                              834, NULL },
  { (char*)"a171",                              873, NULL },
  { (char*)"a172",                              828, NULL },
  { (char*)"a173",                              924, NULL },
  { (char*)"a174",                              917, NULL },
  { (char*)"a175",                              930, NULL },
  { (char*)"a176",                              931, NULL },
  { (char*)"a177",                              463, NULL },
  { (char*)"a178",                              883, NULL },
  { (char*)"a179",                              836, NULL },
  { (char*)"a180",                              867, NULL },
  { (char*)"a181",                              696, NULL },
  { (char*)"a182",                              874, NULL },
  { (char*)"a183",                              760, NULL },
  { (char*)"a184",                              946, NULL },
  { (char*)"a185",                              865, NULL },
  { (char*)"a186",                              967, NULL },
  { (char*)"a187",                              831, NULL },
  { (char*)"a188",                              873, NULL },
  { (char*)"a189",                              927, NULL },
  { (char*)"a1",                                974, NULL },
  { (char*)"a2",                                961, NULL },
  { (char*)"a3",                                980, NULL },
  { (char*)"a4",                                719, NULL },
  { (char*)"a5",                                789, NULL },
  { (char*)"a6",                                494, NULL },
  { (char*)"a7",                                552, NULL },
  { (char*)"a8",                                537, NULL },
  { (char*)"a9",                                577, NULL },
  { (char*)"a190",                              970, NULL },
  { (char*)"a191",                              918, NULL },
  { (char*)"a192",                              748, NULL },
  { (char*)"a193",                              836, NULL },
  { (char*)"a194",                              771, NULL },
  { (char*)"a195",                              888, NULL },
  { (char*)"a196",                              748, NULL },
  { (char*)"a197",                              771, NULL },
  { (char*)"a198",                              888, NULL },
  { (char*)"a199",                              867, NULL },
  { (char*)"a10",                               692, NULL },
  { (char*)"a11",                               960, NULL },
  { (char*)"a12",                               939, NULL },
  { (char*)"a13",                               549, NULL },
  { (char*)"a14",                               855, NULL },
  { (char*)"a15",                               911, NULL },
  { (char*)"a16",                               933, NULL },
  { (char*)"a17",                               945, NULL },
  { (char*)"a18",                               974, NULL },
  { (char*)"a19",                               755, NULL },
  { (char*)"a20",                               846, NULL },
  { (char*)"a21",                               762, NULL },
  { (char*)"a22",                               761, NULL },
  { (char*)"a23",                               571, NULL },
  { (char*)"a24",                               677, NULL },
  { (char*)"a25",                               763, NULL },
  { (char*)"a26",                               760, NULL },
  { (char*)"a27",                               759, NULL },
  { (char*)"a28",                               754, NULL },
  { (char*)"a29",                               786, NULL },
  { (char*)"a30",                               788, NULL },
  { (char*)"a31",                               788, NULL },
  { (char*)"a32",                               790, NULL },
  { (char*)"a33",                               793, NULL },
  { (char*)"a34",                               794, NULL },
  { (char*)"a35",                               816, NULL },
  { (char*)"a36",                               823, NULL },
  { (char*)"a37",                               789, NULL },
  { (char*)"a38",                               841, NULL },
  { (char*)"a39",                               823, NULL },
  { (char*)"a40",                               833, NULL },
  { (char*)"a41",                               816, NULL },
  { (char*)"a42",                               831, NULL },
  { (char*)"a43",                               923, NULL },
  { (char*)"a44",                               744, NULL },
  { (char*)"a45",                               723, NULL },
  { (char*)"a46",                               749, NULL },
  { (char*)"a47",                               790, NULL },
  { (char*)"a48",                               792, NULL },
  { (char*)"a49",                               695, NULL },
  { (char*)"a100",                              668, NULL },
  { (char*)"a101",                              732, NULL },
  { (char*)"a102",                              544, NULL },
  { (char*)"a103",                              544, NULL },
  { (char*)"a104",                              910, NULL },
  { (char*)"a105",                              911, NULL },
  { (char*)"a106",                              667, NULL },
  { (char*)"a107",                              760, NULL },
  { (char*)"a108",                              760, NULL },
  { (char*)"a109",                              626, NULL },
  { (char*)"a50",                               776, NULL },
  { (char*)"a51",                               768, NULL },
  { (char*)"a52",                               792, NULL },
  { (char*)"a53",                               759, NULL },
  { (char*)"a54",                               707, NULL },
  { (char*)"a55",                               708, NULL },
  { (char*)"a56",                               682, NULL },
  { (char*)"a57",                               701, NULL },
  { (char*)"a58",                               826, NULL },
  { (char*)"a59",                               815, NULL },
  { (char*)"a110",                              694, NULL },
  { (char*)"a111",                              595, NULL },
  { (char*)"a112",                              776, NULL },
  { (char*)"a117",                              690, NULL },
  { (char*)"a118",                              791, NULL },
  { (char*)"a119",                              790, NULL },
  { (char*)"a60",                               789, NULL },
  { (char*)"a61",                               789, NULL },
  { (char*)"a62",                               707, NULL },
  { (char*)"a63",                               687, NULL },
  { (char*)"a64",                               696, NULL },
  { (char*)"a65",                               689, NULL },
  { (char*)"a66",                               786, NULL },
  { (char*)"a67",                               787, NULL },
  { (char*)"a68",                               713, NULL },
  { (char*)"a69",                               791, NULL },
  { (char*)"a200",                              696, NULL },
  { (char*)"a201",                              874, NULL },
  { (char*)"a120",                              788, NULL },
  { (char*)"a121",                              788, NULL },
  { (char*)"a202",                              974, NULL },
  { (char*)"a122",                              788, NULL },
  { (char*)"a203",                              762, NULL },
  { (char*)"a123",                              788, NULL },
  { (char*)"a204",                              759, NULL },
  { (char*)"a124",                              788, NULL },
  { (char*)"a205",                              509, NULL },
  { (char*)"a125",                              788, NULL },
  { (char*)"a206",                              410, NULL },
  { (char*)"a126",                              788, NULL },
  { (char*)"a127",                              788, NULL },
  { (char*)"a128",                              788, NULL },
  { (char*)"a129",                              788, NULL },
  { (char*)"a70",                               785, NULL },
  { (char*)"a71",                               791, NULL },
  { (char*)"a72",                               873, NULL },
  { (char*)"a73",                               761, NULL },
  { (char*)"a74",                               762, NULL },
  { (char*)"a75",                               759, NULL },
  { (char*)"a76",                               892, NULL },
  { (char*)"a77",                               892, NULL },
  { (char*)"a78",                               788, NULL },
  { (char*)"a79",                               784, NULL },
  { (char*)"a130",                              788, NULL },
  { (char*)"a131",                              788, NULL },
  { (char*)"a132",                              788, NULL },
  { (char*)"a133",                              788, NULL },
  { (char*)"a134",                              788, NULL },
  { (char*)"a135",                              788, NULL },
  { (char*)"a136",                              788, NULL },
  { (char*)"a137",                              788, NULL },
  { (char*)"a138",                              788, NULL },
  { (char*)"a139",                              788, NULL }
};

BuiltinFont builtinFonts[] = {
  { (char*)"Courier",               standardEncoding,            629, -157, { -23, -250,  715,  805}, NULL },
  { (char*)"Courier-Bold",          standardEncoding,            629, -157, {-113, -250,  749,  801}, NULL },
  { (char*)"Courier-BoldOblique",   standardEncoding,            629, -157, { -57, -250,  869,  801}, NULL },
  { (char*)"Courier-Oblique",       standardEncoding,            629, -157, { -27, -250,  849,  805}, NULL },
  { (char*)"Helvetica",             standardEncoding,            718, -207, {-166, -225, 1000,  931}, NULL },
  { (char*)"Helvetica-Bold",        standardEncoding,            718, -207, {-170, -228, 1003,  962}, NULL },
  { (char*)"Helvetica-BoldOblique", standardEncoding,            718, -207, {-174, -228, 1114,  962}, NULL },
  { (char*)"Helvetica-Oblique",     standardEncoding,            718, -207, {-170, -225, 1116,  931}, NULL },
  { (char*)"Symbol",                symbolEncoding,             1010, -293, {-180, -293, 1090, 1010}, NULL },
  { (char*)"Times-Bold",            standardEncoding,            683, -217, {-168, -218, 1000,  935}, NULL },
  { (char*)"Times-BoldItalic",      standardEncoding,            683, -217, {-200, -218,  996,  921}, NULL },
  { (char*)"Times-Italic",          standardEncoding,            683, -217, {-169, -217, 1010,  883}, NULL },
  { (char*)"Times-Roman",           standardEncoding,            683, -217, {-168, -218, 1000,  898}, NULL },
  { (char*)"ZapfDingbats",          zapfDingbatsEncoding,        820, -143, {  -1, -143,  981,  820}, NULL }
};

BuiltinFont *builtinFontSubst[] = {
  &builtinFonts[0],
  &builtinFonts[3],
  &builtinFonts[1],
  &builtinFonts[2],
  &builtinFonts[4],
  &builtinFonts[7],
  &builtinFonts[5],
  &builtinFonts[6],
  &builtinFonts[12],
  &builtinFonts[11],
  &builtinFonts[9],
  &builtinFonts[10]
};

void initBuiltinFontTables() {
  builtinFonts[0].widths = new BuiltinFontWidths(courierWidthsTab, 315);
  builtinFonts[1].widths = new BuiltinFontWidths(courierBoldWidthsTab, 315);
  builtinFonts[2].widths = new BuiltinFontWidths(courierBoldObliqueWidthsTab, 315);
  builtinFonts[3].widths = new BuiltinFontWidths(courierObliqueWidthsTab, 315);
  builtinFonts[4].widths = new BuiltinFontWidths(helveticaWidthsTab, 315);
  builtinFonts[5].widths = new BuiltinFontWidths(helveticaBoldWidthsTab, 316);
  builtinFonts[6].widths = new BuiltinFontWidths(helveticaBoldObliqueWidthsTab, 315);
  builtinFonts[7].widths = new BuiltinFontWidths(helveticaObliqueWidthsTab, 315);
  builtinFonts[8].widths = new BuiltinFontWidths(symbolWidthsTab, 190);
  builtinFonts[9].widths = new BuiltinFontWidths(timesBoldWidthsTab, 315);
  builtinFonts[10].widths = new BuiltinFontWidths(timesBoldItalicWidthsTab, 315);
  builtinFonts[11].widths = new BuiltinFontWidths(timesItalicWidthsTab, 315);
  builtinFonts[12].widths = new BuiltinFontWidths(timesRomanWidthsTab, 315);
  builtinFonts[13].widths = new BuiltinFontWidths(zapfDingbatsWidthsTab, 202);
}

void freeBuiltinFontTables() {
  int i;

  for (i = 0; i < 14; ++i) {
    delete builtinFonts[i].widths;
  }
}
